

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */



#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"






#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"



#include "proto/bfd/bfd.h"



#include "proto/babel/babel.h"
#include "nest/iface.h"



#include "proto/bgp/bgp.h"



#include "proto/ospf/ospf.h"



#include "proto/pipe/pipe.h"



#include "proto/radv/radv.h"



#include "proto/rip/rip.h"
#include "nest/iface.h"



#include "proto/static/static.h"





#include "sysdep/unix/unix.h"
#include <stdio.h>



#include "sysdep/unix/krt.h"


static struct keyword keyword_list[] = {
{ "define", DEFINE, NULL },
{ "on", ON, NULL },
{ "off", OFF, NULL },
{ "yes", YES, NULL },
{ "no", NO, NULL },
{ "s", S, NULL },
{ "ms", MS, NULL },
{ "us", US, NULL },
{ "port", PORT, NULL },
{ "vpn", VPN, NULL },
{ "mpls", MPLS, NULL },
{ "from", FROM, NULL },
{ "flow4", FLOW4, NULL },
{ "flow6", FLOW6, NULL },
{ "dst", DST, NULL },
{ "src", SRC, NULL },
{ "proto", PROTO, NULL },
{ "next", NEXT, NULL },
{ "header", HEADER, NULL },
{ "dport", DPORT, NULL },
{ "sport", SPORT, NULL },
{ "icmp", ICMP, NULL },
{ "type", TYPE, NULL },
{ "code", CODE, NULL },
{ "tcp", TCP, NULL },
{ "flags", FLAGS, NULL },
{ "length", LENGTH, NULL },
{ "dscp", DSCP, NULL },
{ "dont_fragment", DONT_FRAGMENT, NULL },
{ "is_fragment", IS_FRAGMENT, NULL },
{ "first_fragment", FIRST_FRAGMENT, NULL },
{ "last_fragment", LAST_FRAGMENT, NULL },
{ "fragment", FRAGMENT, NULL },
{ "label", LABEL, NULL },
{ "offset", OFFSET, NULL },
{ "function", FUNCTION, NULL },
{ "print", PRINT, NULL },
{ "printn", PRINTN, NULL },
{ "unset", UNSET, NULL },
{ "return", RETURN, NULL },
{ "accept", ACCEPT, NULL },
{ "reject", REJECT, NULL },
{ "error", ERROR, NULL },
{ "quitbird", QUITBIRD, NULL },
{ "int", INT, NULL },
{ "bool", BOOL, NULL },
{ "ip", IP, NULL },
{ "prefix", PREFIX, NULL },
{ "rd", RD, NULL },
{ "pair", PAIR, NULL },
{ "quad", QUAD, NULL },
{ "ec", EC, NULL },
{ "lc", LC, NULL },
{ "set", SET, NULL },
{ "string", STRING, NULL },
{ "bgpmask", BGPMASK, NULL },
{ "bgppath", BGPPATH, NULL },
{ "clist", CLIST, NULL },
{ "eclist", ECLIST, NULL },
{ "lclist", LCLIST, NULL },
{ "if", IF, NULL },
{ "then", THEN, NULL },
{ "else", ELSE, NULL },
{ "case", CASE, NULL },
{ "true", TRUE, NULL },
{ "false", FALSE, NULL },
{ "rt", RT, NULL },
{ "ro", RO, NULL },
{ "unknown", UNKNOWN, NULL },
{ "generic", GENERIC, NULL },
{ "gw", GW, NULL },
{ "net", NET, NULL },
{ "mask", MASK, NULL },
{ "source", SOURCE, NULL },
{ "scope", SCOPE, NULL },
{ "dest", DEST, NULL },
{ "ifname", IFNAME, NULL },
{ "ifindex", IFINDEX, NULL },
{ "preference", PREFERENCE, NULL },
{ "roa_check", ROA_CHECK, NULL },
{ "asn", ASN, NULL },
{ "is_v4", IS_V4, NULL },
{ "is_v6", IS_V6, NULL },
{ "len", LEN, NULL },
{ "maxlen", MAXLEN, NULL },
{ "defined", DEFINED, NULL },
{ "add", ADD, NULL },
{ "delete", DELETE, NULL },
{ "contains", CONTAINS, NULL },
{ "reset", RESET, NULL },
{ "prepend", PREPEND, NULL },
{ "first", FIRST, NULL },
{ "last", LAST, NULL },
{ "last_nonaggregated", LAST_NONAGGREGATED, NULL },
{ "match", MATCH, NULL },
{ "empty", EMPTY, NULL },
{ "filter", FILTER, NULL },
{ "where", WHERE, NULL },
{ "eval", EVAL, NULL },
{ "bt_assert", BT_ASSERT, NULL },
{ "bt_test_suite", BT_TEST_SUITE, NULL },
{ "format", FORMAT, NULL },
{ "router", ROUTER, NULL },
{ "id", ID, NULL },
{ "protocol", PROTOCOL, NULL },
{ "template", TEMPLATE, NULL },
{ "disabled", DISABLED, NULL },
{ "debug", DEBUG, NULL },
{ "all", ALL, NULL },
{ "direct", DIRECT, NULL },
{ "interface", INTERFACE, NULL },
{ "import", IMPORT, NULL },
{ "export", EXPORT, NULL },
{ "none", NONE, NULL },
{ "vrf", VRF, NULL },
{ "table", TABLE, NULL },
{ "states", STATES, NULL },
{ "routes", ROUTES, NULL },
{ "filters", FILTERS, NULL },
{ "ipv4", IPV4, NULL },
{ "ipv6", IPV6, NULL },
{ "vpn4", VPN4, NULL },
{ "vpn6", VPN6, NULL },
{ "roa4", ROA4, NULL },
{ "roa6", ROA6, NULL },
{ "sadr", SADR, NULL },
{ "receive", RECEIVE, NULL },
{ "limit", LIMIT, NULL },
{ "action", ACTION, NULL },
{ "warn", WARN, NULL },
{ "block", BLOCK, NULL },
{ "restart", RESTART, NULL },
{ "disable", DISABLE, NULL },
{ "keep", KEEP, NULL },
{ "filtered", FILTERED, NULL },
{ "password", PASSWORD, NULL },
{ "passive", PASSIVE, NULL },
{ "to", TO, NULL },
{ "events", EVENTS, NULL },
{ "packets", PACKETS, NULL },
{ "protocols", PROTOCOLS, NULL },
{ "interfaces", INTERFACES, NULL },
{ "algorithm", ALGORITHM, NULL },
{ "keyed", KEYED, NULL },
{ "hmac", HMAC, NULL },
{ "md5", MD5, NULL },
{ "sha1", SHA1, NULL },
{ "sha256", SHA256, NULL },
{ "sha384", SHA384, NULL },
{ "sha512", SHA512, NULL },
{ "primary", PRIMARY, NULL },
{ "stats", STATS, NULL },
{ "count", COUNT, NULL },
{ "by", BY, NULL },
{ "for", FOR, NULL },
{ "commands", COMMANDS, NULL },
{ "preexport", PREEXPORT, NULL },
{ "noexport", NOEXPORT, NULL },
{ "generate", GENERATE, NULL },
{ "bgp", BGP, NULL },
{ "passwords", PASSWORDS, NULL },
{ "description", DESCRIPTION, NULL },
{ "sorted", SORTED, NULL },
{ "reload", RELOAD, NULL },
{ "in", IN, NULL },
{ "out", OUT, NULL },
{ "mrtdump", MRTDUMP, NULL },
{ "messages", MESSAGES, NULL },
{ "restrict", RESTRICT, NULL },
{ "memory", MEMORY, NULL },
{ "igp_metric", IGP_METRIC, NULL },
{ "class", CLASS, NULL },
{ "timeformat", TIMEFORMAT, NULL },
{ "iso", ISO, NULL },
{ "short", SHORT, NULL },
{ "long", LONG, NULL },
{ "route", ROUTE, NULL },
{ "base", BASE, NULL },
{ "log", LOG, NULL },
{ "graceful", GRACEFUL, NULL },
{ "wait", WAIT, NULL },
{ "max", MAX, NULL },
{ "flush", FLUSH, NULL },
{ "as", AS, NULL },
{ "ipv4_mc", IPV4_MC, NULL },
{ "ipv4_mpls", IPV4_MPLS, NULL },
{ "ipv6_mc", IPV6_MC, NULL },
{ "ipv6_mpls", IPV6_MPLS, NULL },
{ "ipv6_sadr", IPV6_SADR, NULL },
{ "vpn4_mc", VPN4_MC, NULL },
{ "vpn4_mpls", VPN4_MPLS, NULL },
{ "vpn6_mc", VPN6_MC, NULL },
{ "vpn6_mpls", VPN6_MPLS, NULL },
{ "pri", PRI, NULL },
{ "sec", SEC, NULL },
{ "RTS_DUMMY", -((T_ENUM_RTS<<16) | RTS_DUMMY), NULL },
{ "RTS_STATIC", -((T_ENUM_RTS<<16) | RTS_STATIC), NULL },
{ "RTS_INHERIT", -((T_ENUM_RTS<<16) | RTS_INHERIT), NULL },
{ "RTS_DEVICE", -((T_ENUM_RTS<<16) | RTS_DEVICE), NULL },
{ "RTS_STATIC_DEVICE", -((T_ENUM_RTS<<16) | RTS_STATIC_DEVICE), NULL },
{ "RTS_REDIRECT", -((T_ENUM_RTS<<16) | RTS_REDIRECT), NULL },
{ "RTS_RIP", -((T_ENUM_RTS<<16) | RTS_RIP), NULL },
{ "RTS_OSPF", -((T_ENUM_RTS<<16) | RTS_OSPF), NULL },
{ "RTS_OSPF_IA", -((T_ENUM_RTS<<16) | RTS_OSPF_IA), NULL },
{ "RTS_OSPF_EXT1", -((T_ENUM_RTS<<16) | RTS_OSPF_EXT1), NULL },
{ "RTS_OSPF_EXT2", -((T_ENUM_RTS<<16) | RTS_OSPF_EXT2), NULL },
{ "RTS_BGP", -((T_ENUM_RTS<<16) | RTS_BGP), NULL },
{ "RTS_PIPE", -((T_ENUM_RTS<<16) | RTS_PIPE), NULL },
{ "RTS_BABEL", -((T_ENUM_RTS<<16) | RTS_BABEL), NULL },
{ "SCOPE_HOST", -((T_ENUM_SCOPE<<16) | SCOPE_HOST), NULL },
{ "SCOPE_LINK", -((T_ENUM_SCOPE<<16) | SCOPE_LINK), NULL },
{ "SCOPE_SITE", -((T_ENUM_SCOPE<<16) | SCOPE_SITE), NULL },
{ "SCOPE_ORGANIZATION", -((T_ENUM_SCOPE<<16) | SCOPE_ORGANIZATION), NULL },
{ "SCOPE_UNIVERSE", -((T_ENUM_SCOPE<<16) | SCOPE_UNIVERSE), NULL },
{ "SCOPE_UNDEFINED", -((T_ENUM_SCOPE<<16) | SCOPE_UNDEFINED), NULL },
{ "RTD_UNICAST", -((T_ENUM_RTD<<16) | RTD_UNICAST), NULL },
{ "RTD_BLACKHOLE", -((T_ENUM_RTD<<16) | RTD_BLACKHOLE), NULL },
{ "RTD_UNREACHABLE", -((T_ENUM_RTD<<16) | RTD_UNREACHABLE), NULL },
{ "RTD_PROHIBIT", -((T_ENUM_RTD<<16) | RTD_PROHIBIT), NULL },
{ "ROA_UNKNOWN", -((T_ENUM_ROA<<16) | ROA_UNKNOWN), NULL },
{ "ROA_VALID", -((T_ENUM_ROA<<16) | ROA_VALID), NULL },
{ "ROA_INVALID", -((T_ENUM_ROA<<16) | ROA_INVALID), NULL },
{ "NET_IP4", -((T_ENUM_NETTYPE<<16) | NET_IP4), NULL },
{ "NET_IP6", -((T_ENUM_NETTYPE<<16) | NET_IP6), NULL },
{ "NET_VPN4", -((T_ENUM_NETTYPE<<16) | NET_VPN4), NULL },
{ "NET_VPN6", -((T_ENUM_NETTYPE<<16) | NET_VPN6), NULL },
{ "NET_ROA4", -((T_ENUM_NETTYPE<<16) | NET_ROA4), NULL },
{ "NET_ROA6", -((T_ENUM_NETTYPE<<16) | NET_ROA6), NULL },
{ "NET_FLOW4", -((T_ENUM_NETTYPE<<16) | NET_FLOW4), NULL },
{ "NET_FLOW6", -((T_ENUM_NETTYPE<<16) | NET_FLOW6), NULL },
{ "NET_IP6_SADR", -((T_ENUM_NETTYPE<<16) | NET_IP6_SADR), NULL },
{ "show", SHOW, NULL },
{ "status", STATUS, NULL },
{ "summary", SUMMARY, NULL },
{ "symbols", SYMBOLS, NULL },
{ "dump", DUMP, NULL },
{ "resources", RESOURCES, NULL },
{ "sockets", SOCKETS, NULL },
{ "neighbors", NEIGHBORS, NULL },
{ "attributes", ATTRIBUTES, NULL },
{ "echo", ECHO, NULL },
{ "enable", ENABLE, NULL },
{ "bfd", BFD, NULL },
{ "min", MIN, NULL },
{ "idle", IDLE, NULL },
{ "rx", RX, NULL },
{ "tx", TX, NULL },
{ "interval", INTERVAL, NULL },
{ "multiplier", MULTIPLIER, NULL },
{ "multihop", MULTIHOP, NULL },
{ "neighbor", NEIGHBOR, NULL },
{ "dev", DEV, NULL },
{ "local", LOCAL, NULL },
{ "authentication", AUTHENTICATION, NULL },
{ "simple", SIMPLE, NULL },
{ "meticulous", METICULOUS, NULL },
{ "sessions", SESSIONS, NULL },
{ "babel", BABEL, NULL },
{ "metric", METRIC, NULL },
{ "rxcost", RXCOST, NULL },
{ "hello", HELLO, NULL },
{ "update", UPDATE, NULL },
{ "wired", WIRED, NULL },
{ "wireless", WIRELESS, NULL },
{ "buffer", BUFFER, NULL },
{ "priority", PRIORITY, NULL },
{ "check", CHECK, NULL },
{ "link", LINK, NULL },
{ "hop", HOP, NULL },
{ "babel_metric", BABEL_METRIC, NULL },
{ "entries", ENTRIES, NULL },
{ "hold", HOLD, NULL },
{ "time", TIME, NULL },
{ "connect", CONNECT, NULL },
{ "retry", RETRY, NULL },
{ "keepalive", KEEPALIVE, NULL },
{ "startup", STARTUP, NULL },
{ "via", VIA, NULL },
{ "self", SELF, NULL },
{ "default", DEFAULT, NULL },
{ "path", PATH, NULL },
{ "start", START, NULL },
{ "delay", DELAY, NULL },
{ "forget", FORGET, NULL },
{ "after", AFTER, NULL },
{ "bgp_path", BGP_PATH, NULL },
{ "bgp_local_pref", BGP_LOCAL_PREF, NULL },
{ "bgp_med", BGP_MED, NULL },
{ "bgp_origin", BGP_ORIGIN, NULL },
{ "bgp_next_hop", BGP_NEXT_HOP, NULL },
{ "bgp_atomic_aggr", BGP_ATOMIC_AGGR, NULL },
{ "bgp_aggregator", BGP_AGGREGATOR, NULL },
{ "bgp_community", BGP_COMMUNITY, NULL },
{ "bgp_ext_community", BGP_EXT_COMMUNITY, NULL },
{ "bgp_large_community", BGP_LARGE_COMMUNITY, NULL },
{ "address", ADDRESS, NULL },
{ "rr", RR, NULL },
{ "rs", RS, NULL },
{ "client", CLIENT, NULL },
{ "cluster", CLUSTER, NULL },
{ "as4", AS4, NULL },
{ "advertise", ADVERTISE, NULL },
{ "capabilities", CAPABILITIES, NULL },
{ "prefer", PREFER, NULL },
{ "older", OLDER, NULL },
{ "missing", MISSING, NULL },
{ "lladdr", LLADDR, NULL },
{ "drop", DROP, NULL },
{ "ignore", IGNORE, NULL },
{ "refresh", REFRESH, NULL },
{ "interpret", INTERPRET, NULL },
{ "communities", COMMUNITIES, NULL },
{ "bgp_originator_id", BGP_ORIGINATOR_ID, NULL },
{ "bgp_cluster_list", BGP_CLUSTER_LIST, NULL },
{ "igp", IGP, NULL },
{ "gateway", GATEWAY, NULL },
{ "recursive", RECURSIVE, NULL },
{ "med", MED, NULL },
{ "ttl", TTL, NULL },
{ "security", SECURITY, NULL },
{ "deterministic", DETERMINISTIC, NULL },
{ "secondary", SECONDARY, NULL },
{ "allow", ALLOW, NULL },
{ "paths", PATHS, NULL },
{ "aware", AWARE, NULL },
{ "extended", EXTENDED, NULL },
{ "setkey", SETKEY, NULL },
{ "strict", STRICT, NULL },
{ "bind", BIND, NULL },
{ "confederation", CONFEDERATION, NULL },
{ "member", MEMBER, NULL },
{ "multicast", MULTICAST, NULL },
{ "cease", CEASE, NULL },
{ "hit", HIT, NULL },
{ "administrative", ADMINISTRATIVE, NULL },
{ "shutdown", SHUTDOWN, NULL },
{ "peer", PEER, NULL },
{ "configuration", CONFIGURATION, NULL },
{ "change", CHANGE, NULL },
{ "deconfigured", DECONFIGURED, NULL },
{ "connection", CONNECTION, NULL },
{ "rejected", REJECTED, NULL },
{ "collision", COLLISION, NULL },
{ "of", OF, NULL },
{ "ORIGIN_IGP", -((T_ENUM_BGP_ORIGIN<<16) | ORIGIN_IGP), NULL },
{ "ORIGIN_EGP", -((T_ENUM_BGP_ORIGIN<<16) | ORIGIN_EGP), NULL },
{ "ORIGIN_INCOMPLETE", -((T_ENUM_BGP_ORIGIN<<16) | ORIGIN_INCOMPLETE), NULL },
{ "ospf", OSPF, NULL },
{ "v2", V2, NULL },
{ "v3", V3, NULL },
{ "ospf_metric1", OSPF_METRIC1, NULL },
{ "ospf_metric2", OSPF_METRIC2, NULL },
{ "ospf_tag", OSPF_TAG, NULL },
{ "ospf_router_id", OSPF_ROUTER_ID, NULL },
{ "area", AREA, NULL },
{ "rfc1583compat", RFC1583COMPAT, NULL },
{ "stub", STUB, NULL },
{ "tick", TICK, NULL },
{ "cost", COST, NULL },
{ "cost2", COST2, NULL },
{ "retransmit", RETRANSMIT, NULL },
{ "transmit", TRANSMIT, NULL },
{ "dead", DEAD, NULL },
{ "broadcast", BROADCAST, NULL },
{ "bcast", BCAST, NULL },
{ "nonbroadcast", NONBROADCAST, NULL },
{ "nbma", NBMA, NULL },
{ "pointopoint", POINTOPOINT, NULL },
{ "ptp", PTP, NULL },
{ "pointomultipoint", POINTOMULTIPOINT, NULL },
{ "ptmp", PTMP, NULL },
{ "cryptographic", CRYPTOGRAPHIC, NULL },
{ "eligible", ELIGIBLE, NULL },
{ "poll", POLL, NULL },
{ "networks", NETWORKS, NULL },
{ "hidden", HIDDEN, NULL },
{ "virtual", VIRTUAL, NULL },
{ "only", ONLY, NULL },
{ "large", LARGE, NULL },
{ "normal", NORMAL, NULL },
{ "stubnet", STUBNET, NULL },
{ "tag", TAG, NULL },
{ "external", EXTERNAL, NULL },
{ "lsadb", LSADB, NULL },
{ "ecmp", ECMP, NULL },
{ "weight", WEIGHT, NULL },
{ "nssa", NSSA, NULL },
{ "translator", TRANSLATOR, NULL },
{ "stability", STABILITY, NULL },
{ "global", GLOBAL, NULL },
{ "lsid", LSID, NULL },
{ "instance", INSTANCE, NULL },
{ "real", REAL, NULL },
{ "netmask", NETMASK, NULL },
{ "merge", MERGE, NULL },
{ "lsa", LSA, NULL },
{ "suppression", SUPPRESSION, NULL },
{ "rfc5838", RFC5838, NULL },
{ "topology", TOPOLOGY, NULL },
{ "state", STATE, NULL },
{ "pipe", PIPE, NULL },
{ "radv", RADV, NULL },
{ "ra", RA, NULL },
{ "managed", MANAGED, NULL },
{ "other", OTHER, NULL },
{ "config", CONFIG, NULL },
{ "linger", LINGER, NULL },
{ "mtu", MTU, NULL },
{ "reachable", REACHABLE, NULL },
{ "retrans", RETRANS, NULL },
{ "timer", TIMER, NULL },
{ "current", CURRENT, NULL },
{ "valid", VALID, NULL },
{ "preferred", PREFERRED, NULL },
{ "mult", MULT, NULL },
{ "lifetime", LIFETIME, NULL },
{ "skip", SKIP, NULL },
{ "onlink", ONLINK, NULL },
{ "autonomous", AUTONOMOUS, NULL },
{ "rdnss", RDNSS, NULL },
{ "dnssl", DNSSL, NULL },
{ "ns", NS, NULL },
{ "domain", DOMAIN, NULL },
{ "trigger", TRIGGER, NULL },
{ "sensitive", SENSITIVE, NULL },
{ "low", LOW, NULL },
{ "medium", MEDIUM, NULL },
{ "high", HIGH, NULL },
{ "propagate", PROPAGATE, NULL },
{ "ra_preference", RA_PREFERENCE, NULL },
{ "ra_lifetime", RA_LIFETIME, NULL },
{ "RA_PREF_LOW", -((T_ENUM_RA_PREFERENCE<<16) | RA_PREF_LOW), NULL },
{ "RA_PREF_MEDIUM", -((T_ENUM_RA_PREFERENCE<<16) | RA_PREF_MEDIUM), NULL },
{ "RA_PREF_HIGH", -((T_ENUM_RA_PREFERENCE<<16) | RA_PREF_HIGH), NULL },
{ "rip", RIP, NULL },
{ "ng", NG, NULL },
{ "infinity", INFINITY, NULL },
{ "timeout", TIMEOUT, NULL },
{ "garbage", GARBAGE, NULL },
{ "mode", MODE, NULL },
{ "version", VERSION, NULL },
{ "split", SPLIT, NULL },
{ "horizon", HORIZON, NULL },
{ "poison", POISON, NULL },
{ "reverse", REVERSE, NULL },
{ "zero", ZERO, NULL },
{ "plaintext", PLAINTEXT, NULL },
{ "rip_metric", RIP_METRIC, NULL },
{ "rip_tag", RIP_TAG, NULL },
{ "static", STATIC, NULL },
{ "prohibit", PROHIBIT, NULL },
{ "blackhole", BLACKHOLE, NULL },
{ "unreachable", UNREACHABLE, NULL },
{ "kernel", KERNEL, NULL },
{ "krt_prefsrc", KRT_PREFSRC, NULL },
{ "krt_realm", KRT_REALM, NULL },
{ "krt_scope", KRT_SCOPE, NULL },
{ "krt_mtu", KRT_MTU, NULL },
{ "krt_window", KRT_WINDOW, NULL },
{ "krt_rtt", KRT_RTT, NULL },
{ "krt_rttvar", KRT_RTTVAR, NULL },
{ "krt_sstresh", KRT_SSTRESH, NULL },
{ "krt_cwnd", KRT_CWND, NULL },
{ "krt_advmss", KRT_ADVMSS, NULL },
{ "krt_reordering", KRT_REORDERING, NULL },
{ "krt_hoplimit", KRT_HOPLIMIT, NULL },
{ "krt_initcwnd", KRT_INITCWND, NULL },
{ "krt_rto_min", KRT_RTO_MIN, NULL },
{ "krt_initrwnd", KRT_INITRWND, NULL },
{ "krt_quickack", KRT_QUICKACK, NULL },
{ "krt_lock_mtu", KRT_LOCK_MTU, NULL },
{ "krt_lock_window", KRT_LOCK_WINDOW, NULL },
{ "krt_lock_rtt", KRT_LOCK_RTT, NULL },
{ "krt_lock_rttvar", KRT_LOCK_RTTVAR, NULL },
{ "krt_lock_sstresh", KRT_LOCK_SSTRESH, NULL },
{ "krt_lock_cwnd", KRT_LOCK_CWND, NULL },
{ "krt_lock_advmss", KRT_LOCK_ADVMSS, NULL },
{ "krt_lock_reordering", KRT_LOCK_REORDERING, NULL },
{ "krt_lock_hoplimit", KRT_LOCK_HOPLIMIT, NULL },
{ "krt_lock_rto_min", KRT_LOCK_RTO_MIN, NULL },
{ "krt_feature_ecn", KRT_FEATURE_ECN, NULL },
{ "krt_feature_allfrag", KRT_FEATURE_ALLFRAG, NULL },
{ "syslog", SYSLOG, NULL },
{ "trace", TRACE, NULL },
{ "info", INFO, NULL },
{ "remote", REMOTE, NULL },
{ "warning", WARNING, NULL },
{ "auth", AUTH, NULL },
{ "fatal", FATAL, NULL },
{ "bug", BUG, NULL },
{ "stderr", STDERR, NULL },
{ "soft", SOFT, NULL },
{ "name", NAME, NULL },
{ "confirm", CONFIRM, NULL },
{ "undo", UNDO, NULL },
{ "latency", LATENCY, NULL },
{ "watchdog", WATCHDOG, NULL },
{ "configure", CONFIGURE, NULL },
{ "down", DOWN, NULL },
{ "persist", PERSIST, NULL },
{ "scan", SCAN, NULL },
{ "learn", LEARN, NULL },
{ "device", DEVICE, NULL },
{ "krt_source", KRT_SOURCE, NULL },
{ "krt_metric", KRT_METRIC, NULL },
{ NULL, -1, NULL } };
