/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "obj/conf/cf-parse.y" /* yacc.c:339  */

/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


/* Headers from filter/config.Y */

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if ((val->type == T_IP) && ipa_is_ip4(val->val.ip)) {
      ipv4_used = 1; key = ipa_to_u32(val->val.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  for (struct f_path_mask *tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *i;
  i = f_new_inst(FI_ASSERT);
  i->a1.p = expr;

  if (end >= start)
  {
    i->a2.p = assert_copy_expr(start, end - start + 1);
  }
  else
  {
    /* this is a break of lexer buffer */
    i->a2.p = "???";
  }

  return i;
}

/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (EMPTY_LIST(this_proto->channels))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    log(L_WARN "Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst **this_srt_last_cmd;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");
}

/* Headers from sysdep/linux/netlink.Y */

/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}


#line 888 "obj/conf/cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_OBJ_CONF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_OBJ_CONF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    IP4 = 272,
    IP6 = 273,
    VPN_RD = 274,
    SYM = 275,
    TEXT = 276,
    PREFIX_DUMMY = 277,
    NMA = 278,
    DEFINE = 279,
    ON = 280,
    OFF = 281,
    YES = 282,
    NO = 283,
    S = 284,
    MS = 285,
    US = 286,
    PORT = 287,
    VPN = 288,
    MPLS = 289,
    FROM = 290,
    FLOW4 = 291,
    FLOW6 = 292,
    DST = 293,
    SRC = 294,
    PROTO = 295,
    NEXT = 296,
    HEADER = 297,
    DPORT = 298,
    SPORT = 299,
    ICMP = 300,
    TYPE = 301,
    CODE = 302,
    TCP = 303,
    FLAGS = 304,
    LENGTH = 305,
    DSCP = 306,
    DONT_FRAGMENT = 307,
    IS_FRAGMENT = 308,
    FIRST_FRAGMENT = 309,
    LAST_FRAGMENT = 310,
    FRAGMENT = 311,
    LABEL = 312,
    OFFSET = 313,
    FUNCTION = 314,
    PRINT = 315,
    PRINTN = 316,
    UNSET = 317,
    RETURN = 318,
    ACCEPT = 319,
    REJECT = 320,
    ERROR = 321,
    QUITBIRD = 322,
    INT = 323,
    BOOL = 324,
    IP = 325,
    PREFIX = 326,
    RD = 327,
    PAIR = 328,
    QUAD = 329,
    EC = 330,
    LC = 331,
    SET = 332,
    STRING = 333,
    BGPMASK = 334,
    BGPPATH = 335,
    CLIST = 336,
    ECLIST = 337,
    LCLIST = 338,
    IF = 339,
    THEN = 340,
    ELSE = 341,
    CASE = 342,
    TRUE = 343,
    FALSE = 344,
    RT = 345,
    RO = 346,
    UNKNOWN = 347,
    GENERIC = 348,
    GW = 349,
    NET = 350,
    MASK = 351,
    SOURCE = 352,
    SCOPE = 353,
    DEST = 354,
    IFNAME = 355,
    IFINDEX = 356,
    PREFERENCE = 357,
    ROA_CHECK = 358,
    ASN = 359,
    IS_V4 = 360,
    IS_V6 = 361,
    LEN = 362,
    MAXLEN = 363,
    DEFINED = 364,
    ADD = 365,
    DELETE = 366,
    CONTAINS = 367,
    RESET = 368,
    PREPEND = 369,
    FIRST = 370,
    LAST = 371,
    LAST_NONAGGREGATED = 372,
    MATCH = 373,
    EMPTY = 374,
    FILTER = 375,
    WHERE = 376,
    EVAL = 377,
    BT_ASSERT = 378,
    BT_TEST_SUITE = 379,
    FORMAT = 380,
    ROUTER = 381,
    ID = 382,
    PROTOCOL = 383,
    TEMPLATE = 384,
    DISABLED = 385,
    DEBUG = 386,
    ALL = 387,
    DIRECT = 388,
    INTERFACE = 389,
    IMPORT = 390,
    EXPORT = 391,
    NONE = 392,
    VRF = 393,
    TABLE = 394,
    STATES = 395,
    ROUTES = 396,
    FILTERS = 397,
    IPV4 = 398,
    IPV6 = 399,
    VPN4 = 400,
    VPN6 = 401,
    ROA4 = 402,
    ROA6 = 403,
    SADR = 404,
    RECEIVE = 405,
    LIMIT = 406,
    ACTION = 407,
    WARN = 408,
    BLOCK = 409,
    RESTART = 410,
    DISABLE = 411,
    KEEP = 412,
    FILTERED = 413,
    PASSWORD = 414,
    PASSIVE = 415,
    TO = 416,
    EVENTS = 417,
    PACKETS = 418,
    PROTOCOLS = 419,
    INTERFACES = 420,
    ALGORITHM = 421,
    KEYED = 422,
    HMAC = 423,
    MD5 = 424,
    SHA1 = 425,
    SHA256 = 426,
    SHA384 = 427,
    SHA512 = 428,
    PRIMARY = 429,
    STATS = 430,
    COUNT = 431,
    BY = 432,
    FOR = 433,
    COMMANDS = 434,
    PREEXPORT = 435,
    NOEXPORT = 436,
    GENERATE = 437,
    BGP = 438,
    PASSWORDS = 439,
    DESCRIPTION = 440,
    SORTED = 441,
    RELOAD = 442,
    IN = 443,
    OUT = 444,
    MRTDUMP = 445,
    MESSAGES = 446,
    RESTRICT = 447,
    MEMORY = 448,
    IGP_METRIC = 449,
    CLASS = 450,
    TIMEFORMAT = 451,
    ISO = 452,
    SHORT = 453,
    LONG = 454,
    ROUTE = 455,
    BASE = 456,
    LOG = 457,
    GRACEFUL = 458,
    WAIT = 459,
    MAX = 460,
    FLUSH = 461,
    AS = 462,
    IPV4_MC = 463,
    IPV4_MPLS = 464,
    IPV6_MC = 465,
    IPV6_MPLS = 466,
    IPV6_SADR = 467,
    VPN4_MC = 468,
    VPN4_MPLS = 469,
    VPN6_MC = 470,
    VPN6_MPLS = 471,
    PRI = 472,
    SEC = 473,
    SHOW = 474,
    STATUS = 475,
    SUMMARY = 476,
    SYMBOLS = 477,
    DUMP = 478,
    RESOURCES = 479,
    SOCKETS = 480,
    NEIGHBORS = 481,
    ATTRIBUTES = 482,
    ECHO = 483,
    ENABLE = 484,
    BFD = 485,
    MIN = 486,
    IDLE = 487,
    RX = 488,
    TX = 489,
    INTERVAL = 490,
    MULTIPLIER = 491,
    MULTIHOP = 492,
    NEIGHBOR = 493,
    DEV = 494,
    LOCAL = 495,
    AUTHENTICATION = 496,
    SIMPLE = 497,
    METICULOUS = 498,
    SESSIONS = 499,
    BABEL = 500,
    METRIC = 501,
    RXCOST = 502,
    HELLO = 503,
    UPDATE = 504,
    WIRED = 505,
    WIRELESS = 506,
    BUFFER = 507,
    PRIORITY = 508,
    CHECK = 509,
    LINK = 510,
    HOP = 511,
    BABEL_METRIC = 512,
    ENTRIES = 513,
    HOLD = 514,
    TIME = 515,
    CONNECT = 516,
    RETRY = 517,
    KEEPALIVE = 518,
    STARTUP = 519,
    VIA = 520,
    SELF = 521,
    DEFAULT = 522,
    PATH = 523,
    START = 524,
    DELAY = 525,
    FORGET = 526,
    AFTER = 527,
    BGP_PATH = 528,
    BGP_LOCAL_PREF = 529,
    BGP_MED = 530,
    BGP_ORIGIN = 531,
    BGP_NEXT_HOP = 532,
    BGP_ATOMIC_AGGR = 533,
    BGP_AGGREGATOR = 534,
    BGP_COMMUNITY = 535,
    BGP_EXT_COMMUNITY = 536,
    BGP_LARGE_COMMUNITY = 537,
    ADDRESS = 538,
    RR = 539,
    RS = 540,
    CLIENT = 541,
    CLUSTER = 542,
    AS4 = 543,
    ADVERTISE = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    PATHS = 566,
    AWARE = 567,
    EXTENDED = 568,
    SETKEY = 569,
    STRICT = 570,
    BIND = 571,
    CONFEDERATION = 572,
    MEMBER = 573,
    MULTICAST = 574,
    CEASE = 575,
    HIT = 576,
    ADMINISTRATIVE = 577,
    SHUTDOWN = 578,
    PEER = 579,
    CONFIGURATION = 580,
    CHANGE = 581,
    DECONFIGURED = 582,
    CONNECTION = 583,
    REJECTED = 584,
    COLLISION = 585,
    OF = 586,
    OSPF = 587,
    V2 = 588,
    V3 = 589,
    OSPF_METRIC1 = 590,
    OSPF_METRIC2 = 591,
    OSPF_TAG = 592,
    OSPF_ROUTER_ID = 593,
    AREA = 594,
    RFC1583COMPAT = 595,
    STUB = 596,
    TICK = 597,
    COST = 598,
    COST2 = 599,
    RETRANSMIT = 600,
    TRANSMIT = 601,
    DEAD = 602,
    BROADCAST = 603,
    BCAST = 604,
    NONBROADCAST = 605,
    NBMA = 606,
    POINTOPOINT = 607,
    PTP = 608,
    POINTOMULTIPOINT = 609,
    PTMP = 610,
    CRYPTOGRAPHIC = 611,
    ELIGIBLE = 612,
    POLL = 613,
    NETWORKS = 614,
    HIDDEN = 615,
    VIRTUAL = 616,
    ONLY = 617,
    LARGE = 618,
    NORMAL = 619,
    STUBNET = 620,
    TAG = 621,
    EXTERNAL = 622,
    LSADB = 623,
    ECMP = 624,
    WEIGHT = 625,
    NSSA = 626,
    TRANSLATOR = 627,
    STABILITY = 628,
    GLOBAL = 629,
    LSID = 630,
    INSTANCE = 631,
    REAL = 632,
    NETMASK = 633,
    MERGE = 634,
    LSA = 635,
    SUPPRESSION = 636,
    RFC5838 = 637,
    TOPOLOGY = 638,
    STATE = 639,
    PIPE = 640,
    RADV = 641,
    RA = 642,
    MANAGED = 643,
    OTHER = 644,
    CONFIG = 645,
    LINGER = 646,
    MTU = 647,
    REACHABLE = 648,
    RETRANS = 649,
    TIMER = 650,
    CURRENT = 651,
    VALID = 652,
    PREFERRED = 653,
    MULT = 654,
    LIFETIME = 655,
    SKIP = 656,
    ONLINK = 657,
    AUTONOMOUS = 658,
    RDNSS = 659,
    DNSSL = 660,
    NS = 661,
    DOMAIN = 662,
    TRIGGER = 663,
    SENSITIVE = 664,
    LOW = 665,
    MEDIUM = 666,
    HIGH = 667,
    PROPAGATE = 668,
    RA_PREFERENCE = 669,
    RA_LIFETIME = 670,
    RIP = 671,
    NG = 672,
    INFINITY = 673,
    TIMEOUT = 674,
    GARBAGE = 675,
    MODE = 676,
    VERSION = 677,
    SPLIT = 678,
    HORIZON = 679,
    POISON = 680,
    REVERSE = 681,
    ZERO = 682,
    PLAINTEXT = 683,
    RIP_METRIC = 684,
    RIP_TAG = 685,
    STATIC = 686,
    PROHIBIT = 687,
    BLACKHOLE = 688,
    UNREACHABLE = 689,
    KERNEL = 690,
    KRT_PREFSRC = 691,
    KRT_REALM = 692,
    KRT_SCOPE = 693,
    KRT_MTU = 694,
    KRT_WINDOW = 695,
    KRT_RTT = 696,
    KRT_RTTVAR = 697,
    KRT_SSTRESH = 698,
    KRT_CWND = 699,
    KRT_ADVMSS = 700,
    KRT_REORDERING = 701,
    KRT_HOPLIMIT = 702,
    KRT_INITCWND = 703,
    KRT_RTO_MIN = 704,
    KRT_INITRWND = 705,
    KRT_QUICKACK = 706,
    KRT_LOCK_MTU = 707,
    KRT_LOCK_WINDOW = 708,
    KRT_LOCK_RTT = 709,
    KRT_LOCK_RTTVAR = 710,
    KRT_LOCK_SSTRESH = 711,
    KRT_LOCK_CWND = 712,
    KRT_LOCK_ADVMSS = 713,
    KRT_LOCK_REORDERING = 714,
    KRT_LOCK_HOPLIMIT = 715,
    KRT_LOCK_RTO_MIN = 716,
    KRT_FEATURE_ECN = 717,
    KRT_FEATURE_ALLFRAG = 718,
    SYSLOG = 719,
    TRACE = 720,
    INFO = 721,
    REMOTE = 722,
    WARNING = 723,
    AUTH = 724,
    FATAL = 725,
    BUG = 726,
    STDERR = 727,
    SOFT = 728,
    NAME = 729,
    CONFIRM = 730,
    UNDO = 731,
    LATENCY = 732,
    WATCHDOG = 733,
    CONFIGURE = 734,
    DOWN = 735,
    PERSIST = 736,
    SCAN = 737,
    LEARN = 738,
    DEVICE = 739,
    KRT_SOURCE = 740,
    KRT_METRIC = 741
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 817 "obj/conf/cf-parse.y" /* yacc.c:355  */

  uint i;
  u32 i32;
  u64 i64;
  ip_addr a;
  ip4_addr ip4;
  ip6_addr ip6;
  net_addr net;
  net_addr *net_ptr;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct channel_config *cc;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  void *g;
  btime time;
  struct f_prefix px;
  struct proto_spec ps;
  struct channel_limit cl;
  struct timeformat *tf;
  mpls_label_stack *mls;

#line 1450 "obj/conf/cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_OBJ_CONF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1467 "obj/conf/cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4213

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  508
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  377
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1261
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2284

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   741

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    33,     2,     2,     2,    32,     2,     2,
     499,   500,    30,    28,   501,    29,    34,    31,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   504,   498,
      24,    23,    25,   505,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   506,     2,   507,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   502,     2,   503,    26,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    27,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1051,  1051,  1052,  1055,  1057,  1065,  1074,  1075,  1076,
    1083,  1084,  1085,  1091,  1092,  1093,  1094,  1095,  1096,  1103,
    1104,  1105,  1112,  1113,  1120,  1126,  1136,  1149,  1168,  1174,
    1180,  1188,  1196,  1202,  1202,  1203,  1203,  1204,  1204,  1207,
    1208,  1209,  1210,  1211,  1212,  1219,  1220,  1228,  1229,  1237,
    1238,  1246,  1247,  1248,  1249,  1250,  1260,  1268,  1269,  1278,
    1286,  1287,  1294,  1295,  1304,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1315,  1316,  1320,  1321,  1322,  1323,  1324,  1325,
    1326,  1327,  1328,  1331,  1332,  1333,  1334,  1337,  1338,  1342,
    1346,  1350,  1351,  1355,  1359,  1368,  1369,  1373,  1377,  1381,
    1388,  1389,  1393,  1394,  1395,  1396,  1400,  1403,  1406,  1412,
    1416,  1417,  1418,  1422,  1426,  1432,  1433,  1434,  1435,  1438,
    1440,  1443,  1445,  1449,  1456,  1457,  1459,  1465,  1471,  1471,
    1477,  1477,  1487,  1491,  1505,  1506,  1507,  1508,  1509,  1510,
    1511,  1512,  1513,  1514,  1515,  1516,  1517,  1518,  1519,  1520,
    1542,  1553,  1554,  1561,  1562,  1569,  1578,  1582,  1586,  1607,
    1608,  1612,  1624,  1624,  1640,  1641,  1644,  1645,  1649,  1652,
    1661,  1662,  1675,  1676,  1677,  1678,  1682,  1690,  1691,  1692,
    1693,  1697,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1714,  1715,  1716,  1717,  1721,  1722,  1723,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1739,  1740,  1741,
    1742,  1743,  1747,  1748,  1749,  1750,  1751,  1755,  1756,  1760,
    1761,  1765,  1766,  1767,  1768,  1776,  1777,  1780,  1781,  1788,
    1800,  1801,  1805,  1809,  1810,  1811,  1812,  1813,  1814,  1818,
    1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1831,
    1832,  1833,  1834,  1844,  1848,  1870,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1894,  1895,  1896,  1897,  1898,
    1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,
    1909,  1910,  1912,  1913,  1914,  1916,  1918,  1920,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1942,
    1943,  1944,  1945,  1946,  1947,  1948,  1949,  1951,  1952,  1954,
    1959,  1981,  1982,  1983,  1984,  1985,  1986,  1990,  1993,  1994,
    1995,  2003,  2009,  2017,  2018,  2022,  2027,  2035,  2043,  2048,
    2052,  2058,  2062,  2067,  2068,  2069,  2075,  2076,  2077,  2078,
    2079,  2080,  2084,  2095,  2096,  2100,  2101,  2102,  2103,  2114,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2139,  2140,  2143,  2155,  2156,  2160,  2166,  2170,  2179,  2188,
    2190,  2191,  2192,  2193,  2194,  2195,  2199,  2205,  2210,  2211,
    2212,  2213,  2214,  2215,  2216,  2219,  2221,  2224,  2226,  2230,
    2237,  2241,  2248,  2249,  2250,  2251,  2255,  2256,  2257,  2258,
    2259,  2263,  2264,  2270,  2271,  2278,  2279,  2280,  2281,  2285,
    2286,  2287,  2288,  2289,  2290,  2291,  2292,  2296,  2303,  2311,
    2312,  2316,  2317,  2321,  2326,  2327,  2331,  2333,  2341,  2345,
    2346,  2352,  2359,  2360,  2361,  2362,  2363,  2367,  2375,  2381,
    2382,  2383,  2387,  2388,  2392,  2393,  2394,  2395,  2396,  2397,
    2403,  2404,  2405,  2409,  2410,  2414,  2415,  2421,  2422,  2425,
    2427,  2431,  2432,  2436,  2456,  2457,  2458,  2459,  2460,  2461,
    2462,  2463,  2464,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,  2476,  2477,  2483,  2486,  2489,  2492,  2496,  2497,  2500,
    2503,  2507,  2511,  2516,  2521,  2527,  2533,  2540,  2545,  2550,
    2554,  2558,  2562,  2572,  2583,  2592,  2596,  2603,  2607,  2608,
    2609,  2610,  2614,  2618,  2622,  2636,  2637,  2638,  2639,  2642,
    2643,  2644,  2649,  2650,  2651,  2652,  2653,  2654,  2655,  2656,
    2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,
    2667,  2668,  2672,  2676,  2679,  2680,  2681,  2682,  2683,  2684,
    2689,  2691,  2693,  2695,  2697,  2699,  2701,  2703,  2706,  2710,
    2716,  2717,  2718,  2722,  2723,  2729,  2731,  2733,  2735,  2737,
    2739,  2743,  2747,  2750,  2754,  2755,  2756,  2760,  2761,  2762,
    2770,  2782,  2783,  2784,  2785,  2788,  2790,  2794,  2798,  2812,
    2832,  2833,  2834,  2835,  2836,  2837,  2838,  2839,  2843,  2844,
    2845,  2846,  2847,  2848,  2851,  2853,  2856,  2858,  2862,  2865,
    2870,  2871,  2872,  2876,  2877,  2881,  2882,  2885,  2904,  2910,
    2918,  2919,  2920,  2923,  2925,  2929,  2933,  2947,  2972,  2973,
    2974,  2975,  2976,  2977,  2978,  2979,  2980,  2981,  2982,  2983,
    2984,  2985,  2986,  2989,  2991,  2994,  2996,  3001,  3006,  3009,
    3012,  3015,  3021,  3047,  3049,  3050,  3053,  3055,  3056,  3061,
    3062,  3066,  3067,  3071,  3072,  3073,  3074,  3075,  3076,  3077,
    3078,  3079,  3083,  3084,  3085,  3086,  3087,  3091,  3092,  3098,
    3099,  3100,  3101,  3102,  3103,  3104,  3105,  3106,  3107,  3108,
    3109,  3110,  3111,  3112,  3113,  3114,  3115,  3116,  3117,  3118,
    3119,  3120,  3121,  3122,  3123,  3124,  3125,  3126,  3127,  3128,
    3129,  3130,  3131,  3132,  3133,  3134,  3135,  3136,  3137,  3138,
    3139,  3140,  3141,  3142,  3146,  3147,  3148,  3149,  3150,  3151,
    3152,  3153,  3154,  3155,  3156,  3157,  3160,  3182,  3183,  3184,
    3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,  3194,
    3195,  3196,  3197,  3210,  3212,  3215,  3217,  3221,  3228,  3240,
    3241,  3242,  3245,  3259,  3260,  3264,  3265,  3269,  3279,  3282,
    3283,  3284,  3285,  3286,  3287,  3288,  3289,  3290,  3291,  3292,
    3295,  3310,  3313,  3315,  3319,  3320,  3321,  3322,  3323,  3324,
    3325,  3326,  3327,  3328,  3328,  3329,  3329,  3330,  3331,  3332,
    3336,  3337,  3341,  3349,  3351,  3355,  3356,  3357,  3361,  3362,
    3365,  3367,  3370,  3371,  3372,  3373,  3374,  3375,  3376,  3377,
    3378,  3379,  3380,  3383,  3402,  3403,  3404,  3405,  3406,  3407,
    3408,  3409,  3410,  3411,  3412,  3413,  3414,  3415,  3416,  3417,
    3418,  3419,  3420,  3421,  3422,  3423,  3424,  3425,  3426,  3427,
    3428,  3429,  3430,  3431,  3432,  3433,  3434,  3435,  3436,  3437,
    3438,  3439,  3442,  3444,  3447,  3449,  3457,  3459,  3460,  3463,
    3465,  3469,  3470,  3473,  3483,  3504,  3506,  3510,  3510,  3513,
    3515,  3518,  3520,  3524,  3529,  3532,  3535,  3540,  3543,  3548,
    3551,  3555,  3559,  3562,  3563,  3564,  3565,  3566,  3567,  3568,
    3569,  3576,  3575,  3590,  3591,  3592,  3593,  3599,  3610,  3611,
    3612,  3613,  3614,  3614,  3615,  3615,  3616,  3617,  3620,  3622,
    3626,  3630,  3653,  3654,  3655,  3656,  3657,  3658,  3659,  3660,
    3661,  3662,  3667,  3671,  3672,  3673,  3674,  3675,  3676,  3676,
    3677,  3677,  3678,  3679,  3683,  3684,  3685,  3688,  3726,  3728,
    3731,  3733,  3737,  3740,  3752,  3753,  3754,  3755,  3759,  3766,
    3774,  3776,  3779,  3781,  3785,  3789,  3799,  3804,  3805,  3806,
    3810,  3822,  3824,  3828,  3829,  3833,  3846,  3851,  3852,  3853,
    3857,  3869,  3871,  3875,  3876,  3881,  3882,  3886,  3887,  3895,
    3896,  3899,  3913,  3914,  3915,  3916,  3917,  3918,  3921,  3923,
    3927,  3931,  3955,  3985,  3986,  3987,  3988,  3989,  3990,  3991,
    3995,  3996,  3997,  3998,  3999,  4000,  4001,  4002,  4003,  4004,
    4005,  4006,  4007,  4008,  4009,  4010,  4011,  4012,  4016,  4017,
    4018,  4019,  4022,  4024,  4027,  4029,  4033,  4039,  4042,  4049,
    4056,  4057,  4058,  4059,  4060,  4068,  4072,  4077,  4082,  4085,
    4088,  4092,  4098,  4099,  4102,  4113,  4114,  4118,  4123,  4124,
    4125,  4126,  4127,  4128,  4132,  4135,  4137,  4140,  4142,  4146,
    4153,  4154,  4165,  4174,  4175,  4179,  4184,  4185,  4189,  4190,
    4194,  4195,  4199,  4200,  4201,  4202,  4203,  4204,  4205,  4206,
    4207,  4213,  4214,  4224,  4225,  4226,  4227,  4235,  4238,  4245,
    4248,  4251,  4254,  4258,  4259,  4263,  4264,  4265,  4273,  4280,
    4281,  4285,  4286,  4287,  4288,  4292,  4299,  4300,  4312,  4317,
    4318,  4319,  4326,  4333,  4336,  4338,  4341,  4343,  4347,  4355,
    4355,  4355,  4355,  4355,  4355,  4355,  4355,  4355,  4355,  4355,
    4355,  4355,  4355,  4355,  4356,  4356,  4357,  4357,  4358,  4359,
    4360,  4361,  4362,  4363,  4364,  4365,  4366,  4367,  4368,  4369,
    4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,
    4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,
    4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,  4369,
    4369,  4369,  4369,  4369,  4369,  4369,  4369,  4370,  4370,  4370,
    4370,  4370,  4370,  4370,  4370,  4370,  4370,  4370,  4371,  4371,
    4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,
    4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,
    4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,
    4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,  4371,
    4371,  4371,  4371,  4371,  4371,  4371,  4371,  4372,  4372,  4372,
    4373,  4373
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "IP4", "IP6", "VPN_RD", "SYM", "TEXT", "PREFIX_DUMMY", "'='",
  "'<'", "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'",
  "'.'", "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT",
  "VPN", "MPLS", "FROM", "FLOW4", "FLOW6", "DST", "SRC", "PROTO", "NEXT",
  "HEADER", "DPORT", "SPORT", "ICMP", "TYPE", "CODE", "TCP", "FLAGS",
  "LENGTH", "DSCP", "DONT_FRAGMENT", "IS_FRAGMENT", "FIRST_FRAGMENT",
  "LAST_FRAGMENT", "FRAGMENT", "LABEL", "OFFSET", "FUNCTION", "PRINT",
  "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT", "ERROR", "QUITBIRD",
  "INT", "BOOL", "IP", "PREFIX", "RD", "PAIR", "QUAD", "EC", "LC", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "LCLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "SOURCE", "SCOPE", "DEST", "IFNAME",
  "IFINDEX", "PREFERENCE", "ROA_CHECK", "ASN", "IS_V4", "IS_V6", "LEN",
  "MAXLEN", "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH", "EMPTY", "FILTER",
  "WHERE", "EVAL", "BT_ASSERT", "BT_TEST_SUITE", "FORMAT", "ROUTER", "ID",
  "PROTOCOL", "TEMPLATE", "DISABLED", "DEBUG", "ALL", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "NONE", "VRF", "TABLE", "STATES",
  "ROUTES", "FILTERS", "IPV4", "IPV6", "VPN4", "VPN6", "ROA4", "ROA6",
  "SADR", "RECEIVE", "LIMIT", "ACTION", "WARN", "BLOCK", "RESTART",
  "DISABLE", "KEEP", "FILTERED", "PASSWORD", "PASSIVE", "TO", "EVENTS",
  "PACKETS", "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC",
  "MD5", "SHA1", "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT",
  "BY", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "BGP",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "TIMEFORMAT",
  "ISO", "SHORT", "LONG", "ROUTE", "BASE", "LOG", "GRACEFUL", "WAIT",
  "MAX", "FLUSH", "AS", "IPV4_MC", "IPV4_MPLS", "IPV6_MC", "IPV6_MPLS",
  "IPV6_SADR", "VPN4_MC", "VPN4_MPLS", "VPN6_MC", "VPN6_MPLS", "PRI",
  "SEC", "SHOW", "STATUS", "SUMMARY", "SYMBOLS", "DUMP", "RESOURCES",
  "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "ENABLE", "BFD", "MIN",
  "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR",
  "DEV", "LOCAL", "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS",
  "BABEL", "METRIC", "RXCOST", "HELLO", "UPDATE", "WIRED", "WIRELESS",
  "BUFFER", "PRIORITY", "CHECK", "LINK", "HOP", "BABEL_METRIC", "ENTRIES",
  "HOLD", "TIME", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA",
  "SELF", "DEFAULT", "PATH", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "BGP_LARGE_COMMUNITY", "ADDRESS", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "CAPABILITIES", "PREFER",
  "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH", "INTERPRET",
  "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY",
  "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY",
  "ALLOW", "PATHS", "AWARE", "EXTENDED", "SETKEY", "STRICT", "BIND",
  "CONFEDERATION", "MEMBER", "MULTICAST", "CEASE", "HIT", "ADMINISTRATIVE",
  "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE", "DECONFIGURED",
  "CONNECTION", "REJECTED", "COLLISION", "OF", "OSPF", "V2", "V3",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "AREA",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT",
  "TRANSMIT", "DEAD", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "CRYPTOGRAPHIC",
  "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "MERGE", "LSA", "SUPPRESSION", "RFC5838", "TOPOLOGY", "STATE",
  "PIPE", "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU",
  "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT",
  "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS",
  "DOMAIN", "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "NG", "INFINITY", "TIMEOUT",
  "GARBAGE", "MODE", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE",
  "ZERO", "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT",
  "BLACKHOLE", "UNREACHABLE", "KERNEL", "KRT_PREFSRC", "KRT_REALM",
  "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW", "KRT_RTT", "KRT_RTTVAR",
  "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS", "KRT_REORDERING",
  "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN", "KRT_INITRWND",
  "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW", "KRT_LOCK_RTT",
  "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "SYSLOG",
  "TRACE", "INFO", "REMOTE", "WARNING", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "NAME", "CONFIRM", "UNDO", "LATENCY", "WATCHDOG", "CONFIGURE",
  "DOWN", "PERSIST", "SCAN", "LEARN", "DEVICE", "KRT_SOURCE", "KRT_METRIC",
  "';'", "'('", "')'", "','", "'{'", "'}'", "':'", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "pxlen4", "net_ip4_", "net_ip6_",
  "net_ip6_sadr_", "net_vpn4_", "net_vpn6_", "net_roa4_", "net_roa6_",
  "net_mpls_", "net_ip_", "net_vpn_", "net_roa_", "net_", "net_ip6",
  "net_ip", "net_any", "net_or_ipa", "label_stack_start", "label_stack",
  "time", "text", "opttext", "flow_num_op", "flow_logic_op",
  "flow_num_type_", "flow_num_type", "flow_flag_type", "flow_frag_type",
  "flow_label_type", "flow_srcdst", "flow_num_opts",
  "flow_num_opt_ext_expr", "flow_num_opt_ext", "flow_bmk_opts", "flow_neg",
  "flow_frag_val", "flow_frag_opts", "flow4_item", "flow6_item",
  "flow4_opts", "flow6_opts", "flow_builder_init", "flow_builder_set_ipv4",
  "flow_builder_set_ipv6", "net_flow4_", "net_flow6_", "net_flow_",
  "filter_def", "$@1", "filter_eval", "bt_test_suite", "type", "one_decl",
  "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "cnum",
  "pair_item", "ec_kind", "ec_item", "lc_item", "set_item", "switch_item",
  "set_items", "switch_items", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail", "constant", "constructor",
  "rtadot", "function_call", "symbol", "static_attr", "term",
  "break_command", "print_one", "print_list", "var_listn", "var_list",
  "cmd", "get_cf_position", "rtrid", "idval", "gr_opts", "net_type",
  "table_sorted", "table", "proto_start", "proto_name", "proto_item",
  "channel_start", "channel_item", "channel_opts", "channel_opt_list",
  "channel_end", "proto_channel", "rtable", "imexport", "limit_action",
  "limit_spec", "debug_default", "timeformat_which", "timeformat_spec",
  "timeformat_base", "iface_patt_node_init", "iface_patt_node_body",
  "iface_negate", "iface_patt_node", "iface_patt_list",
  "iface_patt_list_nopx", "iface_patt_init", "iface_patt", "tos",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "r_args_for",
  "r_args_for_val", "export_mode", "r_args_channel", "cmd_SHOW_SYMBOLS",
  "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item", "bfd_auth_type",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "cmd_SHOW_BABEL_ROUTES", "bgp_proto_start",
  "bgp_loc_opts", "bgp_nbr_opts", "bgp_cease_mask", "bgp_cease_list",
  "bgp_cease_flag", "bgp_proto", "bgp_afi", "bgp_channel_start",
  "bgp_channel_item", "bgp_channel_opts", "bgp_channel_opt_list",
  "bgp_channel_end", "bgp_proto_channel", "ospf_variant",
  "ospf_proto_start", "ospf_proto", "ospf_af_mc", "ospf_channel_start",
  "ospf_channel", "ospf_proto_item", "ospf_area_start", "ospf_area",
  "ospf_area_opts", "ospf_area_item", "$@3", "$@4", "ospf_stubnet",
  "ospf_stubnet_start", "ospf_stubnet_opts", "ospf_stubnet_item",
  "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "$@6", "pipe_proto",
  "radv_proto_start", "radv_proto_item", "$@7", "$@8", "radv_proto_opts",
  "radv_proto", "radv_iface_start", "radv_iface_item", "$@9", "$@10",
  "radv_preference", "radv_iface_finish", "radv_iface_opts",
  "radv_iface_opt_list", "radv_iface", "radv_prefix_start",
  "radv_prefix_item", "radv_prefix_finish", "radv_prefix_opts",
  "radv_prefix_opt_list", "radv_prefix", "radv_rdnss_node",
  "radv_rdnss_start", "radv_rdnss_item", "radv_rdnss_finish",
  "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node", "radv_dnssl_start",
  "radv_dnssl_item", "radv_dnssl_finish", "radv_dnssl_opts", "radv_dnssl",
  "radv_mult", "radv_sensitive", "rip_variant", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_nexthop", "stat_nexthops", "stat_route0", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "kern_sys_item", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kif_iface_start", "kif_iface_item", "kif_iface_opts",
  "kif_iface_opt_list", "kif_iface", "conf", "dynamic_attr", "proto",
  "cli_cmd", "kern_proto", "kif_proto", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    61,    60,    62,   126,   278,    43,    45,
      42,    47,    37,    33,    46,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,    59,    40,
      41,    44,   123,   125,    58,    63,    91,    93
};
# endif

#define YYPACT_NINF -1682

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1682)))

#define YYTABLE_NINF -324

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-324)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     269,  2204,   230,   327,  2403,   525,   525,   525,   758,   525,
     256,  1261,  1694,   112,   525,   299,   288, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,   384,
   -1682, -1682, -1682,   393,   405,  2403,  -174,   340, -1682, -1682,
     -86, -1682,   286, -1682, -1682, -1682, -1682,   190,   396,   109,
     367,   174, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
     404, -1682,  1683, -1682, -1682,   623,  3286,   623, -1682,   623,
   -1682,   623,  3422,   623,  3122,    86,  1125,   623, -1682,   623,
   -1682,   623,  3195, -1682, -1682, -1682,   623,   623, -1682, -1682,
    3145,  1748,    88, -1682, -1682,   593,   604,   729,    98, -1682,
     512,   108,  2403,   640,   158,   171, -1682, -1682, -1682,   177,
     208,   222,   261,   301,   311,   319,  1119,   172,   568,   613,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682,  2350, -1682,  3831,
   -1682, -1682, -1682,   131,   835,   835,   525,   525,   879,   147,
   -1682,   868,   179,   899, -1682,   903, -1682,   662,   994,    33,
      38,   908,   932,   943,   947,   950,   953,   967,   996,  1000,
   -1682, -1682,   564,   910,   835, -1682,   954,   954,  1015,  1044,
     636, -1682,  1054, -1682, -1682,  3952,  1067,    40,   131,   316,
     659, -1682, -1682, -1682,   147,   600, -1682, -1682, -1682, -1682,
     127,   618,   656, -1682, -1682,   -78,   895,   316,   316,  1101,
   -1682, -1682, -1682, -1682,   425, -1682, -1682,   725, -1682, -1682,
   -1682, -1682, -1682,  1117,  1176,   704,  1073,   804,   131, -1682,
     866,   866,   147,   981, -1682, -1682,   751,   749,   762,   766,
     771,   774,   776, -1682, -1682,   255,   974,   787,  1267,   135,
     150,   187,   196,  1018,   866,   804,  1143,   348,   804,     1,
    1239,  1239,  1051,  1020,    71,  1048,  1061,   674,  1079,  1043,
     697,  1047,   804,  1053,  1037,  1114,  1120,  1069,  1086,   291,
     804,  1080,   297, -1682,   916, -1682,   919,   920,   945,   298,
     804,  1333,   316,   804,  1346,  1103,   804, -1682,  1155, -1682,
     749, -1682,   988,   985, -1682, -1682,   316,  1122,   789,  1471,
    1331,  1348, -1682,  1005,  1006,  1003,  1007,  1011,  1435,  1241,
    1360, -1682,  1016,  1017,  1024,  1019,  1031,  1036,  1352,   316,
    1197,  1392,   804,  1272,   804, -1682, -1682, -1682,  1049,  1050,
   -1682,  1279, -1682, -1682,  1055,    44, -1682,    88,  2403,    88,
      88,  1538, -1682,  1542, -1682,  1547,   593,  1536, -1682, -1682,
    1375,  1548,   162,  1546,  1543, -1682, -1682, -1682,  1471,  2403,
    2403,  2403,  2403,  2403,  2403, -1682, -1682,  1570, -1682,  1094,
     116, -1682, -1682,  1536, -1682,   972, -1682, -1682,    78, -1682,
    1592, -1682, -1682, -1682, -1682,   280, -1682,   383,  1587,  1588,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682,  2403,  2403,  2403,  2403,  2403,
    2403,  2403,  2403,  2403,  2403,  2403,  2403,  2403,  2403,  2232,
   -1682, -1682,  1008,  1610, -1682,  1612,  1614,  1616,  1617, -1682,
   -1682, -1682,   417,  1619, -1682, -1682,  1063,  1624, -1682,  1627,
   -1682,  3805, -1682,  1209,   908,   908,   908,   908,   908, -1682,
     908,   908, -1682,   226,   443,  1628,   908,   908,  1629, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682,   336, -1682, -1682,  1630,
    1631,  1640,   636, -1682, -1682,   316,  1641,  2403,  1146,  3837,
    1145, -1682, -1682, -1682, -1682,  2403,  1149, -1682, -1682, -1682,
    2403, -1682, -1682, -1682, -1682, -1682,   316, -1682, -1682,  1150,
   -1682,   316,   881, -1682,   866, -1682, -1682,   564,  1151,   316,
    1115, -1682, -1682,  1454, -1682, -1682,   623, -1682,  1637, -1682,
   -1682,   298, -1682, -1682, -1682, -1682, -1682, -1682,   804, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682,  1387,  1390,  1239,
   -1682,  1165, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
     -63,  1166,  1178,   655,  1371,   804,  1478,  1184, -1682,  1185,
   -1682, -1682, -1682,  1653,    79,  1653,   202,   804,   316,  1415,
    1416,   316,  1419,   316,   316,   804,  1422,   804,  1554,   804,
    1196,   804,   804,   804,   804,   804,   804,  1477,   804,  1198,
     804,   804,  1199, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
     804, -1682,  1539,   316,   804, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682,  3810,  2403, -1682, -1682,   234,  1531, -1682, -1682,
     234, -1682, -1682, -1682,   234,  1471, -1682, -1682, -1682, -1682,
   -1682,   604,   729, -1682, -1682, -1682,   804,  1471, -1682, -1682,
   -1682,  1084, -1682,  1239, -1682, -1682, -1682,   349,  1430, -1682,
    1210, -1682, -1682,   804, -1682,   804,   316, -1682,   316, -1682,
   -1682, -1682, -1682, -1682,   316, -1682,  1692, -1682, -1682,  1355,
   -1682, -1682, -1682, -1682,  1663,  1696,   464, -1682,  1213, -1682,
    1585,  1688, -1682, -1682, -1682,   685,  1401,   727,   836,   869,
     998,  1736, -1682,  2403, -1682,  2403,  1219,    21,  1221,  1775,
   -1682, -1682,  1706,   184,   209, -1682,   729, -1682,  1505,  1506,
    3497,  3497,  3497,  3575,  3575,  3497,  3497,  3497,  3497,  3497,
    1030,  1030,  1543,  1543, -1682, -1682, -1682,  1228, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682,   371, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
     483, -1682, -1682,  1726, -1682, -1682, -1682,  3810,  1714, -1682,
   -1682,   451, -1682, -1682, -1682, -1682,   922, -1682, -1682, -1682,
   -1682,  1715, -1682, -1682, -1682, -1682, -1682, -1682, -1682,  1733,
     835,   835,   835,   835,   835,   835,  1907,   908,   835,   908,
     835, -1682,   835,   835, -1682,   564, -1682, -1682, -1682, -1682,
    1735, -1682, -1682,   330,  3713,  3837, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682,   233,  1242,  1237, -1682, -1682,   866, -1682,  1243,  1975,
   -1682,  2126, -1682, -1682,  1721,  1158,  1175, -1682,   612, -1682,
    1245, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,  1729,
   -1682,  1250,  1271,   707, -1682,  1699,  1157,   316,   316,  1273,
   -1682,   804,   625, -1682, -1682,   316,  1274,  1277,   804,  1281,
     804, -1682, -1682,  1756, -1682,   316,   316, -1682, -1682,   316,
     316, -1682,  1293,  1294,   316,   316,  1295,   316,  1296,  1297,
    1298,   316,  1312,   298,  1313, -1682,  1316,  1319,  1320,  1321,
    1327,  1328,   308,  1332, -1682,  1336,  1337, -1682,  3467, -1682,
   -1682,   316, -1682, -1682, -1682,   831, -1682, -1682, -1682,  3952,
   -1682,  1605, -1682,   804, -1682, -1682,  1339,  3171,  3262,  1340,
    1344, -1682,  1653,  1732,  1814,   804,   316,   804,   349,  1516,
   -1682, -1682,  1681, -1682, -1682,  1250,  1345, -1682,    88, -1682,
    1827, -1682,  2403, -1682,  1825,  1831, -1682, -1682, -1682,  2403,
   -1682,  2403,  2403,  2403,  2403, -1682,  1025,   275,  1553,  2403,
    2045,  2403, -1682,  1361, -1682, -1682,  2403, -1682, -1682, -1682,
    1846,  1848,  2403,  1008, -1682,   417, -1682, -1682, -1682, -1682,
   -1682, -1682,   593,   620,  1108, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682,  1832, -1682,  1862,  1875,  1881,  1883,  1891,
    1893, -1682, -1682,  1884,   298, -1682, -1682,   298, -1682,   298,
     835,  1895,   835,  1899,  1900,  1901, -1682, -1682, -1682, -1682,
    1408,  1420, -1682, -1682, -1682,  3837,  1564,  1423,  1250, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
    1887, -1682, -1682, -1682,  1418, -1682, -1682,  1239, -1682, -1682,
    1427, -1682, -1682, -1682, -1682,  1428,  1432,  1436, -1682,  1440,
     478, -1682,  1442,  1443, -1682, -1682,  1444, -1682,  1445, -1682,
     305, -1682, -1682,   338, -1682, -1682, -1682, -1682,  1448,  1455,
   -1682,  1456, -1682, -1682, -1682,  1457, -1682,  1458, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682,  1460, -1682, -1682, -1682,
    1652,  1599,  1762,  1654,  1810,   144,   804,  1909, -1682, -1682,
    1464, -1682, -1682,   804,   741,   224, -1682,  1697,  1275, -1682,
   -1682,   728, -1682,  1467, -1682,  1579,   964, -1682, -1682, -1682,
     714, -1682, -1682, -1682,   714,  1815, -1682, -1682, -1682,  1470,
   -1682,   804,   316, -1682, -1682, -1682,  1474, -1682, -1682, -1682,
    1814, -1682, -1682,  1938, -1682, -1682, -1682,    59, -1682, -1682,
    1475,  2403, -1682, -1682, -1682, -1682,  2403,  2403,  1950,  1476,
   -1682,  2350,  1479,  2083, -1682, -1682,   316, -1682, -1682, -1682,
   -1682,  1947, -1682,  1951, -1682,  1473,   912,  1164,  2272,  2549,
    2576,  2621,  2403, -1682,  2403,   742,    27,  3952,  1487,   780,
      24,  1489,  1976,  1775, -1682, -1682,  2648, -1682, -1682,  1977,
     593,  1536,  3784, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682,  1990, -1682,  1991, -1682, -1682, -1682,  3837,
   -1682, -1682,  1493,    99, -1682, -1682,  1287,  1421, -1682, -1682,
   -1682, -1682, -1682,  1495, -1682,   149, -1682, -1682, -1682, -1682,
   -1682,   316, -1682, -1682,  1845,  1666, -1682,    89,  1672,  1674,
     956,   648, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682,   362,   666,   804,   627,  1471,
   -1682, -1682, -1682,  1746, -1682, -1682, -1682, -1682,   316,   316,
     804,   316, -1682,  1512,   298, -1682, -1682, -1682, -1682,  1513,
    1515,   316, -1682, -1682,   316,  1518, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682,  1519, -1682, -1682, -1682,    93,    42, -1682,
     804, -1682, -1682, -1682,  1861, -1682, -1682,  1938,  2009,  2403,
    1375, -1682,   407,  3221,    67,  2403, -1682,  2002,   566, -1682,
    3952,  1527,  1532, -1682,   -77,  2017,  2004, -1682, -1682, -1682,
   -1682,  1981, -1682, -1682,  1270,  1979, -1682, -1682, -1682, -1682,
   -1682,   227,  2003,  2003,  1275,  1537, -1682, -1682,   227,  2003,
    2003,  2003,   714,  1544,  2403, -1682, -1682, -1682, -1682,  2697,
    2727, -1682,  2007,  2403, -1682,  2205, -1682,  2010,  2403,  2034,
    2243,  2365,  1540, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682,   593,  1536, -1682, -1682, -1682, -1682,  1495, -1682, -1682,
    2027,   866,  1798,  1549,  1552,  1723,  1818, -1682, -1682, -1682,
   -1682, -1682, -1682,   478, -1682, -1682, -1682,  1239, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682,   804,  1250,  1566, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682,  1567, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682,  1568,   316, -1682,  3070,  1571,  2564, -1682,  2434,
   -1682,  3099,  2403,  2403,  2403,  1220,  2083, -1682,  1239, -1682,
    1574, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682,  2069,   316,  1343, -1682,  1576,
   -1682,    61,   316,  1171,    69, -1682, -1682,  1343,    61,    69,
      61,  2020, -1682,  2754, -1682, -1682,  1591,  1594,   861,    31,
    1595,   905,  1598,  1606,    32,  1607,    36, -1682, -1682,  2370,
   -1682, -1682, -1682,  1239,  1857, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682,  1579, -1682, -1682,    82,   388,   103,  1249,
     960, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682,  1608,  1564,  2016, -1682,    52, -1682,  3952,  3126,  3153,
    1615,  1618,  1620,  1623,  1625, -1682, -1682, -1682,   316, -1682,
   -1682,   316,  1555,   316, -1682,  2003,  2003,  2084, -1682, -1682,
   -1682, -1682, -1682,  2003,  2003,  2107, -1682, -1682, -1682, -1682,
    2093,  2403, -1682, -1682, -1682,  2096,  2403, -1682,  2403,  2120,
   -1682,  2403, -1682, -1682,   866,   804,  1638,  1172,  1888,   316,
     316,   474, -1682, -1682, -1682,  1639,  1634, -1682,   804, -1682,
    1286, -1682, -1682,  3518, -1682, -1682, -1682,   538,   804,   316,
     804, -1682,  1644, -1682,   316,   198,   316,   316,  1858,   309,
   -1682, -1682,  1645,  1737,  1750,   804,   804,   804, -1682,  1648,
    3411, -1682,   501,  -154,  2944, -1682,  1649,  1659,  2434,   145,
   -1682, -1682,   972, -1682, -1682,  2156, -1682, -1682, -1682, -1682,
     418,  1664, -1682, -1682,  2403,  2403,  2403, -1682,  2403, -1682,
    1576,   316, -1682,   316,   316,   316,  1171,  1171, -1682,  1668,
    1669,  1671,  1673,  1675,  1678,  1679, -1682, -1682,  2015,  1926,
    1934,  1940, -1682, -1682, -1682,  1253, -1682,  2011, -1682,  1635,
   -1682, -1682,   316,  1920,  1181,   316,  1925,   649,   316,  1944,
    1945,  1927, -1682,  1700,  1722,   316,  1690,   804,  1931,   679,
     199,   316,   316,  1929,  1808,  1882,  1840,   804,   316,   316,
    1928,   351,  1817,   316,  1826,  1851, -1682, -1682,  1713, -1682,
     316,  1717, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682,   316,   316, -1682, -1682,   316,   316, -1682, -1682,
   -1682, -1682,   146,    66,  1819,   -76,  1809,  -100,   804,  1812,
    1956,  1822,  1949,  1978,  1980, -1682,  1734,   353,  1239, -1682,
    1739,   353,  2209, -1682,  1741,   316,   804,   804,  1982,   732,
     215,   316,  1969,   -38,  1239,  1924,  1863,  1972,  1983,   329,
     372,  1811,  1828, -1682, -1682,  1749, -1682, -1682, -1682, -1682,
    2857,   139,   278,   145,  1751,  2895,  2922,  2949,  3043, -1682,
    2217,  2224, -1682, -1682, -1682, -1682, -1682, -1682,  2403, -1682,
    2403, -1682,  1763,  1769,   316,   316,   316, -1682, -1682,  1269,
    2247,   221,   316,  2247,  1278,   231,  1766, -1682,  1304, -1682,
   -1682, -1682,   316,   316,   316,   316,   316, -1682, -1682,   316,
     316,   804, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682,   178,   316,   316, -1682, -1682, -1682,
   -1682, -1682, -1682,   804,  1878,   753,   804, -1682, -1682, -1682,
     316,   316, -1682,   804, -1682,   316,   804, -1682, -1682, -1682,
   -1682, -1682,  1854,  1854,  2006, -1682,   757,  2008,   316,  2032,
     316,  2039,   316,   757,   316, -1682,   804,   316,   316,  2124,
     804,    93,   804,    42, -1682,   316, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,   316,   316,
     316, -1682, -1682, -1682, -1682, -1682, -1682, -1682,   316,   804,
     804, -1682,  1042,   316,   316,   316, -1682, -1682,   804, -1682,
     804,   804, -1682, -1682,  2403, -1682, -1682, -1682, -1682,  1789,
    1796,  1813,  1816,   316,   316,  1807,  1820, -1682,  2015, -1682,
   -1682, -1682, -1682, -1682, -1682,  1824,  2247,  2247,  1830,  1833,
     832,  1217,  1834,  2247,  2247, -1682,  1239,  1239, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682,   115, -1682, -1682, -1682,
   -1682, -1682, -1682,   804,  1935, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682,   804, -1682, -1682,   316, -1682, -1682, -1682, -1682,
     316,  1854,   316, -1682,   316, -1682, -1682,  1854, -1682, -1682,
   -1682,   316, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682,  1936, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682,  2857, -1682, -1682, -1682, -1682, -1682, -1682, -1682,  2403,
   -1682,  1635,  1835,  1836,  1635,  1635, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682,  1635,  1837,  1842, -1682,
   -1682, -1682,  1942, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682,  1823, -1682,  1635,  1635, -1682,
   -1682, -1682,  1635,  1635, -1682,  1847,  2403, -1682, -1682, -1682,
   -1682, -1682,  1829, -1682
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,   253,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1103,     0,  1208,  1209,  1210,
    1211,  1212,  1213,  1214,  1215,  1216,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,     3,     1,     2,     0,
     359,   357,   358,     0,     0,   253,     0,     0,   363,   364,
       0,   350,   351,   353,   354,   355,   356,     0,     0,     0,
       0,     0,  1129,  1130,  1131,  1132,  1133,  1134,  1135,  1136,
       0,  1137,     0,  1139,  1140,   365,   369,   365,  1198,   365,
    1199,   365,   369,   365,   369,     0,   369,   365,  1203,   365,
    1204,   365,   369,  1141,  1142,  1143,   365,   365,     5,  1138,
     369,   369,   238,   239,   248,   170,   171,   244,   255,   242,
       0,     0,   253,     0,     0,     0,   240,   241,   285,     0,
       0,     0,     0,     0,     0,     0,   253,     0,    33,    34,
      43,    35,    36,    37,    38,    44,    39,    40,    41,   245,
     128,   129,    42,   243,   252,   283,   284,     0,   282,     0,
     574,   576,   575,     0,    63,    63,     0,     0,     0,     0,
     573,   578,     0,     0,   492,     0,   543,     0,     0,   488,
       0,   488,     0,     0,     0,     0,     0,     0,     0,     0,
     561,   560,     0,   563,    63,  1104,  1103,  1103,     0,     0,
    1105,  1102,     0,   162,   130,   132,     0,     0,     0,     0,
      18,   352,    61,    60,     0,     0,   406,   405,   407,   408,
       0,     0,  1074,  1077,  1075,     0,     0,     0,     0,     0,
     431,   652,   580,   619,   759,   901,   907,   989,  1039,  1108,
    1118,   762,   991,   366,     0,     0,     0,    18,     0,   437,
       0,     0,     0,     0,  1197,   376,     0,   387,     0,     0,
       0,     0,     0,   734,   735,     0,     0,     0,     0,   724,
     725,     0,     0,     0,     0,    18,     0,     0,    18,     0,
     656,   653,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,  1200,     0,   736,   755,     0,     0,     0,
      18,     0,     0,    18,     0,     0,    18,  1201,   765,   769,
     387,   770,     0,     0,   779,   903,     0,     0,     0,     0,
       0,     0,  1202,     0,     0,     0,     0,     0,     0,     0,
       0,  1205,     0,     0,  1058,  1067,     0,     0,     0,     0,
       0,     0,    18,     0,    18,  1206,  1111,  1112,     0,     0,
    1122,     0,  1207,  1119,     0,   238,   255,   238,   253,   238,
     238,     0,   230,     0,    25,     0,     0,     0,    28,    29,
     253,     0,     0,     0,   280,    32,   123,   123,     0,   253,
     253,   253,   253,   253,   253,   192,   193,     0,   195,     0,
       0,   172,   174,   171,   176,   253,    33,    34,   221,   173,
     210,   207,   208,   209,   217,     0,   225,     0,     0,     0,
    1144,   256,   259,   257,   258,   260,   261,   262,   263,   264,
    1145,  1146,  1148,  1151,  1150,  1147,  1149,  1152,  1153,  1154,
    1157,  1158,  1155,  1156,  1159,  1160,  1161,  1162,  1163,  1164,
    1165,  1166,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,   286,   287,   558,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,     0,
     440,   439,     0,     0,    62,     0,     0,     0,     0,   568,
     451,   450,     0,     0,   577,   579,   578,     0,   489,     0,
     484,     0,   483,     0,   488,   488,   488,   488,   488,   487,
     488,   488,   892,   488,   488,     0,   488,   488,     0,   556,
     552,   557,   553,   550,   551,   554,   555,  1087,  1082,  1083,
    1084,  1085,  1086,  1088,  1089,  1090,     0,  1080,   564,     0,
       0,     0,  1105,  1099,  1100,  1106,     0,   253,     0,   151,
       0,   345,   347,   348,   427,   253,     0,   403,     7,     9,
     253,   404,    14,    16,    15,    17,     0,    13,  1093,     0,
    1092,   409,     0,   417,     0,  1076,  1078,     0,     0,     0,
       0,  1096,  1095,   360,   760,   761,   365,   990,     0,   367,
     432,     0,   370,   371,   418,   375,   374,   372,    18,   433,
     385,   389,   434,   435,   585,   623,   672,     0,     0,     0,
     687,     0,   728,   726,   729,   727,   730,   732,   731,   733,
       0,     0,     0,    18,     0,    18,     0,     0,   688,     0,
      19,    20,    21,    22,     0,    22,     0,    18,     0,     0,
       0,     0,     0,     0,     0,    18,     0,    18,     0,    18,
       0,    18,    18,    18,    18,    18,    18,     0,    18,     0,
      18,    18,     0,   673,   753,   757,   674,   763,   780,   771,
      18,   777,   774,     0,    18,   772,   766,   767,   389,   764,
     782,   383,   151,   253,   394,   395,     0,     0,   393,   378,
       0,   379,   391,   377,     0,     0,   904,   905,   918,   998,
    1040,     0,     0,    50,    49,  1054,    18,     0,  1041,  1042,
    1060,     0,  1059,     0,  1063,  1061,  1062,  1052,  1055,  1065,
       0,  1258,  1260,    18,  1071,    18,     0,  1113,     0,  1115,
    1257,  1259,   418,  1120,     0,  1261,     0,   233,   235,     0,
     236,   237,   232,    24,    26,     0,   321,   324,     0,   299,
       0,     0,   300,   124,   125,     0,     0,     0,     0,     0,
       0,     0,   194,   253,   265,   253,     0,     0,     0,   181,
     222,   223,     0,     0,     0,   246,     0,   247,     0,     0,
     277,   275,   273,   270,   271,   272,   274,   276,   278,   279,
     266,   267,   268,   269,   289,   290,   291,     0,   294,   288,
     292,   293,   296,   297,   298,   444,   445,   446,   448,   449,
     447,     0,   442,   571,   567,   565,   569,   570,   455,   456,
       0,   453,   572,     0,   485,   490,   491,   151,     0,   499,
     520,     0,   501,   500,   505,   506,     0,   519,   521,   493,
     498,     0,   542,   549,   545,   546,   547,   548,   544,     0,
      63,    63,    63,    63,    63,    63,     0,   488,    63,   488,
      63,   884,    63,    63,  1069,     0,   562,   559,   566,  1101,
       0,  1107,  1097,     0,     0,   151,   134,   135,   136,   138,
     137,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,   131,   155,     0,   418,     0,     0,
     343,     0,  1094,  1091,     0,   411,   414,  1073,     0,  1072,
       0,    10,    11,    12,   361,   362,   902,   368,   373,   421,
     424,   438,     0,     0,   390,   369,   369,     0,     0,     0,
     679,    18,    18,   711,   713,     0,     0,     0,    18,     0,
      18,   723,   689,     0,   656,     0,     0,   677,   653,     0,
       0,   675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   710,     0,     0,     0,     0,
       0,     0,     0,     0,   712,     0,     0,   683,     0,   758,
     773,     0,   778,   776,   768,     0,   156,   157,   392,   158,
     402,   396,   381,    18,   382,   380,     0,   369,   369,     0,
       0,  1047,    22,  1056,     0,    18,     0,    18,  1053,   253,
    1045,  1116,  1109,  1070,  1114,   426,  1126,  1121,   238,   231,
       0,    26,   253,   310,     0,     0,   119,   121,   307,   253,
     281,   253,   253,   253,   253,   309,     0,     0,   253,   253,
     253,   253,   175,     0,   170,   171,   253,   211,   218,   226,
       0,     0,   253,     0,   441,     0,   452,   486,   497,   504,
     495,   496,   517,   518,     0,   514,   515,   516,   510,   508,
     509,   494,   507,   502,   618,     0,     0,     0,     0,     0,
       0,   891,   900,     0,     0,   895,   898,     0,   893,     0,
      63,     0,    63,     0,     0,     0,  1081,  1098,     6,   160,
     153,     0,   163,   150,   149,   151,   253,     0,   428,   344,
     346,     8,   410,   412,   413,   415,   416,  1079,   349,   422,
      63,   418,   436,   388,     0,   588,   588,     0,   587,   581,
       0,   626,   625,   620,   621,     0,     0,     0,   698,     0,
       0,   659,     0,     0,   719,   718,     0,   708,     0,    23,
       0,   657,   658,     0,   654,   655,   722,   685,     0,     0,
     702,     0,   697,   696,   691,     0,   681,     0,   682,   694,
     714,   693,   692,   721,   695,   715,     0,   717,   690,   684,
       0,     0,     0,     0,     0,     0,    18,     0,   756,   737,
       0,   775,   874,    18,     0,    18,   793,     0,     0,   795,
     785,    18,   781,     0,   799,   875,     0,   401,   384,   906,
       0,   921,   912,   914,     0,     0,   920,   908,   909,     0,
    1001,    18,     0,  1000,   992,   993,     0,  1043,  1044,  1046,
       0,    56,    57,  1048,  1051,  1050,  1049,     0,   315,   316,
       0,   253,   312,   313,   314,   311,   253,   253,     0,     0,
    1068,     0,     0,   253,  1064,  1066,     0,  1117,  1124,  1128,
     234,     0,   322,     0,   301,     0,     0,     0,     0,     0,
       0,     0,   253,   249,   253,     0,     0,   181,     0,     0,
       0,     0,     0,     0,    30,    31,     0,   443,   454,     0,
     511,   512,     0,   651,   648,   649,   650,   886,   885,   896,
     899,   894,   897,     0,   887,     0,   889,  1037,  1038,     0,
     159,   152,     0,   253,   166,   133,   419,     0,   423,   425,
     386,   418,   582,   606,   583,   610,   584,   586,   418,   622,
     624,     0,   703,   705,     0,     0,   663,     0,     0,     0,
       0,     0,   661,   706,   720,   707,   709,   678,   676,   701,
     700,   686,   699,   680,   716,     0,    18,    18,     0,     0,
     744,   745,   746,     0,   754,   418,   798,   786,     0,     0,
      18,     0,   784,     0,     0,    48,    47,   802,   797,   801,
       0,     0,   791,   783,     0,   809,   397,   398,   399,   400,
      46,    45,   953,   962,   911,   418,   910,     0,     0,   916,
      18,   919,   418,   997,   994,   996,   999,  1057,     0,   253,
     253,   253,     0,     0,     0,   253,   342,     0,     0,   334,
     317,   319,     0,  1110,     0,     0,     0,    76,    87,    88,
      74,     0,    77,    78,     0,     0,    81,    82,    85,   126,
      83,     0,   100,   100,     0,     0,    86,   127,     0,   100,
     100,   100,     0,     0,   253,   304,   305,   303,   306,     0,
       0,   190,     0,   253,   188,   253,   184,     0,   253,   182,
     253,   253,     0,   295,   513,   539,   537,   538,   522,   525,
     529,   532,   535,   536,   523,   524,   526,   527,   528,   530,
     531,   533,   534,   540,   541,   503,   888,   890,   154,   161,
     167,    53,    54,    55,    51,    52,   420,   606,   604,   589,
       0,     0,   613,   645,     0,     0,     0,   667,   665,   666,
     669,   668,   670,     0,   660,   740,   739,     0,   749,   750,
     751,   747,   741,   742,   743,   752,    18,   877,   881,   788,
     789,   787,   790,   862,   823,   803,   862,   792,   876,   810,
     960,   959,   950,   966,   965,   973,   913,   975,   976,   983,
     915,   917,  1034,     0,    58,     0,     0,     0,   328,   253,
     227,     0,   253,   253,   253,     0,   253,   333,     0,  1127,
       0,    27,   302,    75,    79,    80,    84,    70,    68,    66,
      65,    67,    69,    64,    71,    93,     0,   110,    95,    91,
     101,   111,     0,     0,   112,   109,   120,   115,   116,   117,
     118,   113,   122,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   589,     0,
     609,   611,   612,     0,   615,   643,   627,   704,   664,   671,
     662,   738,   748,   875,   879,   883,     0,     0,     0,   812,
       0,   964,   948,   947,   971,   981,  1032,  1002,   995,   327,
     254,     0,   253,   325,   168,     0,   331,   342,     0,     0,
       0,     0,     0,     0,     0,   320,  1123,  1125,     0,    89,
      73,    72,     0,     0,    72,   100,   100,     0,   102,   103,
     104,   105,   106,   100,   100,     0,   308,   205,   189,   187,
       0,   253,   185,   203,   183,     0,   253,   201,   253,   199,
     198,   253,   196,   608,     0,    18,     0,     0,     0,     0,
       0,     0,   607,   597,   458,   462,     0,   614,    18,   617,
     628,   647,   878,     0,   794,   865,   863,   866,    18,     0,
      18,   800,     0,   796,     0,     0,     0,     0,     0,     0,
     808,   822,     0,     0,     0,    18,    18,    18,   963,     0,
       0,   952,   967,   977,     0,  1036,     0,     0,   253,   253,
     177,   180,   253,   335,   179,   215,   212,   213,   214,   219,
       0,     0,   330,   329,   253,   253,   253,   336,   253,    94,
      92,     0,    96,     0,     0,     0,     0,     0,   114,     0,
       0,     0,     0,     0,     0,     0,   463,   595,   459,     0,
       0,     0,   590,   594,   598,     0,   599,     0,   596,   464,
     605,   616,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   646,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,   882,   861,     0,   867,
       0,     0,   806,   807,   805,   804,   816,   819,   820,   821,
     813,   814,     0,     0,   817,   811,     0,     0,   954,   955,
     956,   961,     0,     0,     0,     0,     0,     0,    18,     0,
       0,     0,     0,   938,   940,   951,     0,     0,     0,   970,
       0,     0,     0,   980,     0,     0,    18,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,  1027,     0,   332,   169,   326,   229,
     181,     0,     0,   253,     0,     0,     0,     0,     0,    90,
       0,     0,    97,   108,   107,   204,   186,   202,   253,   200,
     253,   197,     0,     0,     0,     0,     0,   600,   601,     0,
       0,     0,     0,     0,     0,     0,     0,   629,     0,   632,
     633,   631,     0,     0,     0,     0,     0,   638,   630,     0,
       0,    18,   644,   831,   832,   833,   834,   835,   836,   837,
     838,   828,   869,   860,     0,     0,     0,   855,   849,   850,
     851,   825,   842,    18,     0,    18,    18,   844,   824,   827,
       0,     0,   829,    18,   826,     0,    18,   880,   868,   864,
     815,   818,   987,   987,     0,   937,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   925,    18,     0,     0,     0,
      18,     0,    18,     0,   949,     0,   985,   969,   968,   974,
     972,   979,   978,   984,   982,  1008,  1006,  1025,     0,     0,
       0,  1020,  1028,  1031,  1030,  1029,  1026,  1003,     0,    18,
      18,  1007,    18,     0,     0,     0,  1004,  1005,    18,  1009,
      18,    18,  1033,   178,   253,   216,   220,   228,   341,     0,
       0,     0,     0,     0,     0,     0,     0,   457,   459,   591,
     592,   593,   602,   603,    59,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   461,     0,     0,   636,   637,
     430,   429,   639,   634,   635,   640,     0,   853,   852,   854,
     857,   856,   845,    18,     0,   858,   843,   841,   830,   840,
     846,   839,    18,   957,   958,     0,   944,   945,   946,   934,
       0,   987,     0,   924,     0,   927,   933,   987,   926,   928,
     929,     0,   942,   939,   943,   941,   986,  1018,  1019,  1021,
    1014,  1024,  1013,     0,  1022,  1017,  1015,  1016,  1010,  1011,
    1012,     0,   338,   339,   337,   340,    99,    98,   191,   253,
     460,   464,     0,     0,   464,   464,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   464,     0,     0,   641,
     642,   848,   871,   870,   847,   859,   988,   935,   936,   932,
     923,   922,   931,   930,  1023,     0,   469,   464,   464,   471,
     470,   472,   464,   464,   872,     0,   253,   467,   468,   465,
     466,   873,     0,   206
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1682, -1682, -1682, -1682,  -163,  -239,   -64,  -298,  -588, -1682,
    -127,  -132,  1441,  1447,  1462, -1682, -1682, -1682,  -149, -1682,
   -1682,  -151, -1101, -1150,  1771, -1682, -1682,  1046, -1223,   -85,
    -178,   598,  -530, -1682,  1038,  1056,  1060, -1682,  1066,   864,
     626,   632,  -265,  -695,  -375,   871, -1682, -1682, -1682, -1682,
    1960, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682,  -802,  1224,  1026,  1765,  1509,  1849, -1682,  1472, -1682,
   -1682, -1544, -1682,   565,  -156,  1575,   406, -1061, -1622,  2233,
   -1574, -1571,  1577,   420, -1682, -1682,  1581, -1682, -1682, -1682,
   -1682,  -340, -1682, -1682, -1037, -1682,  -109,  1109,    -4, -1682,
   -1682,   783,  1341,   958, -1034,   699, -1682,  -294, -1682,   193,
   -1682, -1682, -1682,   -65,   -90, -1682,  -502, -1682,  2064,  1691,
     -93,  -402,  2063, -1682,    68, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682,  1254,  -623, -1153, -1682, -1682, -1509, -1682, -1682,
   -1682, -1682,   211, -1682,  1324,   285, -1682,  1330, -1192,   276,
   -1681, -1682,  -355, -1682, -1682, -1682, -1682, -1682,  -168, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
    1136,  1890, -1682, -1682, -1682, -1682,  1262,   759, -1682, -1682,
   -1682,   882, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682,  1449,  1446, -1682, -1682,   870, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,   849,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682,   756, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682,   368, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682,   518,   504, -1682, -1682, -1682,
   -1682,   364,   505, -1682, -1682, -1682, -1682,   363,   508, -1618,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682,  1695, -1682, -1682, -1682,
   -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,  1850,
    1558, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,  1260,
    1870, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682, -1682,
   -1682, -1682, -1264, -1682, -1682, -1682, -1682
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    93,   607,   621,   608,  1594,   984,   394,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,  1432,  1775,   745,  1546,  1272,  1273,  2145,   235,
     525,  1636,  1726,  1480,  1481,  1482,  1483,  1491,  1484,  1637,
    1638,  1639,  1641,  1642,  1732,  1644,  1485,  1493,  1305,  1306,
     793,  1066,  1067,   170,   171,   172,    94,   589,    95,    96,
     931,   932,   933,  1141,  1027,  1028,   728,   915,   935,    97,
     588,  1352,  1353,  1703,   173,   430,  1815,   807,   431,   808,
     432,   433,   434,  1819,   435,  1820,   436,   437,  1705,   390,
     174,   391,   175,   176,   177,  1292,   178,   502,  1317,  1293,
    1461,  1462,   787,   788,  1354,  1612,    98,   596,    99,   275,
     955,   101,   102,   265,   276,   277,   354,   963,   641,   964,
     278,   733,   729,  1247,  1032,   103,   240,   241,   104,   959,
    1358,  1160,   960,  1055,  1056,   937,   938,  2017,   105,   106,
     634,   279,   523,   851,   852,   533,   860,   861,  1763,  1992,
    1764,  1765,  2006,  2152,    17,    18,    19,    20,   555,    21,
      22,    23,   541,  1111,  1112,   881,  1535,    24,   543,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,   213,
     579,    35,    36,    37,    38,    39,    40,    41,    42,    43,
     183,   537,   107,  1170,   965,   108,  1361,  1670,  1766,  1858,
    1669,  1549,  1362,  1364,  1552,  1674,  1769,  1366,    44,   109,
    1175,   966,   110,  1368,  1771,  1873,  1770,  1676,  1369,    45,
      46,    47,    48,   111,   676,   674,  1182,  1381,  1382,   112,
     325,   326,  1230,  1018,   705,  1019,   327,   261,   113,   114,
     717,   340,   341,   342,   343,   344,  1025,  1243,  1413,  1420,
    1418,  1419,  1687,  1782,  1244,  1689,  1792,  1245,  1898,  1686,
    1776,  1777,  1901,  2166,  2275,  2253,  1405,  1425,  1578,  1683,
    1773,  1685,  1406,    49,    50,    51,    52,    53,    54,    55,
      56,   896,   115,   626,   116,   117,  1259,  1437,  1438,  1037,
     118,  1435,  1936,  2081,  2083,  2189,  1801,  1800,  1693,  1436,
    1433,  1799,  1691,  1690,  1591,  1434,  1595,  1694,  1940,  2089,
    1802,  1596,  1599,  1695,  1944,  2093,  1803,  1600,  2087,  2183,
     262,   119,  1266,  1038,   120,  1442,  1805,  1965,  2106,  1804,
    1697,  1443,    57,    58,   121,   122,   757,   758,   364,   365,
    1295,  1049,   760,    59,   378,   123,   615,   245,   618,   576,
     577,   124,   125,    60,    61,    62,    63,    64,    65,   220,
     586,   126,  1297,   379,   127,   384,   772,  1620,  1464,  1299,
     773,   128,   503,   129,    66,   130,   131
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     179,   429,   673,   675,   244,   399,   795,   526,   428,   622,
     398,   961,  1291,  2073,   971,  1294,   598,  1316,  1318,  1320,
    1321,   599,   324,   392,   339,   427,   353,  1458,  1079,   363,
     426,  1508,   362,   558,  1503,   708,   580,   377,  1741,  1748,
     376,   383,   280,  1751,   281,   777,   282,   778,   328,   780,
     781,   776,   355,   549,   356,   591,   357,   592,  1809,   385,
     593,   366,   367,  1597,   386,   616,   601,  1810,  1811,  1084,
    1085,   225,  1720,  1724,   387,   505,   506,   507,   508,   509,
    1720,  1724,  1449,  1816,   620,   620,   594,   988,  1417,   228,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   396,
     397,   519,  1415,   385,   229,  -165,   810,   811,   386,  1291,
     670,   671,  1140,   672,  -165,  -165,  -165,  -165,   387,  1277,
     396,   397,   985,  1415,   505,   506,   507,   508,   509,   232,
     233,  1817,   670,   671,  1818,   672,   669,   402,   404,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   611,   210,
     519,  -164,   420,  1439,  1810,  1811,  1084,  1085,  1807,   702,
    -164,  -164,  -164,  -164,   397,  1277,  1430,  1993,   520,   711,
    1278,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   550,  2066,
     652,  1550,   538,   721,   530,   635,   636,   421,   422,   135,
     423,   790,   424,   598,  1286,   654,   100,  1287,   599,   421,
     422,  1084,  1085,   632,   424,  2070,   764,   744,  1547,   661,
     232,   233,  1288,  1557,   556,  1553,  1278,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,   421,   422,  1084,  1085,  2109,   424,
      67,   662,   656,  1289,   667,  1627,  1628,  1629,   403,   598,
    1286,   658,   598,  1287,   599,   989,   549,   599,   690,   598,
    1630,  1631,  1632,  1143,   599,   211,   699,  1941,  1288,   190,
     602,   603,   604,   605,  1942,  1969,   709,  2146,   972,   712,
     551,  1030,   715,     1,   521,   557,   392,  2153,   392,  1289,
     392,   392,  1592,   505,   506,   507,   508,   509,  1400,  1602,
     531,   221,   791,  1810,  1811,  1084,  1085,   986,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   338,   767,   519,
     769,  2074,   598,   591,  1148,   592,  1291,   599,   593,  1540,
     215,  1144,  2071,   598,   598,   226,  1633,  1634,   599,   599,
      68,   598,  1618,  1036,  1645,   612,   599,   958,   505,   506,
     507,   508,   509,  1701,   679,  1040,  1907,  2038,   985,  1943,
    1816,   969,   680,   510,   511,   512,   513,   514,   515,   516,
     517,   518,    69,  2102,   519,   234,   598,   942,   598,   897,
    2037,   599,    70,   599,    71,    72,   889,   890,   891,   892,
     893,   989,   894,   895,   779,   898,   900,   598,   902,   903,
     744,  1651,   599,  2147,  1044,  2103,   786,    73,  1817,  1551,
    2110,  1818,   230,  2154,   222,   796,   797,   798,   799,   800,
     801,   539,   552,   223,  1607,   505,   506,   507,   508,   509,
     990,   809,   911,  1558,   617,   224,  1619,   553,   554,  2127,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   597,
    2101,   519,  1657,   620,  1659,  2184,   231,  1661,   944,  1664,
    1666,  1908,  2039,  1042,  1269,  1043,   950,  1993,    74,  1401,
      75,  1164,    76,   549,    77,   653,    78,    79,  2067,    80,
     647,  1100,   505,   506,   507,   508,   509,  2068,   227,   633,
     655,    81,    82,    83,    84,    85,    86,   510,   511,   512,
     513,   514,   515,   516,   517,   518,  1913,  1791,   519,   668,
     600,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   993,  1229,   657,   996,   609,
     998,   999,  1080,   986,  1509,  1510,   659,  1504,    87,   947,
    1565,  1742,  1749,   246,    88,   236,  1752,   648,  2051,   595,
      89,    90,   697,   388,  1598,   180,   181,  1140,  2064,   389,
    1022,  1812,  2167,  2168,   249,  1813,   990,   637,  1450,   664,
    1374,   956,  1725,  1031,   216,  1909,  2040,  1031,   858,  1610,
    1733,  1031,  1291,  2259,   962,  1704,   698,   987,  1411,  2262,
     812,  1897,  2104,   913,   242,  1774,   899,   388,   345,  1614,
    1045,   939,   243,   389,  1101,  1593,   941,   400,  -165,   977,
    1615,   979,  -165,  1053,   247,  1054,  1783,   237,   238,   239,
     399,  1057,  1964,   992,   212,   398,   804,   805,  2251,   859,
    1778,  1000,  1854,  1002,   393,  1004,   701,  1006,  1007,  1008,
    1009,  1010,  1011,   522,  1013,   395,  1015,  1016,  2124,  1566,
     598,   567,   401,   263,  -164,   599,  1020,   665,  -164,   532,
    1023,   395,  1855,   248,  2105,   405,  1567,   429,   429,  2116,
     406,   602,   603,   604,   605,  1291,  1329,   428,   182,   264,
     598,   425,   666,   407,   598,   599,   408,   600,  1375,   599,
    1840,   598,  1039,  1086,   427,  1842,   599,  1843,  2117,   426,
    1845,   602,   603,   604,   605,   602,   603,   604,   605,  1051,
     991,  1052,   602,   603,   604,   605,   568,   409,   425,  1207,
    2013,  2014,  1115,  1116,  1117,  1118,  1119,  1120,  1300,  1029,
    1131,   410,  1133,   600,  1134,  1135,   600,  1856,  1857,  1130,
    1046,  1132,   397,   600,  1430,   505,   506,   507,   508,   509,
    2035,  2014,  1779,   598,  1107,  2118,   396,   397,   599,  1106,
     510,   511,   512,   513,   514,   515,   516,   517,   518,  1780,
     411,   519,  1047,  2085,   602,   603,   604,   605,   598,   624,
     625,  1291,  1291,   599,  1704,  1313,  1314,  1812,   180,   181,
    2149,   814,  1577,   217,   438,   218,   219,   815,  1643,   602,
     603,   604,   605,  2099,  2014,  1643,   600,   595,  1034,  1076,
     412,  1077,  1035,  1387,  1176,  1177,  1215,   600,   600,  1376,
     413,  1377,  1183,  1378,  1379,   600,    91,  1380,   414,   598,
     346,   606,  1191,  1192,   599,    92,  1194,  1195,  1138,   439,
    1340,  1198,  1199,  1341,  1201,  1342,  1388,   905,  1205,   906,
     602,   603,   604,   605,   505,   506,   507,   508,   509,  1216,
     600,  1147,   600,   347,   348,  2015,   524,   349,  1231,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   350,  1365,
     519,   600,  1093,  1174,  1094,  1169,  1173,   505,   506,   507,
     508,   509,   529,  1275,   816,  2015,   232,   233,   534,   535,
     817,  1781,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   182,   540,   519,  1572,  1608,   542,  1179,  1181,  1899,
    1568,  1569,  1937,  2016,  1186,  1900,  1188,   544,  1938,  1972,
     722,   723,  1973,  2232,  2233,   578,   975,  2135,   549,  2136,
    2247,  2248,   724,  1573,  1574,   559,  1291,   725,  2015,  1102,
    1103,  1104,  1105,  2036,  1258,  1265,   560,  1257,  1264,   392,
     561,   730,  1343,   562,  1345,  1467,   563,   186,   187,   683,
     684,  1468,  1469,  1470,  1471,  1062,  1472,  1473,  1474,  1248,
     564,  1475,   399,  1476,  1477,   215,  1232,   398,   976,  1478,
    1486,  1274,  1357,  1276,  1095,   132,  1096,   133,   134,   135,
     136,   137,   138,   139,   687,   688,  2100,  1575,  2174,   565,
     140,   141,   806,   566,  1939,   142,   505,   506,   507,   508,
     509,   536,  2236,  2237,  2238,  2239,  2240,   143,   583,   144,
     145,   510,   511,   512,   513,   514,   515,   516,   517,   518,
    1833,  1834,   519,   505,   506,   507,   508,   509,  1836,  1837,
     569,   570,   571,   572,   573,   574,   575,   584,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   598,   786,   519,
     517,   518,   599,  1233,   519,  1307,   585,  1308,  1309,  1310,
    1311,   146,   147,   415,   416,   417,   418,   587,   602,   603,
     604,   605,  1323,   534,   535,   148,   149,   590,  1326,  1416,
     945,   946,   150,   151,   152,  1408,  1409,   153,   610,  1445,
     750,   670,   671,   154,   672,  1041,   427,  1722,   155,  1234,
     619,   426,  1421,   905,  1734,  1157,   613,  1722,  1431,  1734,
    1584,   623,  1431,  1410,   600,  1330,  1331,  1180,  1426,  1427,
    1428,  1429,   132,  1463,   133,   134,   135,   136,   137,   138,
     139,   614,   184,   185,   188,   189,   545,   140,   141,  1563,
     214,  1564,   142,   627,   600,   951,   952,   953,   600,   845,
     846,   847,  1402,   628,   143,   600,   144,   145,  2265,  1407,
     546,  1412,   505,   506,   507,   508,   509,  1422,  2186,  2187,
    2188,   848,   849,  1235,   850,  1068,  1069,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   629,  1444,   519,  1153,
    1154,  1236,    70,  1237,    71,    72,   630,  1238,  1554,  1239,
    1163,   631,   882,  1240,  1241,  2282,  1155,  1156,   146,   147,
     415,   416,   417,   418,  1648,  1545,  1650,   600,  1071,   883,
    1544,   547,   148,   149,  1728,  1729,  1730,  1731,   346,   150,
     151,   152,  1501,  1502,   153,  1579,  1580,   638,  1582,   639,
     154,   640,   600,   722,   723,   155,   670,   671,  1587,   672,
     642,  1588,   266,   548,   643,   724,   267,   268,   649,  1681,
     725,   347,   348,   644,   270,   349,   645,  1452,   646,   884,
    1506,  1507,  1453,  1454,   726,   650,   350,  2213,   651,  1460,
     727,   678,   396,   397,   266,  1415,  1561,  1562,   267,   268,
     751,   660,  1171,   600,   -62,   -62,   270,   -62,  1499,   663,
    1500,    81,    82,    83,    84,    85,    86,   677,  1635,   681,
    1716,   271,   527,   528,   686,  1635,   272,  1624,  1625,  1862,
     752,   682,  1570,  1571,  1242,  1416,   685,  1072,  1863,   753,
     885,  1710,  1711,  1864,   689,  1712,  1581,   692,   886,   887,
    1713,  1714,   427,   271,  1720,  1721,   691,   426,   272,   888,
    1431,  1739,  1740,   505,   506,   507,   508,   509,  1793,  1794,
    1073,   693,  1795,  1796,  1797,  1767,  1601,   694,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   695,   132,   519,
     133,   134,   135,   136,   137,   138,   139,  2241,  2242,  2243,
    2244,  2245,   696,   140,   141,  1744,  1745,   700,   142,   505,
     506,   507,   508,   509,   703,  1487,  1849,  1850,   706,  1754,
     143,   704,   144,   145,   510,   511,   512,   513,   514,   515,
     516,   517,   518,  1997,  1998,   519,   191,   192,  1541,  1542,
    1698,  1543,  2009,  2010,  1756,  1605,   786,   707,  1865,  2142,
    2143,  1611,   396,   741,   742,   743,  2150,  2151,  2156,  2157,
     351,  1983,  1984,  1798,  1784,   193,  1672,   754,   755,   756,
     710,   156,   194,  1719,   146,   147,   581,   582,   157,  1727,
     143,   714,   144,   145,   713,   716,   719,   720,   148,   149,
    1653,   732,   195,   734,   196,   150,   151,   152,   735,  1074,
     153,  1785,   197,   736,   737,   738,   154,   746,  1786,   739,
     747,   155,  1682,   740,   748,   749,  1467,   198,   763,   765,
    1852,   759,  1468,  1469,  1470,  1471,  1312,  1472,  1473,  1474,
    1866,  1867,  1475,   761,  1476,  1477,  1277,  1416,   762,  1416,
    1478,   600,   766,   768,  1868,  1869,  1870,   770,   771,  1814,
     774,  1871,   782,   775,   427,  1829,   427,   783,  1635,   426,
    1635,   426,   784,  1627,  1628,  1629,   132,   785,   133,   134,
     135,   136,   137,   138,   139,   792,   789,   519,  1630,  1631,
    1632,   140,   141,  1315,  1277,   802,   142,  1278,  1279,  1280,
    1281,  1282,  1283,  1284,  1285,   803,   620,  1853,   143,   813,
     144,   145,   818,   819,   199,  1787,  1788,  1789,  1707,  1708,
    1709,  1286,  1460,   853,  1287,   854,  1903,   855,   156,   856,
     857,  1906,   862,  1910,  1911,   157,  1914,   864,   352,  1288,
     865,   901,   904,   907,   908,  1278,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,   909,   912,   914,   936,   940,   943,   949,
    1289,   954,   146,   147,  1633,  1634,  2111,   957,   967,  1286,
    1172,   968,  1287,   970,   973,  1494,   148,   149,  1979,  1846,
    1980,  1981,  1982,   150,   151,   152,   974,  1288,   153,   978,
     980,  2000,   981,   982,   154,   983,   994,   995,   200,   155,
     997,  1847,  1003,  1001,  1005,  1012,  1014,  1017,  1289,  2007,
    1033,  1021,  2011,   201,  1861,  2018,   751,  1058,  1050,  1060,
    2001,  1061,  2031,  1063,  1902,  1064,  1904,  1065,  2041,  2042,
    1078,  1083,  1081,  1090,  1091,  2048,  2049,  1092,  2052,  1097,
    2054,  1918,  1919,  1920,  1099,  1113,  1114,  2058,  1137,  1146,
    1145,  1149,  1152,  1158,   505,   506,   507,   508,   509,  2060,
    2061,  1161,  1790,  2062,  2063,  2139,  2140,  2141,  1159,   510,
     511,   512,   513,   514,   515,   516,   517,   518,  1246,  1162,
     519,  1178,  1184,  2002,  2086,  1185,  1189,  1270,  2086,  1187,
    2163,  2164,  2095,   505,   506,   507,   508,   509,  2107,  1872,
    1431,  1196,  1197,  1200,  1202,  1203,  1204,  2119,   510,   511,
     512,   513,   514,   515,   516,   517,   518,  2003,  1970,   519,
    1206,  1208,  2004,  2033,  1209,  1814,  1814,  1210,  1211,  1212,
    1975,  1976,  1977,  2047,  1978,  1213,  1214,   250,  2005,  1271,
    1217,   620,   620,   620,  1218,  1219,   266,  1249,  1267,  2148,
     267,   268,  1268,  1296,  1165,  1301,   202,  1298,   270,  2158,
    2159,  2160,  2161,  2162,  1303,  1059,   620,   620,  2249,  2250,
    1304,  1324,  1322,  1325,  2075,  1333,  1332,   203,  2252,   204,
     205,  2169,  2170,  2171,   156,  -323,  2266,   251,  1334,  2269,
    2270,   157,  2096,  2097,  1335,   266,  1336,  2177,  2178,   267,
     268,  2271,  2180,   380,  1337,   271,  1338,   270,  1344,  1339,
     272,  1070,  1346,  1347,  1348,  2191,  1349,  2193,  1356,  2195,
    1121,  2197,  2277,  2278,  2199,  2200,  1360,  2279,  2280,  1395,
    1350,  1396,  2206,  1355,   252,  1367,  1370,  1122,  1397,   206,
     207,   208,   209,  1371,  1372,  2207,  2208,  2209,  1373,   253,
    1383,  1384,  1385,  1386,   271,  2210,  1389,  1166,  1167,   272,
    2215,  2216,  2217,  1390,  1391,  1392,  1393,  2165,  1394,  1398,
    1399,  1403,  1404,  1414,  1123,  1423,  1424,  1440,  1441,  1448,
    2226,  2227,  1446,  1455,  1451,  1456,  1479,  1459,  1465,  2172,
    1466,  2175,  2176,   505,   506,   507,   508,   509,  1505,  2179,
    1511,  1512,  2181,  1536,  1537,  1514,  1539,  1548,   510,   511,
     512,   513,   514,   515,   516,   517,   518,  1555,  1556,   519,
    1559,  1560,  2198,  1576,  1583,  1585,  2202,  1586,  2204,  1290,
    1589,  1590,  2257,  1603,  1604,  1613,   254,  2258,  1616,  2260,
    1617,  2261,  1621,  1622,  1623,  1646,  1640,  1656,  2263,  1626,
    1660,  1662,  1652,  1667,  1124,  2211,  2212,  1671,  2214,  1673,
    1677,  1675,   156,  1679,  2218,  1678,  2219,  2220,   132,   157,
     133,   134,   135,   136,   137,   138,   139,  -164,  1684,  1692,
    1696,  1700,  1717,   140,   141,  1319,  1718,  1723,   142,   255,
     256,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  1735,
     143,  1737,   144,   145,  1738,  1743,   132,  1746,   133,   134,
     135,   136,   137,   138,   139,  1768,  1747,  1750,  1806,  2254,
     257,   140,   141,  1808,  1824,  1835,   142,  1825,  2256,  1826,
    2221,  1827,  1838,  1839,  1828,   258,  1841,  1844,   143,   259,
     144,   145,  1860,  1851,   505,   506,   507,   508,   509,  1912,
    1848,  1859,  1905,  1915,   146,   147,  1921,  1966,  1916,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   148,   149,
     519,  1917,  1967,  1971,  1974,   150,   151,   152,  1985,  1986,
     153,  1987,  1994,  1125,  1988,  1989,   154,  1990,   260,  1991,
    1995,   155,   146,   147,  1126,  1754,  1996,  2008,  2012,  1999,
    2019,  2020,  2032,  2021,  2034,  2043,   148,   149,  2022,  2044,
    2045,  2046,  1168,   150,   151,   152,  2053,  2055,   153,  2050,
    2056,  2057,  2072,  2076,   154,  2059,  2079,  2069,   132,   155,
     133,   134,   135,   136,   137,   138,   139,  2077,  2078,  2080,
    1597,  2082,  2084,   140,   141,  1658,  1075,  2090,   142,  2094,
    2108,   381,  2112,  2114,  2113,  2098,  2120,  2122,  2133,  2128,
     143,   382,   144,   145,  2115,  2134,   132,  1127,   133,   134,
     135,   136,   137,   138,   139,  2121,  2137,  2138,  2144,  2155,
    2173,   140,   141,  1663,  2182,  1082,   142,  2185,  2192,  2190,
     505,   506,   507,   508,   509,  2194,  2201,  2222,   143,   834,
     144,   145,  1128,  1129,  2223,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   146,   147,   519,  2228,  2255,  2264,
    2274,  2224,   879,   835,  2225,   836,  1447,  1108,   148,   149,
    1831,  2229,  2231,  1109,  2276,   150,   151,   152,  2234,  2283,
     153,  2235,  2246,  2267,  2268,  2272,   154,     4,  1110,   837,
    2273,   155,   146,   147,  1488,  2281,     5,   838,   839,  1832,
     840,   841,  1647,  1830,   934,   440,   148,   149,   842,   843,
     844,  1649,  1489,   150,   151,   152,  1490,   794,   153,  1351,
       6,     7,  1492,  1968,   154,  1538,  1098,  2125,   132,   155,
     133,   134,   135,   136,   137,   138,   139,  1142,  1087,   419,
     880,  1088,  2126,   140,   141,  1665,   441,  1089,   142,  1715,
    1457,   442,     8,  1302,   718,     9,  1821,    10,  1606,  1024,
     143,   731,   144,   145,  2230,  1359,   132,  1327,   133,   134,
     135,   136,   137,   138,   139,  1328,   863,  1753,  1363,  1668,
    1190,   140,   141,  1680,    11,  1688,   142,  1193,    12,  1772,
    2065,  2196,  2088,    13,    14,  2203,  2205,  2092,   143,  2091,
     144,   145,   910,  1048,  1277,   443,   444,     0,   445,   446,
     447,   448,   449,  1136,   146,   147,     0,   948,     0,     0,
       0,     0,     0,     0,     0,  1150,     0,     0,   148,   149,
       0,     0,     0,     0,     0,   150,   151,   152,     0,     0,
     153,     0,     0,     0,     0,     0,   154,     0,     0,     0,
       0,   155,   146,   147,     0,  1278,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,     0,     0,     0,   148,   149,     0,     0,
       0,     0,     0,   150,   151,   152,     0,     0,   153,  1286,
       0,     0,  1287,     0,   154,     0,     0,     0,     0,   155,
    1754,  1755,     0,     0,   156,     0,     0,  1288,     0,     0,
       0,   157,     0,     0,     0,   450,     0,   505,   506,   507,
     508,   509,     0,     0,     0,  1756,     0,     0,  1289,   440,
       0,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,  -318,   156,   519,   505,   506,   507,   508,   509,   157,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,     0,  1757,  1758,     0,     0,  1759,  1760,   451,     0,
       0,     0,  1761,     0,     0,     0,  1151,     0,     0,   505,
     506,   507,   508,   509,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   505,   506,   507,   508,
     509,   462,   463,     0,     0,     0,     0,     0,     0,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    15,    16,   464,   465,   466,   467,
       0,     0,     0,     0,   156,   505,   506,   507,   508,   509,
       0,   157,     0,     0,     0,     0,     0,     0,     0,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,     0,     0,     0,   505,   506,   507,   508,   509,
       0,     0,   156,     0,     0,     0,     0,     0,     0,   157,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   505,   506,   507,   508,   509,     0,     0,   450,
       0,     0,  1495,     0,     0,   468,   469,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,     0,
     470,   471,     0,     0,     0,     0,     0,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,     0,     0,     0,     0,
       0,     0,   451,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   500,   501,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,     0,
       0,     0,     0,     0,   156,   505,   506,   507,   508,   509,
       0,   157,     0,  1762,     0,   462,   463,     0,     0,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   156,   505,   506,   507,   508,   509,     0,   157,
     464,   465,   466,   467,     0,     0,     0,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     505,   506,   507,   508,   509,     0,  1702,     0,     0,     0,
       0,     0,     0,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   505,   506,   507,
     508,   509,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,     0,     0,     0,  1945,     0,   468,
     469,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   470,   471,     0,     0,     0,     0,
       0,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1496,
       0,   505,   506,   507,   508,   509,     0,     0,     0,     0,
     500,   501,     0,     0,     0,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,  1497,   519,   505,   506,
     507,   508,   509,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,     0,     0,   505,   506,   507,
     508,   509,     0,     0,  1754,  1946,     0,     0,     0,     0,
       0,  1498,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   505,   506,   507,   508,   509,  1756,
       0,     0,     0,     0,     0,     0,     0,     0,  1513,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   505,   506,   507,   508,   509,     0,    70,     0,    71,
      72,     0,     0,     0,     0,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,  1947,     0,   519,  1948,  1949,
      70,     0,    71,    72,     0,     0,  1950,  1654,     0,     0,
       0,  1951,     0,     0,  1952,     0,     0,     0,     0,  1953,
       0,     0,     0,     0,     0,     0,    70,     0,    71,    72,
       0,     0,     0,     0,     0,     0,     0,  1655,     0,   505,
     506,   507,   508,   509,     0,     0,     0,     0,  1954,     0,
      70,     0,    71,    72,   510,   511,   512,   513,   514,   515,
     516,   517,   518,  1250,  1736,   519,     0,     0,     0,   266,
       0,  1955,     0,   267,   268,     0,     0,     0,     0,     0,
       0,   270,     0,     0,     0,     0,    81,    82,    83,    84,
      85,    86,   266,     0,     0,     0,   267,   268,     0,     0,
       0,     0,     0,     0,   270,     0,     0,     0,     0,    81,
      82,    83,    84,    85,    86,     0,     0,    70,   266,    71,
      72,     0,   267,   268,     0,     0,  1251,  1609,   271,     0,
     270,     0,     0,   272,  1956,    81,    82,    83,    84,    85,
      86,    70,   266,    71,    72,     0,   267,   268,     0,     0,
       0,   271,     0,     0,   270,     0,   272,     0,     0,    81,
      82,    83,    84,    85,    86,     0,     0,  2123,     0,   368,
       0,     0,     0,     0,     0,     0,     0,   271,     0,     0,
       0,     0,   272,     0,  1957,  1958,  1959,  1960,  1961,     0,
    1962,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   271,     0,     0,     0,  2129,   272,     0,     0,   266,
       0,     0,   369,   267,   268,     0,   358,  1260,     0,     0,
       0,   270,     0,     0,     0,     0,    81,    82,    83,    84,
      85,    86,  2130,   266,     0,     0,     0,   267,   268,     0,
       0,   269,     0,     0,     0,   270,     0,     0,     0,     0,
      81,    82,    83,    84,    85,    86,     0,  1963,     0,  2131,
       0,     0,     0,     0,     0,     0,     0,     0,   271,     0,
     359,     0,     0,   272,     0,     0,     0,     0,     0,   283,
     284,     0,   329,   330,   331,   332,     0,     0,     0,     0,
       0,     0,   271,     0,     0,     0,     0,   272,     0,     0,
       0,     0,     0,  1922,     0,     0,     0,     0,     0,   285,
       0,     0,   333,     0,     0,  -324,  -324,  -324,   360,   334,
       0,     0,   335,     0,     0,   336,     0,     0,     0,  1220,
    -324,  -324,  -324,  -324,  -324,   515,   516,   517,   518,     0,
     286,   519,     0,     0,     0,   370,     0,     0,     0,     0,
       0,     0,     0,  2132,     0,     0,     0,     0,     0,     0,
       0,   273,     0,     0,     0,     0,     0,     0,     0,   266,
       0,     0,     0,   267,   268,     0,   287,   288,  1699,     0,
       0,   270,     0,     0,     0,  1874,   289,   290,   291,   292,
     346,     0,     0,   505,   506,   507,  1252,  1253,  1221,   293,
    1254,   371,   294,   295,     0,  1255,     0,  1706,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
       0,     0,     0,   347,   348,     0,     0,   349,   271,     0,
       0,     0,  1923,   272,  1822,   337,     0,  1924,   350,     0,
       0,     0,     0,     0,     0,     0,   296,   372,   373,   374,
       0,     0,  1261,     0,     0,     0,     0,     0,   375,     0,
       0,  1823,     0,  1925,     0,     0,     0,     0,     0,     0,
       0,     0,   297,   298,     0,     0,     0,     0,     0,     0,
     299,   300,     0,   301,  1256,     0,     0,  1926,     0,     0,
       0,  1222,     0,     0,     0,     0,     0,   302,  1754,  1927,
       0,  1262,   303,     0,   304,     0,   305,   306,   361,     0,
     307,   308,   309,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1756,     0,     0,     0,   310,   311,     0,
       0,     0,     0,   312,   313,     0,     0,     0,     0,     0,
       0,   314,     0,  1875,     0,   315,     0,     0,   316,   317,
       0,   318,     0,   319,     0,     0,     0,   320,   321,     0,
     322,     0,     0,     0,     0,  1876,     0,     0,     0,  1877,
       0,     0,  1878,  1879,     0,  1263,     0,     0,     0,     0,
    1880,  1223,     0,     0,     0,     0,     0,  1881,     0,     0,
    1224,  1225,  1882,  1883,  1884,     0,     0,  1226,     0,   274,
       0,  1227,   916,   917,   918,   919,   920,   921,   922,   923,
     924,     0,   925,   926,   927,   928,   929,   930,   866,     0,
    1928,  1929,     0,     0,     0,  1930,  1931,     0,  1932,     0,
       0,     0,   396,   741,   742,   743,  1933,  1934,     0,  1515,
    1026,  1516,  1517,     0,   504,  1885,     0,     0,     0,   505,
     506,   507,   508,   509,  1886,     0,     0,     0,     0,     0,
     143,     0,   144,   145,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,     0,     0,     0,     0,
    1887,     0,  1888,     0,  1889,  1890,  1891,     0,     0,     0,
       0,     0,  1892,     0,     0,     0,     0,  1893,     0,   916,
     917,   918,   919,   920,   921,   922,   923,   924,  1894,   925,
     926,   927,   928,   929,   930,     0,  1895,     0,     0,     0,
       0,     0,     0,     0,  1935,     0,   916,   917,   918,   919,
     920,   921,   922,   923,   924,   323,   925,   926,   927,   928,
     929,   930,     0,     0,     0,     0,   867,   723,  1518,  1519,
    1520,  1521,  1522,  1523,   868,     0,     0,     0,   869,     0,
       0,     0,   870,     0,     0,   871,     0,     0,     0,     0,
     505,   506,   507,   508,   509,     0,     0,     0,     0,     0,
    1228,     0,     0,     0,   872,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,     0,     0,     0,
     873,   874,   875,     0,   876,     0,   877,   878,     0,     0,
       0,     0,     0,  1524,  1525,  1526,  1527,  1528,  1529,  1530,
    1531,  1532,  1533,  1534,     0,     0,     0,     0,     0,     0,
       0,  1896,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1139
};

static const yytype_int16 yycheck[] =
{
       4,   157,   300,   301,    89,   137,   408,   185,   157,   248,
     137,   634,  1049,   113,    77,  1049,    15,  1078,  1079,  1080,
    1081,    20,   112,   132,   114,   157,   116,  1291,     7,   122,
     157,     7,   122,   201,     7,   329,   214,   130,     7,     7,
     130,   131,   107,     7,   109,   385,   111,   387,   113,   389,
     390,     7,   117,    20,   119,    15,   121,    17,     6,    15,
      20,   126,   127,    21,    20,   143,   229,    15,    16,    17,
      18,    75,    11,    12,    30,     8,     9,    10,    11,    12,
      11,    12,    23,  1705,   247,   248,    46,   675,  1238,   175,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    17,
      18,    34,    20,    15,   190,     6,    28,    29,    20,  1146,
      17,    18,   914,    20,    15,    16,    17,    18,    30,    20,
      17,    18,    43,    20,     8,     9,    10,    11,    12,    20,
      21,  1705,    17,    18,  1705,    20,   299,    29,   142,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    21,    37,
      34,     6,   156,  1254,    15,    16,    17,    18,  1702,   322,
      15,    16,    17,    18,    18,    20,    20,  1848,    37,   332,
      71,    72,    73,    74,    75,    76,    77,    78,   145,   113,
      45,    32,     3,   346,    37,   270,   271,    15,    16,    17,
      18,    29,    20,    15,    95,    45,     3,    98,    20,    15,
      16,    17,    18,   267,    20,   281,   369,   358,  1361,   294,
      20,    21,   113,   124,   176,  1368,    71,    72,    73,    74,
      75,    76,    77,    78,    15,    16,    17,    18,   266,    20,
       0,   295,    45,   134,   298,     8,     9,    10,   130,    15,
      95,    45,    15,    98,    20,    43,    20,    20,   312,    15,
      23,    24,    25,    20,    20,   143,   320,   411,   113,     3,
      36,    37,    38,    39,   418,  1809,   330,    46,   331,   333,
     237,    37,   336,     4,   143,   237,   385,    46,   387,   134,
     389,   390,  1435,     8,     9,    10,    11,    12,   144,  1442,
     143,     3,   130,    15,    16,    17,    18,   218,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   114,   372,    34,
     374,   411,    15,    15,   937,    17,  1353,    20,    20,  1353,
      21,    88,   398,    15,    15,   499,    99,   100,    20,    20,
       3,    15,   409,   735,  1484,   208,    20,   631,     8,     9,
      10,    11,    12,  1607,   273,   747,   148,   148,    43,   503,
    1972,   649,   281,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    35,   148,    34,   175,    15,   606,    15,   143,
    1879,    20,    45,    20,    47,    48,   544,   545,   546,   547,
     548,    43,   550,   551,   388,   553,   554,    15,   556,   557,
     541,  1492,    20,   172,    45,   180,   400,    70,  1972,   250,
     438,  1972,   488,   172,    20,   409,   410,   411,   412,   413,
     414,   232,   379,    20,  1451,     8,     9,    10,    11,    12,
     218,   425,   585,   334,   502,    20,   503,   394,   395,  1973,
      23,    24,    25,    26,    27,    28,    29,    30,    31,   228,
    1949,    34,  1503,   606,  1505,  2063,   160,  1508,   611,  1510,
    1511,   253,   253,   751,  1042,   753,   619,  2138,   131,   315,
     133,   963,   135,    20,   137,   330,   139,   140,   402,   142,
     215,    20,     8,     9,    10,    11,    12,   411,   138,   268,
     330,   154,   155,   156,   157,   158,   159,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   187,  1689,    34,   498,
     499,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   678,  1018,   330,   681,   234,
     683,   684,   501,   218,   500,   501,   330,   500,   201,   614,
     168,   500,   500,   166,   207,   139,   500,   282,   187,   499,
     213,   214,   251,   499,   502,    20,    21,  1349,   402,   505,
     713,   499,   374,   375,   150,   503,   218,   272,   499,   211,
      82,   626,   501,   726,   265,   367,   367,   730,   151,   502,
     501,   734,  1609,  2191,   638,  1609,   285,   498,   354,  2197,
     502,  1773,   367,   587,   475,   503,   143,   499,   502,    23,
     241,   595,   483,   505,   143,   502,   600,   499,   499,   663,
      34,   665,   503,   766,   430,   768,   503,   211,   212,   213,
     742,   774,  1804,   677,   502,   742,   500,   501,   503,   202,
     232,   685,   148,   687,    31,   689,   329,   691,   692,   693,
     694,   695,   696,   502,   698,    31,   700,   701,   499,   277,
      15,    77,   130,    20,   499,    20,   710,   299,   503,   502,
     714,    31,   178,   479,   439,    15,   294,   813,   814,   330,
     502,    36,    37,    38,    39,  1702,    46,   816,   143,    46,
      15,   499,   324,   502,    15,    20,   499,   499,   200,    20,
    1741,    15,   746,   499,   816,  1746,    20,  1748,   359,   816,
    1751,    36,    37,    38,    39,    36,    37,    38,    39,   763,
     498,   765,    36,    37,    38,    39,   142,   499,   499,  1003,
      61,    62,   890,   891,   892,   893,   894,   895,  1058,   723,
     898,   499,   900,   499,   902,   903,   499,   253,   254,   897,
     381,   899,    18,   499,    20,     8,     9,    10,    11,    12,
      61,    62,   354,    15,   876,   373,    17,    18,    20,   876,
      23,    24,    25,    26,    27,    28,    29,    30,    31,   371,
     499,    34,   413,   410,    36,    37,    38,    39,    15,   344,
     345,  1808,  1809,    20,  1808,   500,   501,   499,    20,    21,
    2003,   501,  1405,   484,   216,   486,   487,   507,  1483,    36,
      37,    38,    39,    61,    62,  1490,   499,   499,   730,   803,
     499,   805,   734,   498,   967,   968,   498,   499,   499,   331,
     499,   333,   975,   335,   336,   499,   489,   339,   499,    15,
     113,   162,   985,   986,    20,   498,   989,   990,   498,   216,
    1124,   994,   995,  1127,   997,  1129,   498,   501,  1001,   503,
      36,    37,    38,    39,     8,     9,    10,    11,    12,  1012,
     499,   936,   499,   146,   147,   206,    21,   150,  1021,    23,
      24,    25,    26,    27,    28,    29,    30,    31,   161,  1167,
      34,   499,   501,   966,   503,   965,   966,     8,     9,    10,
      11,    12,     3,  1046,   501,   206,    20,    21,    20,    21,
     507,   503,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   143,     3,    34,   277,   498,     3,   971,   972,   371,
     244,   245,   411,   264,   978,   377,   980,   255,   417,   501,
     131,   132,   504,  2146,  2147,    15,   271,  1988,    20,  1990,
    2153,  2154,   143,   306,   307,     3,  1973,   148,   206,    17,
      18,    19,    20,   264,  1037,  1038,     3,  1037,  1038,  1058,
       3,   162,  1130,     3,  1132,    43,     3,   199,   200,   285,
     286,    49,    50,    51,    52,   501,    54,    55,    56,  1033,
       3,    59,  1104,    61,    62,    21,   145,  1104,   323,    67,
      68,  1045,  1160,  1047,   501,    13,   503,    15,    16,    17,
      18,    19,    20,    21,   297,   298,   264,  1399,   245,     3,
      28,    29,    30,     3,   503,    33,     8,     9,    10,    11,
      12,   143,   180,   181,   182,   183,   184,    45,     3,    47,
      48,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    1725,  1726,    34,     8,     9,    10,    11,    12,  1733,  1734,
     476,   477,   478,   479,   480,   481,   482,     3,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    15,  1062,    34,
      30,    31,    20,   232,    34,  1069,   430,  1071,  1072,  1073,
    1074,    99,   100,   101,   102,   103,   104,    23,    36,    37,
      38,    39,  1086,    20,    21,   113,   114,    20,  1092,  1238,
     209,   210,   120,   121,   122,   354,   355,   125,   498,  1262,
      76,    17,    18,   131,    20,    21,  1238,  1637,   136,   278,
     215,  1238,   384,   501,  1644,   503,   498,  1647,  1250,  1649,
    1414,    20,  1254,   382,   499,    17,    18,   502,   164,   165,
     166,   167,    13,  1296,    15,    16,    17,    18,    19,    20,
      21,   485,     6,     7,     8,     9,   152,    28,    29,   501,
      14,   503,    33,   428,   499,    40,    41,    42,   499,   151,
     152,   153,  1226,    46,    45,   499,    47,    48,  2229,  1233,
     176,  1235,     8,     9,    10,    11,    12,  1241,   421,   422,
     423,   173,   174,   352,   176,   500,   501,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    20,  1261,    34,    41,
      42,   370,    45,   372,    47,    48,   502,   376,  1371,   378,
     503,   138,     3,   382,   383,  2276,    41,    42,    99,   100,
     101,   102,   103,   104,  1489,  1357,  1491,   499,   501,    20,
    1357,   237,   113,   114,    63,    64,    65,    66,   113,   120,
     121,   122,   500,   501,   125,  1408,  1409,   266,  1411,   498,
     131,   502,   499,   131,   132,   136,    17,    18,  1421,    20,
     498,  1424,   137,   269,   498,   143,   141,   142,   294,  1567,
     148,   146,   147,   502,   149,   150,   502,  1281,   502,    70,
     500,   501,  1286,  1287,   162,   498,   161,   245,    21,  1293,
     168,   271,    17,    18,   137,    20,   340,   341,   141,   142,
     276,   283,   145,   499,    17,    18,   149,    20,  1312,   166,
    1314,   154,   155,   156,   157,   158,   159,   266,  1481,   271,
    1618,   196,   186,   187,   281,  1488,   201,    57,    58,    43,
     306,   270,  1396,  1397,   503,  1484,   257,   501,    52,   315,
     131,   121,   122,    57,   297,   125,  1410,   310,   139,   140,
     130,   131,  1484,   196,    11,    12,   303,  1484,   201,   150,
    1492,   500,   501,     8,     9,    10,    11,    12,   408,   409,
     501,   257,   412,   413,   414,  1673,  1440,   257,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   318,    13,    34,
      15,    16,    17,    18,    19,    20,    21,   180,   181,   182,
     183,   184,   316,    28,    29,   500,   501,   327,    33,     8,
       9,    10,    11,    12,   498,   503,   244,   245,   498,   170,
      45,   502,    47,    48,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   180,   181,    34,   175,   176,    17,    18,
    1603,    20,   261,   262,   195,  1449,  1450,   502,   162,   180,
     181,  1455,    17,    18,    19,    20,   178,   179,   154,   155,
     335,  1836,  1837,   503,   215,   204,  1551,   443,   444,   445,
     137,   499,   211,  1636,    99,   100,   216,   217,   506,  1642,
      45,   378,    47,    48,   138,   330,   498,   502,   113,   114,
    1494,    20,   231,   162,   233,   120,   121,   122,   150,   501,
     125,   252,   241,   498,   498,   502,   131,   266,   259,   502,
     150,   136,  1576,   502,   498,   498,    43,   256,   166,   322,
    1759,   502,    49,    50,    51,    52,   501,    54,    55,    56,
     244,   245,    59,   502,    61,    62,    20,  1686,   502,  1688,
      67,   499,   150,   271,   258,   259,   260,   498,   498,  1705,
     271,   265,    14,   498,  1686,  1718,  1688,    15,  1721,  1686,
    1723,  1688,    15,     8,     9,    10,    13,    31,    15,    16,
      17,    18,    19,    20,    21,    29,    28,    34,    23,    24,
      25,    28,    29,    30,    20,    15,    33,    71,    72,    73,
      74,    75,    76,    77,    78,   501,  1759,  1760,    45,     7,
      47,    48,    15,    15,   343,   356,   357,   358,  1612,  1613,
    1614,    95,  1616,     3,    98,     3,  1779,     3,   499,     3,
       3,  1784,     3,  1786,  1787,   506,  1789,     3,   503,   113,
       3,     3,     3,     3,     3,    71,    72,    73,    74,    75,
      76,    77,    78,     3,     3,   499,   501,   498,   498,   498,
     134,   197,    99,   100,    99,   100,  1954,    20,   271,    95,
     503,   271,    98,   498,   498,   501,   113,   114,  1831,  1754,
    1833,  1834,  1835,   120,   121,   122,   498,   113,   125,   308,
     202,    46,   498,   498,   131,    32,   271,   271,   427,   136,
     271,  1755,   138,   271,   498,   218,   498,   498,   134,  1862,
     169,   162,  1865,   442,  1768,  1868,   276,    15,   498,    46,
      75,    15,  1875,   500,  1778,   130,  1780,    29,  1881,  1882,
     501,    15,   501,   218,   218,  1888,  1889,   499,  1891,     3,
    1893,  1795,  1796,  1797,    20,    20,     3,  1900,     3,   502,
     498,   498,    21,   498,     8,     9,    10,    11,    12,  1912,
    1913,   501,   503,  1916,  1917,  1994,  1995,  1996,    29,    23,
      24,    25,    26,    27,    28,    29,    30,    31,   163,   498,
      34,   498,   498,   138,  1937,   498,    20,    45,  1941,   498,
    2019,  2020,  1945,     8,     9,    10,    11,    12,  1951,   503,
    1922,   498,   498,   498,   498,   498,   498,  1960,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   172,  1812,    34,
     498,   498,   177,  1877,   498,  1971,  1972,   498,   498,   498,
    1824,  1825,  1826,  1887,  1828,   498,   498,   144,   193,    15,
     498,  1994,  1995,  1996,   498,   498,   137,   498,   498,  2002,
     141,   142,   498,   162,   145,    18,   152,   502,   149,  2012,
    2013,  2014,  2015,  2016,    29,   500,  2019,  2020,  2156,  2157,
      29,    15,   501,    15,  1928,     3,    34,   173,  2166,   175,
     176,  2034,  2035,  2036,   499,   500,  2231,   194,     3,  2234,
    2235,   506,  1946,  1947,     3,   137,     3,  2050,  2051,   141,
     142,  2246,  2055,   145,     3,   196,     3,   149,     3,    15,
     201,   500,     3,     3,     3,  2068,   498,  2070,    21,  2072,
       3,  2074,  2267,  2268,  2077,  2078,   498,  2272,  2273,   267,
     500,   322,  2085,   500,   241,   498,   498,    20,   166,   235,
     236,   237,   238,   501,   498,  2098,  2099,  2100,   498,   256,
     498,   498,   498,   498,   196,  2108,   498,   248,   249,   201,
    2113,  2114,  2115,   498,   498,   498,   498,  2021,   498,   305,
     150,    52,   498,   266,    57,   498,   387,   152,   498,    31,
    2133,  2134,   498,    23,   499,   499,   503,   498,    31,  2043,
      29,  2045,  2046,     8,     9,    10,    11,    12,   501,  2053,
     501,    15,  2056,     3,     3,    18,   503,   502,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   162,   342,    34,
     338,   337,  2076,   267,   502,   502,  2080,   502,  2082,   503,
     502,   502,  2185,   162,    15,    23,   343,  2190,   501,  2192,
     498,  2194,    15,    29,    53,   498,    33,    30,  2201,    60,
      30,     7,   498,   503,   137,  2109,  2110,    20,  2112,   251,
     498,   502,   499,   235,  2118,   332,  2120,  2121,    13,   506,
      15,    16,    17,    18,    19,    20,    21,   503,   502,   502,
     502,   500,   498,    28,    29,    30,     7,   501,    33,   396,
     397,   359,   360,   361,   362,   363,   364,   365,   366,    69,
      45,   500,    47,    48,   500,   500,    13,   499,    15,    16,
      17,    18,    19,    20,    21,   248,   500,   500,   500,  2173,
     427,    28,    29,    97,   499,    31,    33,   499,  2182,   499,
    2124,   498,    15,    30,   499,   442,    30,     7,    45,   446,
      47,    48,   498,   245,     8,     9,    10,    11,    12,   281,
     502,   502,   498,   498,    99,   100,   498,   498,   411,    23,
      24,    25,    26,    27,    28,    29,    30,    31,   113,   114,
      34,   411,   503,     7,   500,   120,   121,   122,   500,   500,
     125,   500,   246,   266,   501,   500,   131,   499,   495,   500,
     246,   136,    99,   100,   277,   170,   246,   267,   263,   178,
     246,   246,   502,   266,   263,   266,   113,   114,   498,   391,
     318,   361,   503,   120,   121,   122,   389,   381,   125,   281,
     359,   498,   403,   401,   131,   498,   267,   398,    13,   136,
      15,    16,    17,    18,    19,    20,    21,   271,   406,   251,
      21,   251,   498,    28,    29,    30,   500,   498,    33,   498,
     271,   493,   318,   271,   381,   263,   435,   498,    31,   498,
      45,   503,    47,    48,   271,    31,    13,   350,    15,    16,
      17,    18,    19,    20,    21,   437,   503,   498,    21,   503,
     392,    28,    29,    30,   420,   500,    33,   271,   246,   271,
       8,     9,    10,    11,    12,   246,   162,   498,    45,    57,
      47,    48,   385,   386,   498,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    99,   100,    34,   500,   373,   373,
     368,   498,   541,    81,   498,    83,  1270,   876,   113,   114,
    1722,   501,   498,   876,   501,   120,   121,   122,   498,   500,
     125,   498,   498,   498,   498,   498,   131,   133,   876,   107,
     498,   136,    99,   100,  1306,   498,   142,   115,   116,  1723,
     118,   119,  1488,  1721,   589,     5,   113,   114,   126,   127,
     128,  1490,  1306,   120,   121,   122,  1306,   407,   125,  1145,
     166,   167,  1306,  1808,   131,  1349,   867,  1971,    13,   136,
      15,    16,    17,    18,    19,    20,    21,   915,   813,   156,
     541,   814,  1972,    28,    29,    30,    46,   816,    33,  1616,
    1291,    51,   198,  1062,   340,   201,  1707,   203,  1450,   718,
      45,   348,    47,    48,  2138,  1161,    13,  1093,    15,    16,
      17,    18,    19,    20,    21,  1095,   536,  1668,  1166,  1547,
     984,    28,    29,  1563,   230,  1586,    33,   988,   234,  1683,
    1922,  2073,  1938,   239,   240,  2081,  2083,  1942,    45,  1941,
      47,    48,   582,   758,    20,   105,   106,    -1,   108,   109,
     110,   111,   112,   905,    99,   100,    -1,   617,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   500,    -1,    -1,   113,   114,
      -1,    -1,    -1,    -1,    -1,   120,   121,   122,    -1,    -1,
     125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,
      -1,   136,    99,   100,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    -1,    -1,   113,   114,    -1,    -1,
      -1,    -1,    -1,   120,   121,   122,    -1,    -1,   125,    95,
      -1,    -1,    98,    -1,   131,    -1,    -1,    -1,    -1,   136,
     170,   171,    -1,    -1,   499,    -1,    -1,   113,    -1,    -1,
      -1,   506,    -1,    -1,    -1,   205,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,   195,    -1,    -1,   134,     5,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   498,   499,    34,     8,     9,    10,    11,    12,   506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      34,    -1,   242,   243,    -1,    -1,   246,   247,   268,    -1,
      -1,    -1,   252,    -1,    -1,    -1,   500,    -1,    -1,     8,
       9,    10,    11,    12,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    34,     8,     9,    10,    11,
      12,   311,   312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   490,   491,   346,   347,   348,   349,
      -1,    -1,    -1,    -1,   499,     8,     9,    10,    11,    12,
      -1,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    34,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,   499,    -1,    -1,    -1,    -1,    -1,    -1,   506,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    34,     8,     9,    10,    11,    12,    -1,    -1,   205,
      -1,    -1,   500,    -1,    -1,   425,   426,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    34,    -1,
     440,   441,    -1,    -1,    -1,    -1,    -1,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   496,   497,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    -1,    -1,
      -1,    -1,    -1,    -1,   499,     8,     9,    10,    11,    12,
      -1,   506,    -1,   503,    -1,   311,   312,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   499,     8,     9,    10,    11,    12,    -1,   506,
     346,   347,   348,   349,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    34,
       8,     9,    10,    11,    12,    -1,   502,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    34,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,    -1,    -1,    -1,    43,    -1,   425,
     426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   440,   441,    -1,    -1,    -1,    -1,
      -1,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   500,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
     496,   497,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,   500,    34,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,    -1,     8,     9,    10,
      11,    12,    -1,    -1,   170,   171,    -1,    -1,    -1,    -1,
      -1,   500,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,     8,     9,    10,    11,    12,   195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   500,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      34,     8,     9,    10,    11,    12,    -1,    45,    -1,    47,
      48,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    31,   241,    -1,    34,   244,   245,
      45,    -1,    47,    48,    -1,    -1,   252,   500,    -1,    -1,
      -1,   257,    -1,    -1,   260,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   500,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,   294,    -1,
      45,    -1,    47,    48,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    82,   500,    34,    -1,    -1,    -1,   137,
      -1,   317,    -1,   141,   142,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,   156,   157,
     158,   159,   137,    -1,    -1,    -1,   141,   142,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,   156,   157,   158,   159,    -1,    -1,    45,   137,    47,
      48,    -1,   141,   142,    -1,    -1,   145,    96,   196,    -1,
     149,    -1,    -1,   201,   380,   154,   155,   156,   157,   158,
     159,    45,   137,    47,    48,    -1,   141,   142,    -1,    -1,
      -1,   196,    -1,    -1,   149,    -1,   201,    -1,    -1,   154,
     155,   156,   157,   158,   159,    -1,    -1,   500,    -1,   214,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,   201,    -1,   430,   431,   432,   433,   434,    -1,
     436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,   500,   201,    -1,    -1,   137,
      -1,    -1,   257,   141,   142,    -1,   211,   145,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,   156,   157,
     158,   159,   500,   137,    -1,    -1,    -1,   141,   142,    -1,
      -1,   145,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,   156,   157,   158,   159,    -1,   503,    -1,   500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
     265,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    47,
      48,    -1,   350,   351,   352,   353,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,   380,    -1,    -1,     8,     9,    10,   313,   387,
      -1,    -1,   390,    -1,    -1,   393,    -1,    -1,    -1,    52,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
     108,    34,    -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   500,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,
      -1,    -1,    -1,   141,   142,    -1,   144,   145,   498,    -1,
      -1,   149,    -1,    -1,    -1,    57,   154,   155,   156,   157,
     113,    -1,    -1,     8,     9,    10,   415,   416,   121,   167,
     419,   446,   170,   171,    -1,   424,    -1,   498,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    34,
      -1,    -1,    -1,   146,   147,    -1,    -1,   150,   196,    -1,
      -1,    -1,   211,   201,   498,   503,    -1,   216,   161,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   214,   492,   493,   494,
      -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,   503,    -1,
      -1,   498,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,   241,    -1,    -1,    -1,    -1,    -1,    -1,
     248,   249,    -1,   251,   503,    -1,    -1,   266,    -1,    -1,
      -1,   214,    -1,    -1,    -1,    -1,    -1,   265,   170,   278,
      -1,   429,   270,    -1,   272,    -1,   274,   275,   503,    -1,
     278,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   195,    -1,    -1,    -1,   295,   296,    -1,
      -1,    -1,    -1,   301,   302,    -1,    -1,    -1,    -1,    -1,
      -1,   309,    -1,   215,    -1,   313,    -1,    -1,   316,   317,
      -1,   319,    -1,   321,    -1,    -1,    -1,   325,   326,    -1,
     328,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,   241,
      -1,    -1,   244,   245,    -1,   503,    -1,    -1,    -1,    -1,
     252,   304,    -1,    -1,    -1,    -1,    -1,   259,    -1,    -1,
     313,   314,   264,   265,   266,    -1,    -1,   320,    -1,   503,
      -1,   324,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,     3,    -1,
     399,   400,    -1,    -1,    -1,   404,   405,    -1,   407,    -1,
      -1,    -1,    17,    18,    19,    20,   415,   416,    -1,    45,
      20,    47,    48,    -1,     3,   317,    -1,    -1,    -1,     8,
       9,    10,    11,    12,   326,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    48,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,
     352,    -1,   354,    -1,   356,   357,   358,    -1,    -1,    -1,
      -1,    -1,   364,    -1,    -1,    -1,    -1,   369,    -1,    79,
      80,    81,    82,    83,    84,    85,    86,    87,   380,    89,
      90,    91,    92,    93,    94,    -1,   388,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    87,   503,    89,    90,    91,    92,
      93,    94,    -1,    -1,    -1,    -1,   131,   132,   154,   155,
     156,   157,   158,   159,   139,    -1,    -1,    -1,   143,    -1,
      -1,    -1,   147,    -1,    -1,   150,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
     503,    -1,    -1,    -1,   169,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    34,    -1,    -1,    -1,
     185,   186,   187,    -1,   189,    -1,   191,   192,    -1,    -1,
      -1,    -1,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   500
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   509,   510,   133,   142,   166,   167,   198,   201,
     203,   230,   234,   239,   240,   490,   491,   662,   663,   664,
     665,   667,   668,   669,   675,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   716,   727,   728,   729,   730,   781,
     782,   783,   784,   785,   786,   787,   788,   840,   841,   851,
     861,   862,   863,   864,   865,   866,   882,     0,     3,    35,
      45,    47,    48,    70,   131,   133,   135,   137,   139,   140,
     142,   154,   155,   156,   157,   158,   159,   201,   207,   213,
     214,   489,   498,   511,   564,   566,   567,   577,   614,   616,
     617,   619,   620,   633,   636,   646,   647,   700,   703,   717,
     720,   731,   737,   746,   747,   790,   792,   793,   798,   829,
     832,   842,   843,   853,   859,   860,   869,   872,   879,   881,
     883,   884,    13,    15,    16,    17,    18,    19,    20,    21,
      28,    29,    33,    45,    47,    48,    99,   100,   113,   114,
     120,   121,   122,   125,   131,   136,   499,   506,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     561,   562,   563,   582,   598,   600,   601,   602,   604,   606,
      20,    21,   143,   698,   698,   698,   199,   200,   698,   698,
       3,   175,   176,   204,   211,   231,   233,   241,   256,   343,
     427,   442,   152,   173,   175,   176,   235,   236,   237,   238,
      37,   143,   502,   687,   698,    21,   265,   484,   486,   487,
     867,     3,    20,    20,    20,   606,   499,   138,   175,   190,
     488,   160,    20,    21,   175,   537,   139,   211,   212,   213,
     634,   635,   475,   483,   537,   855,   166,   430,   479,   150,
     144,   194,   241,   256,   343,   396,   397,   427,   442,   446,
     495,   745,   828,    20,    46,   621,   137,   141,   142,   145,
     149,   196,   201,   265,   503,   617,   622,   623,   628,   649,
     621,   621,   621,    47,    48,    77,   108,   144,   145,   154,
     155,   156,   157,   167,   170,   171,   214,   240,   241,   248,
     249,   251,   265,   270,   272,   274,   275,   278,   279,   280,
     295,   296,   301,   302,   309,   313,   316,   317,   319,   321,
     325,   326,   328,   503,   622,   738,   739,   744,   621,   350,
     351,   352,   353,   380,   387,   390,   393,   503,   617,   622,
     749,   750,   751,   752,   753,   502,   113,   146,   147,   150,
     161,   335,   503,   622,   624,   621,   621,   621,   211,   265,
     313,   503,   622,   628,   846,   847,   621,   621,   214,   257,
     390,   446,   492,   493,   494,   503,   622,   628,   852,   871,
     145,   493,   503,   622,   873,    15,    20,    30,   499,   505,
     597,   599,   604,    31,   517,    31,    17,    18,   518,   519,
     499,   130,    29,   130,   606,    15,   502,   502,   499,   499,
     499,   499,   499,   499,   499,   101,   102,   103,   104,   587,
     606,    15,    16,    18,    20,   499,   518,   519,   526,   582,
     583,   586,   588,   589,   590,   592,   594,   595,   216,   216,
       5,    46,    51,   105,   106,   108,   109,   110,   111,   112,
     205,   268,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   311,   312,   346,   347,   348,   349,   425,   426,
     440,   441,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     496,   497,   605,   880,     3,     8,     9,    10,    11,    12,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    34,
      37,   143,   502,   650,    21,   538,   538,   698,   698,     3,
      37,   143,   502,   653,    20,    21,   143,   699,     3,   232,
       3,   670,     3,   676,   255,   152,   176,   237,   269,    20,
     145,   237,   379,   394,   395,   666,   176,   237,   666,     3,
       3,     3,     3,     3,     3,     3,     3,    77,   142,   476,
     477,   478,   479,   480,   481,   482,   857,   858,    15,   688,
     538,   867,   867,     3,     3,   430,   868,    23,   578,   565,
      20,    15,    17,    20,    46,   499,   615,   650,    15,    20,
     499,   512,    36,    37,    38,    39,   162,   512,   514,   653,
     498,    21,   208,   498,   485,   854,   143,   502,   856,   215,
     512,   513,   513,    20,   344,   345,   791,   428,    46,    20,
     502,   138,   514,   650,   648,   537,   537,   653,   266,   498,
     502,   626,   498,   498,   502,   502,   502,   215,   282,   294,
     498,    21,    45,   330,    45,   330,    45,   330,    45,   330,
     283,   537,   514,   166,   211,   299,   324,   514,   498,   512,
      17,    18,    20,   515,   733,   515,   732,   266,   271,   273,
     281,   271,   270,   285,   286,   257,   281,   297,   298,   297,
     514,   303,   310,   257,   257,   318,   316,   251,   285,   514,
     327,   329,   512,   498,   502,   742,   498,   502,   615,   514,
     137,   512,   514,   138,   378,   514,   330,   748,   626,   498,
     502,   512,   131,   132,   143,   148,   162,   168,   574,   630,
     162,   630,    20,   629,   162,   150,   498,   498,   502,   502,
     502,    18,    19,    20,   529,   532,   266,   150,   498,   498,
      76,   276,   306,   315,   443,   444,   445,   844,   845,   502,
     850,   502,   502,   166,   512,   322,   150,   514,   271,   514,
     498,   498,   874,   878,   271,   498,     7,   599,   599,   606,
     599,   599,    14,    15,    15,    31,   606,   610,   611,    28,
      29,   130,    29,   558,   558,   629,   606,   606,   606,   606,
     606,   606,    15,   501,   500,   501,    30,   585,   587,   606,
      28,    29,   502,     7,   501,   507,   501,   507,    15,    15,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,    57,    81,    83,   107,   115,   116,
     118,   119,   126,   127,   128,   151,   152,   153,   173,   174,
     176,   651,   652,     3,     3,     3,     3,     3,   151,   202,
     654,   655,     3,   699,     3,     3,     3,   131,   139,   143,
     147,   150,   169,   185,   186,   187,   189,   191,   192,   532,
     574,   673,     3,    20,    70,   131,   139,   140,   150,   666,
     666,   666,   666,   666,   666,   666,   789,   143,   666,   143,
     666,     3,   666,   666,     3,   501,   503,     3,     3,     3,
     868,   512,     3,   606,   499,   575,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    89,    90,    91,    92,    93,
      94,   568,   569,   570,   572,   576,   501,   643,   644,   606,
     498,   606,   513,   498,   512,   209,   210,   537,   857,   498,
     512,    40,    41,    42,   197,   618,   621,    20,   615,   637,
     640,   641,   514,   625,   627,   702,   719,   271,   271,   515,
     498,    77,   331,   498,   498,   271,   323,   514,   308,   514,
     202,   498,   498,    32,   516,    43,   218,   498,   516,    43,
     218,   498,   514,   512,   271,   271,   512,   271,   512,   512,
     514,   271,   514,   138,   514,   498,   514,   514,   514,   514,
     514,   514,   218,   514,   498,   514,   514,   498,   741,   743,
     514,   162,   512,   514,   627,   754,    20,   572,   573,   606,
      37,   512,   632,   169,   632,   632,   629,   797,   831,   514,
     629,    21,   515,   515,    45,   241,   381,   413,   844,   849,
     498,   514,   514,   512,   512,   641,   642,   512,    15,   500,
      46,    15,   501,   500,   130,    29,   559,   560,   500,   501,
     500,   501,   501,   501,   501,   500,   606,   606,   501,     7,
     501,   501,   500,    15,    17,    18,   499,   583,   590,   594,
     218,   218,   499,   501,   503,   501,   503,     3,   573,    20,
      20,   143,    17,    18,    19,    20,   518,   519,   520,   521,
     522,   671,   672,    20,     3,   538,   538,   538,   538,   538,
     538,     3,    20,    57,   137,   266,   277,   350,   385,   386,
     666,   538,   666,   538,   538,   538,   858,     3,   498,   500,
     569,   571,   576,    20,    88,   498,   502,   537,   641,   498,
     500,   500,    21,    41,    42,    41,    42,   503,   498,    29,
     639,   501,   498,   503,   624,   145,   248,   249,   503,   622,
     701,   145,   503,   622,   628,   718,   512,   512,   498,   514,
     502,   514,   734,   512,   498,   498,   514,   498,   514,    20,
     733,   512,   512,   732,   512,   512,   498,   498,   512,   512,
     498,   512,   498,   498,   498,   512,   498,   615,   498,   498,
     498,   498,   498,   498,   498,   498,   512,   498,   498,   498,
      52,   121,   214,   304,   313,   314,   320,   324,   503,   624,
     740,   512,   145,   232,   278,   352,   370,   372,   376,   378,
     382,   383,   503,   755,   762,   765,   163,   631,   514,   498,
      82,   145,   415,   416,   419,   424,   503,   622,   628,   794,
     145,   380,   429,   503,   622,   628,   830,   498,   498,   516,
      45,    15,   534,   535,   514,   512,   514,    20,    71,    72,
      73,    74,    75,    76,    77,    78,    95,    98,   113,   134,
     503,   602,   603,   607,   612,   848,   162,   870,   502,   877,
     599,    18,   610,    29,    29,   556,   557,   606,   606,   606,
     606,   606,   501,   500,   501,    30,   585,   606,   585,    30,
     585,   585,   501,   606,    15,    15,   606,   652,   655,    46,
      17,    18,    34,     3,     3,     3,     3,     3,     3,    15,
     615,   615,   615,   538,     3,   538,     3,     3,     3,   498,
     500,   570,   579,   580,   612,   500,    21,   538,   638,   640,
     498,   704,   710,   704,   711,   515,   715,   498,   721,   726,
     498,   501,   498,   498,    82,   200,   331,   333,   335,   336,
     339,   735,   736,   498,   498,   498,   498,   498,   498,   498,
     498,   498,   498,   498,   498,   267,   322,   166,   305,   150,
     144,   315,   514,    52,   498,   774,   780,   514,   354,   355,
     382,   354,   514,   756,   266,    20,   526,   531,   758,   759,
     757,   384,   514,   498,   387,   775,   164,   165,   166,   167,
      20,   519,   530,   808,   813,   799,   807,   795,   796,   530,
     152,   498,   833,   839,   514,   512,   498,   535,    31,    23,
     499,   499,   606,   606,   606,    23,   499,   605,   880,   498,
     606,   608,   609,   512,   876,    31,    29,    43,    49,    50,
      51,    52,    54,    55,    56,    59,    61,    62,    67,   503,
     541,   542,   543,   544,   546,   554,    68,   503,   542,   543,
     544,   545,   546,   555,   501,   500,   500,   500,   500,   606,
     606,   500,   501,     7,   500,   501,   500,   501,     7,   500,
     501,   501,    15,   500,    18,    45,    47,    48,   154,   155,
     156,   157,   158,   159,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   674,     3,     3,   571,   503,
     612,    17,    18,    20,   518,   519,   533,   642,   502,   709,
      32,   250,   712,   642,   512,   162,   342,   124,   334,   338,
     337,   340,   341,   501,   503,   168,   277,   294,   244,   245,
     514,   514,   277,   306,   307,   629,   267,   641,   776,   512,
     512,   514,   512,   502,   615,   502,   502,   512,   512,   502,
     502,   812,   642,   502,   515,   814,   819,    21,   502,   820,
     825,   514,   642,   162,    15,   606,   611,   602,   498,    96,
     502,   606,   613,    23,    23,    34,   501,   498,   409,   503,
     875,    15,    29,    53,    57,    58,    60,     8,     9,    10,
      23,    24,    25,    99,   100,   512,   539,   547,   548,   549,
      33,   550,   551,   551,   553,   531,   498,   547,   550,   553,
     550,   530,   498,   606,   500,   500,    30,   585,    30,   585,
      30,   585,     7,    30,   585,    30,   585,   503,   709,   708,
     705,    20,   537,   251,   713,   502,   725,   498,   332,   235,
     736,   515,   514,   777,   502,   779,   767,   760,   767,   763,
     811,   810,   502,   806,   815,   821,   502,   838,   512,   498,
     500,   880,   502,   581,   612,   596,   498,   606,   606,   606,
     121,   122,   125,   130,   131,   609,   515,   498,     7,   512,
      11,    12,   540,   501,    12,   501,   540,   512,    63,    64,
      65,    66,   552,   501,   540,    69,   500,   500,   500,   500,
     501,     7,   500,   500,   500,   501,   499,   500,     7,   500,
     500,     7,   500,   705,   170,   171,   195,   242,   243,   246,
     247,   252,   503,   656,   658,   659,   706,   515,   248,   714,
     724,   722,   775,   778,   503,   531,   768,   769,   232,   354,
     371,   503,   761,   503,   215,   252,   259,   356,   357,   358,
     503,   656,   764,   408,   409,   412,   413,   414,   503,   809,
     805,   804,   818,   824,   837,   834,   500,   579,    97,     6,
      15,    16,   499,   503,   582,   584,   586,   588,   589,   591,
     593,   613,   498,   498,   499,   499,   499,   498,   499,   512,
     549,   539,   548,   551,   551,    31,   551,   551,    15,    30,
     585,    30,   585,   585,     7,   585,   537,   514,   502,   244,
     245,   245,   513,   512,   148,   178,   253,   254,   707,   502,
     498,   514,    43,    52,    57,   162,   244,   245,   258,   259,
     260,   265,   503,   723,    57,   215,   237,   241,   244,   245,
     252,   259,   264,   265,   266,   317,   326,   352,   354,   356,
     357,   358,   364,   369,   380,   388,   503,   656,   766,   371,
     377,   770,   514,   512,   514,   498,   512,   148,   253,   367,
     512,   512,   281,   187,   512,   498,   411,   411,   514,   514,
     514,   498,    82,   211,   216,   242,   266,   278,   399,   400,
     404,   405,   407,   415,   416,   503,   800,   411,   417,   503,
     816,   411,   418,   503,   822,    43,   171,   241,   244,   245,
     252,   257,   260,   265,   294,   317,   380,   430,   431,   432,
     433,   434,   436,   503,   656,   835,   498,   503,   581,   579,
     606,     7,   501,   504,   500,   606,   606,   606,   606,   512,
     512,   512,   512,   552,   552,   500,   500,   500,   501,   500,
     499,   500,   657,   658,   246,   246,   246,   180,   181,   178,
      46,    75,   138,   172,   177,   193,   660,   512,   267,   261,
     262,   512,   263,    61,    62,   206,   264,   645,   512,   246,
     246,   266,   498,   359,   360,   361,   362,   363,   364,   365,
     366,   512,   502,   514,   263,    61,   264,   645,   148,   253,
     367,   512,   512,   266,   391,   318,   361,   514,   512,   512,
     281,   187,   512,   389,   512,   381,   359,   498,   512,   498,
     512,   512,   512,   512,   402,   813,   113,   402,   411,   398,
     281,   398,   403,   113,   411,   514,   401,   271,   406,   267,
     251,   801,   251,   802,   498,   410,   512,   826,   814,   817,
     498,   826,   820,   823,   498,   512,   514,   514,   263,    61,
     264,   645,   148,   180,   367,   439,   836,   512,   271,   266,
     438,   515,   318,   381,   271,   271,   330,   359,   373,   512,
     435,   437,   498,   500,   499,   584,   591,   579,   498,   500,
     500,   500,   500,    31,    31,   585,   585,   503,   498,   513,
     513,   513,   180,   181,    21,   536,    46,   172,   512,   536,
     178,   179,   661,    46,   172,   503,   154,   155,   512,   512,
     512,   512,   512,   513,   513,   514,   771,   374,   375,   512,
     512,   512,   514,   392,   245,   514,   514,   512,   512,   514,
     512,   514,   420,   827,   827,   271,   421,   422,   423,   803,
     271,   512,   246,   512,   246,   512,   803,   512,   514,   512,
     512,   162,   514,   819,   514,   825,   512,   512,   512,   512,
     512,   514,   514,   245,   514,   512,   512,   512,   514,   514,
     514,   606,   498,   498,   498,   498,   512,   512,   500,   501,
     657,   498,   536,   536,   498,   498,   180,   181,   182,   183,
     184,   180,   181,   182,   183,   184,   498,   536,   536,   515,
     515,   503,   515,   773,   514,   373,   514,   512,   512,   827,
     512,   512,   827,   512,   373,   585,   660,   498,   498,   660,
     660,   660,   498,   498,   368,   772,   501,   660,   660,   660,
     660,   498,   585,   500
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   508,   509,   509,   510,   510,   511,   512,   512,   512,
     513,   513,   513,   514,   514,   514,   514,   514,   514,   515,
     515,   515,   516,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   526,   527,   527,   528,   528,   529,
     529,   529,   529,   529,   529,   530,   530,   531,   531,   532,
     532,   533,   533,   533,   533,   533,   534,   535,   535,   536,
     537,   537,   538,   538,   539,   539,   539,   539,   539,   539,
     539,   539,   540,   540,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   542,   543,   544,   545,   546,   546,   547,
     547,   547,   547,   548,   548,   549,   549,   550,   550,   550,
     551,   551,   552,   552,   552,   552,   553,   553,   553,   554,
     554,   554,   554,   555,   555,   555,   555,   555,   555,   556,
     556,   557,   557,   558,   559,   560,   561,   562,   563,   563,
     565,   564,   566,   567,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     569,   570,   570,   571,   571,   572,   573,   573,   574,   575,
     575,   576,   578,   577,   579,   579,   580,   580,   581,   581,
     582,   582,   583,   583,   583,   583,   583,   584,   584,   584,
     584,   585,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   587,   587,   587,   587,   588,   588,   588,   589,
     589,   589,   589,   589,   589,   589,   589,   590,   590,   590,
     590,   590,   591,   591,   591,   591,   591,   592,   592,   593,
     593,   594,   594,   594,   594,   595,   595,   596,   596,   596,
     597,   597,   598,   599,   599,   599,   599,   599,   599,   600,
     600,   600,   600,   600,   600,   600,   600,   600,   600,   601,
     601,   601,   601,   602,   603,   604,   605,   605,   605,   605,
     605,   605,   605,   605,   605,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   607,   607,   607,   607,   607,   607,   608,   609,   609,
     609,   610,   610,   611,   611,   612,   612,   612,   612,   612,
     612,   612,   612,   612,   612,   612,   612,   612,   612,   612,
     612,   612,   613,   614,   614,   615,   615,   615,   615,   616,
     617,   617,   617,   617,   617,   617,   617,   617,   617,   617,
     618,   618,   619,   620,   620,   621,   621,   621,   621,   622,
     622,   622,   622,   622,   622,   622,   623,   624,   624,   624,
     624,   624,   624,   624,   624,   625,   625,   626,   626,   627,
     628,   629,   630,   630,   630,   630,   631,   631,   631,   631,
     631,   632,   632,   633,   633,   634,   634,   634,   634,   635,
     635,   635,   635,   635,   635,   635,   635,   636,   637,   638,
     638,   639,   639,   640,   641,   641,   642,   643,   644,   645,
     645,   646,   647,   647,   647,   647,   647,   648,   649,   650,
     650,   650,   651,   651,   652,   652,   652,   652,   652,   652,
     653,   653,   653,   654,   654,   655,   655,   656,   656,   657,
     657,   658,   658,   659,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   661,   662,   663,   664,   665,   666,   666,   667,
     668,   669,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   671,   671,   671,
     671,   671,   671,   671,   671,   672,   672,   672,   672,   673,
     673,   673,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   675,   676,   676,   676,   676,   676,   676,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   687,   687,   688,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   698,   698,   699,   699,   699,
     700,   701,   701,   701,   701,   702,   702,   703,   704,   705,
     706,   706,   706,   706,   706,   706,   706,   706,   707,   707,
     707,   707,   707,   707,   708,   708,   709,   709,   710,   711,
     712,   712,   712,   713,   713,   714,   714,   715,   716,   717,
     718,   718,   718,   719,   719,   720,   721,   722,   723,   723,
     723,   723,   723,   723,   723,   723,   723,   723,   723,   723,
     723,   723,   723,   724,   724,   725,   725,   726,   727,   728,
     729,   730,   731,   732,   732,   732,   733,   733,   733,   734,
     734,   735,   735,   736,   736,   736,   736,   736,   736,   736,
     736,   736,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   738,   738,   738,   738,   738,   738,
     738,   738,   738,   738,   738,   738,   739,   740,   740,   740,
     740,   740,   740,   740,   740,   740,   740,   740,   740,   740,
     740,   740,   740,   741,   741,   742,   742,   743,   744,   745,
     745,   745,   746,   747,   747,   748,   748,   749,   750,   751,
     751,   751,   751,   751,   751,   751,   751,   751,   751,   751,
     752,   753,   754,   754,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   756,   755,   757,   755,   755,   755,   755,
     758,   758,   759,   760,   760,   761,   761,   761,   762,   762,
     763,   763,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   765,   766,   766,   766,   766,   766,   766,
     766,   766,   766,   766,   766,   766,   766,   766,   766,   766,
     766,   766,   766,   766,   766,   766,   766,   766,   766,   766,
     766,   766,   766,   766,   766,   766,   766,   766,   766,   766,
     766,   766,   767,   767,   768,   769,   770,   770,   770,   771,
     771,   772,   772,   773,   774,   775,   775,   777,   776,   778,
     778,   779,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   789,   789,   789,   789,   789,   789,   789,
     789,   791,   790,   792,   792,   792,   792,   793,   794,   794,
     794,   794,   795,   794,   796,   794,   794,   794,   797,   797,
     798,   799,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   800,   800,   801,   800,
     802,   800,   800,   800,   803,   803,   803,   804,   805,   805,
     806,   806,   807,   808,   809,   809,   809,   809,   809,   810,
     811,   811,   812,   812,   813,   814,   815,   816,   816,   816,
     817,   818,   818,   819,   819,   820,   821,   822,   822,   822,
     823,   824,   824,   825,   825,   826,   826,   827,   827,   828,
     828,   829,   830,   830,   830,   830,   830,   830,   831,   831,
     832,   833,   834,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   836,   836,
     836,   836,   837,   837,   838,   838,   839,   840,   841,   842,
     843,   843,   843,   843,   843,   843,   844,   844,   844,   844,
     844,   844,   845,   845,   846,   847,   847,   847,   847,   847,
     847,   847,   847,   847,   848,   849,   849,   850,   850,   851,
     852,   852,   853,   854,   854,   855,   855,   855,   856,   856,
     857,   857,   858,   858,   858,   858,   858,   858,   858,   858,
     858,   859,   859,   860,   860,   860,   860,   861,   862,   863,
     864,   865,   866,   867,   867,   868,   868,   868,   869,   870,
     870,   871,   871,   871,   871,   871,   871,   871,   872,   873,
     873,   873,   874,   875,   876,   876,   877,   877,   878,   879,
     879,   879,   879,   879,   879,   879,   879,   879,   879,   879,
     879,   879,   879,   879,   880,   880,   880,   880,   880,   880,
     880,   880,   880,   880,   880,   880,   880,   880,   880,   880,
     880,   880,   880,   880,   880,   880,   880,   880,   880,   880,
     880,   880,   880,   880,   880,   880,   880,   880,   880,   880,
     880,   880,   880,   880,   880,   880,   880,   880,   880,   880,
     880,   880,   880,   880,   880,   880,   880,   881,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   883,   883,   883,
     884,   884
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     0,     2,     2,     2,     3,     7,     2,     2,
       5,     5,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       2,     1,     1,     1,     2,     1,     1,     1,     1,     2,
       4,     1,     3,     1,     3,     1,     3,     4,     6,     6,
       0,     1,     1,     1,     1,     1,     2,     4,     4,     2,
       2,     2,     2,     2,     4,     2,     2,     2,     2,     0,
       3,     0,     3,     0,     0,     0,     6,     6,     1,     1,
       0,     4,     2,     6,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     3,     1,     3,     1,     1,     1,     2,     3,
       2,     4,     0,     5,     0,     1,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     3,     1,     1,     3,     1,
       1,     1,     5,     7,     5,     7,     9,     7,     5,     7,
       5,    11,     1,     1,     2,     1,     7,     9,     7,     7,
       9,     7,     9,     7,     9,     7,    15,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     3,     1,     3,     1,
       3,     1,     2,     2,     6,     1,     3,     0,     4,     3,
       1,     3,     3,     2,     4,     2,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     4,     1,     1,     1,     1,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     6,     3,     3,     3,     3,
       3,     5,     7,     6,     6,     6,     6,     4,     8,     4,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       8,     7,     0,     4,     5,     1,     3,     1,     1,     5,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     4,     1,     1,     0,     1,     2,     3,     0,
       2,     2,     2,     3,     2,     2,     1,     2,     2,     2,
       3,     3,     3,     2,     4,     0,     3,     0,     3,     0,
       3,     1,     2,     1,     1,     1,     0,     2,     2,     2,
       2,     2,     1,     3,     3,     1,     1,     1,     1,     2,
       4,     3,     4,     4,     3,     4,     4,     3,     0,     1,
       2,     0,     1,     3,     1,     3,     1,     0,     2,     2,
       2,     2,     3,     3,     3,     3,     5,     0,     3,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     4,     1,     0,
       3,     4,     1,     2,     0,     5,     5,     5,     5,     4,
       4,     4,     4,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     4,     5,     1,     0,     3,
       4,     4,     0,     2,     3,     3,     3,     3,     2,     2,
       2,     2,     3,     5,     3,     2,     2,     1,     1,     1,
       1,     2,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       1,     1,     3,     0,     1,     4,     4,     4,     3,     4,
       4,     4,     4,     2,     1,     1,     1,     1,     0,     1,
       2,     1,     2,     2,     2,     0,     3,     5,     0,     0,
       2,     4,     4,     4,     2,     2,     2,     1,     1,     1,
       2,     2,     3,     3,     0,     3,     0,     3,     4,     3,
       0,     2,     2,     0,     2,     0,     2,     4,     5,     2,
       1,     1,     2,     0,     3,     5,     0,     0,     0,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     2,     3,
       3,     4,     4,     0,     3,     0,     3,     4,     6,     6,
       6,     6,     2,     0,     3,     3,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     4,     6,     4,     6,     4,
       6,     5,     5,     4,     5,     5,     6,     3,     3,     4,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     6,     5,     6,     8,     6,     6,     6,     5,     6,
       4,     4,     4,     4,     5,     5,     6,     5,     5,     5,
       6,     5,     5,     4,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     4,     3,
       3,     3,     3,     3,     2,     2,     2,     3,     4,     3,
       3,     3,     3,     0,     3,     0,     3,     0,     3,     1,
       2,     2,     2,     3,     3,     0,     1,     2,     3,     1,
       1,     2,     2,     3,     2,     4,     3,     2,     3,     1,
       2,     4,     0,     3,     2,     1,     2,     3,     3,     3,
       3,     2,     3,     0,     5,     0,     5,     2,     2,     1,
       4,     1,     1,     0,     3,     2,     2,     2,     5,     2,
       0,     3,     0,     2,     2,     3,     2,     2,     3,     2,
       2,     2,     1,     3,     2,     2,     2,     2,     2,     2,
       3,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     2,     3,     2,     3,     3,     4,     4,     2,
       2,     2,     3,     3,     3,     2,     3,     3,     3,     4,
       2,     1,     0,     2,     3,     1,     0,     1,     2,     0,
       2,     0,     1,     3,     0,     0,     2,     0,     3,     0,
       3,     0,     3,     3,     4,     6,     6,     6,     7,     6,
       7,     5,     0,     2,     3,     2,     3,     3,     2,     3,
       2,     0,     4,     2,     3,     3,     5,     2,     1,     1,
       2,     2,     0,     3,     0,     3,     2,     3,     0,     3,
       5,     0,     4,     4,     3,     2,     3,     3,     3,     3,
       4,     4,     4,     3,     3,     4,     4,     2,     0,     3,
       0,     3,     3,     3,     1,     1,     1,     0,     0,     3,
       0,     3,     4,     1,     2,     2,     2,     4,     4,     0,
       0,     3,     0,     3,     3,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     2,     0,     2,     1,
       2,     2,     1,     1,     2,     4,     2,     2,     0,     3,
       5,     0,     0,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     4,     3,     2,     2,     1,     1,     1,
       1,     1,     0,     3,     0,     3,     4,     6,     6,     2,
       3,     3,     3,     5,     5,     4,     3,     2,     3,     3,
       3,     3,     1,     2,     2,     2,     3,     5,     1,     2,
       2,     2,     2,     2,     1,     0,     2,     0,     3,     4,
       3,     2,     4,     2,     0,     1,     2,     1,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     3,     3,     4,     3,     3,     4,     5,     3,
       3,     4,     2,     0,     1,     0,     1,     2,     2,     0,
       2,     1,     1,     2,     3,     2,     3,     4,     2,     1,
       2,     3,     0,     2,     0,     3,     0,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       2,     2,     2,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 1051 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4779 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 1052 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4785 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 1065 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4796 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 1075 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4802 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 1076 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4810 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 1083 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.time) = (yyvsp[-1].i) S_; }
#line 4816 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 1084 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.time) = (yyvsp[-1].i) MS_; }
#line 4822 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 1085 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.time) = (yyvsp[-1].i) US_; }
#line 4828 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 1091 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4834 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 1092 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4840 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 1093 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4846 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 1094 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4852 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 1095 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4858 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 1096 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4864 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 1103 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = ipa_from_ip4((yyvsp[0].ip4)); }
#line 4870 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 1104 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = ipa_from_ip6((yyvsp[0].ip6)); }
#line 4876 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 1105 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).ip;
   }
#line 4885 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 1112 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4891 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 1113 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4897 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 1120 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4906 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 1127 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  net_fill_ip4(&((yyval.net)), (yyvsp[-1].ip4), (yyvsp[0].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
}
#line 4919 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 1137 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
}
#line 4935 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 1150 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if ((yyvsp[-4].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[-4].i));

  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-6].ip6), (yyvsp[-4].i), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
}
#line 4957 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 1169 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[0].net)), net4_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 4966 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 1175 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[0].net)), net6_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 4975 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 1181 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[-4].net)), net4_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net4_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 4986 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 1189 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[-4].net)), net6_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net6_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 4997 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 1197 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_mpls((yyval.net_ptr), (yyvsp[0].i));
}
#line 5006 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 1207 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length); net_copy((yyval.net_ptr), &((yyvsp[0].net))); }
#line 5012 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1220 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP6))
       cf_error("IPv6 network expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 5022 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 1229 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       cf_error("IP network expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 5032 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 1238 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
   }
#line 5042 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1248 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 5048 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1249 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 5054 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1250 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[0].s)).ip);
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
     else
       cf_error("IP address or network expected");
   }
#line 5067 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1261 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[0].i);
}
#line 5077 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1269 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[-2].mls)->stack[(yyvsp[-2].mls)->len++] = (yyvsp[0].i);
    (yyval.mls) = (yyvsp[-2].mls);
  }
#line 5088 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1278 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_time((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   }
#line 5098 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1287 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 5107 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1295 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 5113 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1304 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_TRUE; }
#line 5119 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1305 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_EQ;  }
#line 5125 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1306 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_NEQ; }
#line 5131 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1307 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_LT;  }
#line 5137 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1308 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_LEQ; }
#line 5143 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1309 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_GT;  }
#line 5149 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1310 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_GEQ; }
#line 5155 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1311 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_FALSE; }
#line 5161 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1315 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_OR; }
#line 5167 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1316 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_AND; }
#line 5173 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1320 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; }
#line 5179 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1321 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; }
#line 5185 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1322 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_PORT; }
#line 5191 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1323 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_DST_PORT; }
#line 5197 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1324 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_SRC_PORT; }
#line 5203 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1325 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; }
#line 5209 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1326 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_ICMP_CODE; }
#line 5215 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1327 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; }
#line 5221 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1328 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_DSCP; }
#line 5227 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1331 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, (yyvsp[0].i32)); }
#line 5233 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1332 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); }
#line 5239 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1333 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); }
#line 5245 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1334 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, FLOW_TYPE_LABEL); }
#line 5251 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1337 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_DST_PREFIX; }
#line 5257 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1338 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; }
#line 5263 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1342 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 5272 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1346 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-2].i32) | (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 5281 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1355 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[0].i));
   }
#line 5290 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1359 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[-2].i));
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[-2].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[0].i));
   }
#line 5301 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1373 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 5310 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1377 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-4].i32) | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 5319 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1381 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i)); /* AND */
   }
#line 5328 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1388 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0x00; }
#line 5334 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1389 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0x02; }
#line 5340 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1393 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 1; }
#line 5346 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1394 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 2; }
#line 5352 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1395 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 4; }
#line 5358 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1396 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 8; }
#line 5364 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1400 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 5372 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1403 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_builder_add_val_mask(this_flow, (yyvsp[-2].i32), ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 5380 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1406 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32)); /* AND */
   }
#line 5388 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1412 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[0].net)));
   }
#line 5397 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1422 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[0].net)), 0);
   }
#line 5406 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1426 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) > (yyvsp[-2].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[-3].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[-2].net)), (yyvsp[0].i));
   }
#line 5417 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1449 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (this_flow == NULL)
    this_flow = flow_builder_init(&root_pool);
  else
    flow_builder_clear(this_flow);
}
#line 5428 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1456 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_flow->ipv6 = 0; }
#line 5434 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1457 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_flow->ipv6 = 1; }
#line 5440 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1460 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
}
#line 5449 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1466 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
}
#line 5458 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1477 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5464 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1478 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5475 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1487 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5481 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1491 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (!((yyvsp[-3].s)->class & SYM_FUNCTION))
    cf_error("Function expected");

  struct f_bt_test_suite *t = cfg_alloc(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-3].s)->def;
  t->fn_name = (yyvsp[-3].s)->name;
  t->dsc = (yyvsp[-1].t);

  add_tail(&new_config->tests, &t->n);
 }
#line 5497 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1505 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5503 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1506 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5509 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1507 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5515 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1508 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_RD; }
#line 5521 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1509 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_NET; }
#line 5527 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1510 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5533 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1511 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5539 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1512 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5545 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1513 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 5551 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1514 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5557 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1515 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5563 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1516 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5569 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1517 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5575 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1518 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5581 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1519 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 5587 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1520 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5611 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1542 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5624 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1553 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5630 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1554 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5639 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1561 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5645 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1562 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5654 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1569 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5665 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1578 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5674 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1586 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5697 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1607 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5703 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1608 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5709 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1612 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5723 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1624 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5732 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1627 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 5743 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1640 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5749 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1641 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5755 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1644 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5761 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1645 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5767 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1649 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5775 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1652 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5783 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1661 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 5789 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1662 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 5795 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1675 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5801 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1676 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5807 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1677 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5813 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1678 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 5822 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1682 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 5832 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1690 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5838 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1691 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5844 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1692 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5850 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1693 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5856 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1697 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5862 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1700 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5868 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1701 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5874 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1702 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 5880 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1703 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5886 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1704 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5892 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1705 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 5898 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1706 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5904 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1707 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5910 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1708 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 5916 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1710 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 5922 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1714 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5928 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1715 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5934 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1716 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5940 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1717 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5946 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1721 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5952 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1722 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5958 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1723 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5964 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1727 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5970 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1728 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5976 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1729 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 5982 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1730 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 5988 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1731 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 5994 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1732 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6000 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1733 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6006 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1735 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6012 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1742 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6018 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1743 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6024 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1750 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6030 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1751 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6036 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1756 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6042 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1761 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6048 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1765 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).net = (yyvsp[0].net); (yyval.px).lo = (yyvsp[0].net).pxlen; (yyval.px).hi = (yyvsp[0].net).pxlen; }
#line 6054 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1766 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = (yyvsp[-1].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[-1].net).type]; }
#line 6060 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1767 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[-1].net).pxlen; }
#line 6066 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1768 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.px).net = (yyvsp[-5].net); (yyval.px).lo = (yyvsp[-3].i); (yyval.px).hi = (yyvsp[-1].i);
     if (((yyvsp[-3].i) > (yyvsp[-1].i)) || ((yyvsp[-1].i) > net_max_prefix_length[(yyvsp[-5].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 6076 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1776 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 6082 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1777 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 6088 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1780 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6094 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1781 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6106 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1788 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6118 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1800 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6124 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1801 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6130 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1805 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6136 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1809 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6142 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1810 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6148 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1811 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6154 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1812 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6160 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1813 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6166 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1814 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6172 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1818 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6178 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1819 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6184 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1820 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6190 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1821 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6196 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1822 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6202 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1823 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); val->type = T_RD; val->val.ec = (yyvsp[0].i64); (yyval.x)->a1.p = val; }
#line 6208 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1824 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); val->type = T_NET; val->val.net = (yyvsp[0].net_ptr); (yyval.x)->a1.p = val; }
#line 6214 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1825 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6220 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1826 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6226 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1827 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6232 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1831 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6238 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1832 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6244 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1833 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6250 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1834 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 6256 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1848 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6280 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1870 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6295 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1882 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 6301 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1883 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 6307 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1884 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	0); }
#line 6313 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1885 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 6319 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1886 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 6325 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1887 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 6331 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1888 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 6337 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1889 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 6343 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1890 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 6349 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1894 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6355 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1895 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6361 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1896 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6367 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1897 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6373 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1898 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6379 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1899 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6385 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1900 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6391 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1901 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6397 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1902 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6403 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1903 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6409 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1904 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6415 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1905 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6421 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1906 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6427 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1907 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6433 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1908 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6439 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1909 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 6445 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1910 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6451 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1912 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6457 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1913 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6463 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1914 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6469 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1916 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 6475 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1918 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 6481 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1920 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 6487 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1922 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IS_V4); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6493 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1923 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_TYPE); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6499 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1924 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6505 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1925 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROUTE_DISTINGUISHER); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_RD; }
#line 6511 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1926 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6517 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1927 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROA_MAXLEN); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6523 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1928 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROA_ASN); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6529 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1929 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6535 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1930 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6541 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1931 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6547 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1932 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6553 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1942 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 6559 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1943 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 6565 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1944 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 6571 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1945 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 6577 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1946 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6583 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1947 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6589 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1948 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6595 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1949 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6601 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1951 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].r), NULL, NULL); }
#line 6607 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1952 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].r), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6613 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1954 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {  (yyval.x) = f_new_inst(FI_FORMAT); (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6619 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1959 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1981 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1982 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1983 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1984 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1985 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6673 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1986 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6679 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1990 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6685 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1993 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6691 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1994 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6697 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1995 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6708 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2003 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6719 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2009 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6730 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2017 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6736 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2018 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6742 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2022 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6752 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2027 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6765 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2035 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6778 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2043 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6788 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2048 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6797 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2052 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6808 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2058 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6817 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2062 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 6827 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2067 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6833 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2068 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6839 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2069 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6849 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2075 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 6855 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2076 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 6861 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2077 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 6867 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2078 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 6873 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2079 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 6879 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2080 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = assert_done((yyvsp[-3].x), (yyvsp[-4].t) + 1, (yyvsp[-2].t) - 1); }
#line 6885 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2084 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.t) = cf_text;
}
#line 6893 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2095 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 6899 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2096 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 6905 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2100 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 6911 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2101 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 6917 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2102 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = ip4_to_u32((yyvsp[0].ip4)); }
#line 6923 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2103 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 6936 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2114 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 6942 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2120 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_IP4; }
#line 6948 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2121 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_IP6; }
#line 6954 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2122 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_IP6_SADR; }
#line 6960 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2123 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_VPN4; }
#line 6966 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2124 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_VPN6; }
#line 6972 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2125 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_ROA4; }
#line 6978 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2126 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_ROA6; }
#line 6984 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2127 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_FLOW4; }
#line 6990 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2128 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_FLOW6; }
#line 6996 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2129 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = NET_MPLS; }
#line 7002 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2139 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7008 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2140 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7014 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2143 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s), (yyvsp[-3].i));
   cf->sorted = (yyvsp[0].i);
   }
#line 7024 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2155 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 7030 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2156 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 7036 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2160 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 7047 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2166 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 7056 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2170 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 7070 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2179 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 7082 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2190 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 7088 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2191 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 7094 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2192 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 7100 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2193 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 7106 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2194 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 7112 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2195 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); }
#line 7118 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2200 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
}
#line 7126 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2205 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if (this_channel->net_type && ((yyvsp[0].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[0].r);
   }
#line 7136 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2210 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->in_filter = (yyvsp[0].f); }
#line 7142 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2211 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->out_filter = (yyvsp[0].f); }
#line 7148 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2212 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->rx_limit = (yyvsp[0].cl); }
#line 7154 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2213 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->in_limit = (yyvsp[0].cl); }
#line 7160 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2214 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->out_limit = (yyvsp[0].cl); }
#line 7166 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2215 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->preference = (yyvsp[0].i); check_u16((yyvsp[0].i)); }
#line 7172 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2216 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel->in_keep_filtered = (yyvsp[0].i); }
#line 7178 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2230 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 7189 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2241 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 7198 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2248 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 7204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2250 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 7210 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2251 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 7216 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2255 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 7222 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2256 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 7228 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2257 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 7234 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2258 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 7240 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2259 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 7246 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2263 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[-1].i), (yyval.cl).action = (yyvsp[0].i) }; }
#line 7252 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2264 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.cl) = (struct channel_limit){}; }
#line 7258 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2270 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 7264 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2271 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 7270 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2278 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 7276 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2279 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 7282 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2280 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 7288 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2281 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 7294 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2285 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 7300 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2286 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (s64) (yyvsp[-1].i) S_}; }
#line 7306 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2287 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = TM_ISO_SHORT_S; }
#line 7312 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2288 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_SHORT_MS; }
#line 7318 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2289 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_SHORT_US; }
#line 7324 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2290 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = TM_ISO_LONG_S; }
#line 7330 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2291 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_LONG_MS; }
#line 7336 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2292 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_LONG_US; }
#line 7342 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2303 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 7352 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2311 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); /* this_ipn->prefix stays zero */ }
#line 7358 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2312 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].net); }
#line 7364 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2316 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 7370 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2317 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 7376 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2331 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 7382 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2333 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 7392 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2345 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if ((yyvsp[0].i) > 255) cf_error("TX class must be in range 0-255"); }
#line 7398 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2346 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if ((yyvsp[0].i) > 63)  cf_error("TX DSCP must be in range 0-63"); }
#line 7404 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2352 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 7413 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2363 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 7419 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2367 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 7429 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2381 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 7435 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2382 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7441 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2383 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7447 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2388 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7453 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2392 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 7459 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2393 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 7465 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2394 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 7471 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2395 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 7477 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2396 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 7483 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2397 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 7489 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2403 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 7495 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2404 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7501 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2405 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7507 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2410 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7513 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2414 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 7519 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2415 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 7525 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2436 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
	this_p_list = cfg_alloc(sizeof(list));
	init_list(this_p_list);
	password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 7547 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2456 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { }
#line 7553 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2457 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 7559 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2458 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 7565 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2459 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 7571 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2460 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 7577 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2461 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 7583 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2462 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 7589 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2463 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 7595 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2464 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 7601 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2468 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 7607 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2469 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 7613 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2470 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 7619 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2471 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 7625 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2472 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 7631 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2473 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 7637 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2474 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 7643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2475 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 7649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2476 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 7655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2477 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 7661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2484 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 7667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2487 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 7673 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2490 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 7679 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2493 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 7685 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2497 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 7691 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2501 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 7697 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2504 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 7703 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2508 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 7709 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2511 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 7719 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2516 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
   }
#line 7729 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2521 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->show_for = 1;
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
   }
#line 7740 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2527 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     rt_show_add_table((yyval.ra), ((struct rtable_config *)(yyvsp[0].s)->def)->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 7751 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2533 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[-2].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   }
#line 7763 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2540 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 7773 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2545 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 7783 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2550 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 7792 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2554 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 7801 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2558 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 7810 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2562 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 7825 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2572 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[-2].s)->def;
     (yyval.ra) = (yyvsp[-4].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if ((yyvsp[-2].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-3].i);
     (yyval.ra)->export_channel = proto_find_channel_by_name(c->proto, (yyvsp[0].t));
     if (!(yyval.ra)->export_channel) cf_error("Export channel not found");
     (yyval.ra)->running_on_config = c->proto->cf->global;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 7841 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2583 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 7855 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2592 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 7864 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2596 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 7873 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2603 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[0].net));
  }
#line 7882 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2610 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 7891 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2614 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 7900 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2618 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-2].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH);
  }
#line 7909 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2622 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[0].s)).ip);
     }
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[0].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network expected");
   }
#line 7925 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2638 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 7931 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2639 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 7937 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2642 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 7943 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2643 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 7949 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2644 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 7955 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2649 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv4"; }
#line 7961 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2650 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv4-mc"; }
#line 7967 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2651 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv4-mpls"; }
#line 7973 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2652 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6"; }
#line 7979 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2653 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6-mc"; }
#line 7985 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2654 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6-mpls"; }
#line 7991 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2655 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6-sadr"; }
#line 7997 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2656 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "vpn4"; }
#line 8003 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2657 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "vpn4-mc"; }
#line 8009 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2658 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "vpn4-mpls"; }
#line 8015 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2659 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "vpn6"; }
#line 8021 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2660 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "vpn6-mc"; }
#line 8027 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2661 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "vpn6-mpls"; }
#line 8033 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2662 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "roa4"; }
#line 8039 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2663 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "roa6"; }
#line 8045 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2664 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "flow4"; }
#line 8051 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2665 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "flow6"; }
#line 8057 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2666 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "mpls"; }
#line 8063 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2667 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "pri"; }
#line 8069 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2668 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = "sec"; }
#line 8075 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2673 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 8081 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2676 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 8089 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2679 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 8095 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2680 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 8101 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2681 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 8107 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2682 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 8113 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2683 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 8119 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2684 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 8125 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2690 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 8131 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2692 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 8137 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2694 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 8143 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2696 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 8149 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2698 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 8155 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2700 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 8161 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2702 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 8167 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2704 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 8173 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2707 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 8179 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2710 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 8188 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2716 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 8194 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2717 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8200 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2718 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 8206 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2722 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 8212 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2723 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 8221 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2730 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 8227 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2732 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 8233 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2734 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 8239 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2736 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 8245 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2738 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 8251 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2740 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 8257 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2744 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 8263 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2748 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 8269 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2751 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 8275 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2754 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 8281 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2755 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 8287 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2756 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 8293 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2760 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 8299 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2761 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 8305 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2762 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 8311 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2771 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 8325 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2798 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 8342 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2812 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 8365 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2832 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 8371 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2833 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].time); }
#line 8377 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2834 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 8383 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2835 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].time); }
#line 8389 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2836 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 8395 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2837 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 8401 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2838 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 8407 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2839 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {}
#line 8413 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2843 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 8419 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2844 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 8425 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2845 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 8431 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2846 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 8437 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2847 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 8443 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2848 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 8449 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2866 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 8455 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2870 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 8461 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2871 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 8467 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2872 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 8473 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2876 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 8479 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2877 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 8485 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2881 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8491 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2882 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 8497 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2886 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 8517 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2905 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 8523 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2911 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
}
#line 8533 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2933 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 8549 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2947 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);
}
#line 8577 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2973 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8583 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2974 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 8589 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2975 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->limit = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>16)) cf_error("Limit must be in range 1-16"); }
#line 8595 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2976 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 8601 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2977 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 8607 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2978 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->hello_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); }
#line 8613 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2979 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->update_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); }
#line 8619 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2980 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 8625 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2981 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 8631 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2982 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 8637 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2983 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 8643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2984 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 8649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2985 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->next_hop_ip4 = (yyvsp[0].a); if (!ipa_is_ip4((yyvsp[0].a))) cf_error("Must be an IPv4 address"); }
#line 8655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2986 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->next_hop_ip6 = (yyvsp[0].a); if (!ipa_is_ip6((yyvsp[0].a))) cf_error("Must be an IPv6 address"); }
#line 8661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 3007 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { babel_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 8667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 3010 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { babel_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 8673 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3013 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { babel_show_entries(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 8679 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3016 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { babel_show_routes(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 8685 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 3021 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
     BGP_CFG->check_link = -1;
   }
#line 8714 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 3049 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8720 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3050 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[0].i); }
#line 8726 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3055 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8732 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3056 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 8738 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3061 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 8744 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3062 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 8750 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 3067 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8756 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3071 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 0; }
#line 8762 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 3072 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 1; }
#line 8768 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 3073 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 2; }
#line 8774 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3074 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 3; }
#line 8780 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 3075 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 4; }
#line 8786 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 3076 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 5; }
#line 8792 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 3077 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 6; }
#line 8798 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 3078 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 7; }
#line 8804 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3079 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 8; }
#line 8810 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3087 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     BGP_CFG->local_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 8819 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3092 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 8830 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3098 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 8836 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3099 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 8842 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3100 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = (yyvsp[-1].i); }
#line 8848 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 3101 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = (yyvsp[-1].i); }
#line 8854 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 3102 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->confederation = (yyvsp[-1].i); }
#line 8860 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 3103 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->confederation_member = (yyvsp[-1].i); }
#line 8866 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 3104 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 8872 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 3105 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 8878 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 3106 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 8884 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 3107 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 8890 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 3108 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 8896 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 3109 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->strict_bind = (yyvsp[-1].i); }
#line 8902 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3110 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 8908 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3111 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 8914 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3112 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 8920 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3113 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 8926 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3114 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 8932 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3115 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 8938 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 3116 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 8944 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3117 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_ip = (yyvsp[-1].a); }
#line 8950 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 3118 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 8956 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 3119 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 8962 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 3120 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 8968 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 3121 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 8974 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 3122 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 8980 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 3123 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 8986 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 3124 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 8992 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 3125 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 8998 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 3126 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 9004 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 3127 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 9010 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 3128 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 9016 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 3129 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 9022 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 3130 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 9028 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 3131 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 9034 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 3132 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 9040 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 3133 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 9046 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 3134 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 9052 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 3135 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 9058 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 3136 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 9064 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 3137 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 9070 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 3138 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 9076 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 3139 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 9082 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 3140 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 9088 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 3141 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 9094 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 3142 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 9100 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 3146 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV4; }
#line 9106 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 3147 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV6; }
#line 9112 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 3148 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV4_MC; }
#line 9118 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 3149 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV6_MC; }
#line 9124 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 3150 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV4_MPLS; }
#line 9130 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 3151 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV6_MPLS; }
#line 9136 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 3152 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN4_MPLS; }
#line 9142 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 3153 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN6_MPLS; }
#line 9148 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 3154 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN4_MC; }
#line 9154 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 3155 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN6_MC; }
#line 9160 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 3156 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_FLOW4; }
#line 9166 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 3157 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_FLOW6; }
#line 9172 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 3161 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[0].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[0].i32);
    BGP_CC->desc = desc;
    BGP_CC->gr_able = 0xff;	/* undefined */
  }
}
#line 9196 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 3183 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->next_hop_addr = (yyvsp[0].a); }
#line 9202 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3184 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->next_hop_self = 1; BGP_CC->next_hop_keep = 0; }
#line 9208 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3185 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->next_hop_keep = 1; BGP_CC->next_hop_self = 0; }
#line 9214 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3186 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->missing_lladdr = MLL_SELF; }
#line 9220 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3187 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->missing_lladdr = MLL_DROP; }
#line 9226 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3188 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->missing_lladdr = MLL_IGNORE; }
#line 9232 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3189 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->gw_mode = GW_DIRECT; }
#line 9238 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3190 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->gw_mode = GW_RECURSIVE; }
#line 9244 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3191 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->secondary = (yyvsp[0].i); }
#line 9250 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3192 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->gr_able = (yyvsp[0].i); }
#line 9256 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3193 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->ext_next_hop = (yyvsp[0].i); }
#line 9262 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3194 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->add_path = BGP_ADD_PATH_RX; }
#line 9268 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3195 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->add_path = BGP_ADD_PATH_TX; }
#line 9274 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3196 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { BGP_CC->add_path = (yyvsp[0].i) ? BGP_ADD_PATH_FULL : 0; }
#line 9280 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3197 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[0].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[0].r);
    else if ((yyvsp[0].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[0].r);
    else
      cf_error("Mismatched IGP table type");
   }
#line 9296 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3221 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 9307 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3240 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 9313 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3241 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 9319 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3242 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 9325 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3246 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[0].i);
  OSPF_CFG->af_ext = !(yyvsp[0].i);
}
#line 9341 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3264 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 9347 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3265 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 9353 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3270 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[-1].i)], (yyvsp[-1].i), this_proto);

  /* Save the multicast flag */
  if (this_channel == proto_cf_main_channel(this_proto))
    OSPF_CFG->af_mc = (yyvsp[0].i);
}
#line 9366 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3283 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 9372 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3284 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 9378 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3285 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->af_ext = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); }
#line 9384 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3286 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 9390 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3287 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 9396 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3288 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 9402 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3289 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 9408 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3290 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i) <= 0) cf_error("Tick must be greater than zero"); }
#line 9414 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3291 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 9420 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3295 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 9438 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3310 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 9444 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3319 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 9450 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3320 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 9456 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3321 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 9462 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3322 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 9468 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3323 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 9474 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3324 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 9480 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3325 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 9486 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3326 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 9492 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3327 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 9498 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3328 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 9504 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3329 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 9510 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3341 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[0].net);
     this_stubnet->cost = COST_D;
   }
#line 9521 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3355 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 9527 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3356 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 9533 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3357 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 9539 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3361 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 9545 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3362 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 9551 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3371 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 9557 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3372 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 9563 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3373 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 9569 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3374 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 9575 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3375 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 9581 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3376 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 9587 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3377 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 9593 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3378 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 9599 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3379 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 9605 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3380 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 9611 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3384 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 9631 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3402 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 9637 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3403 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 9643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3404 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 9649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3405 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 9655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3406 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 9661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3407 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 9667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3408 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 9673 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3409 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 9679 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3410 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 9685 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3411 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 9691 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3412 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 9697 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3413 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 9703 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3414 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 9709 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3415 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 9715 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3416 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 9721 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3417 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 9727 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3418 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 9733 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3419 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 9739 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3420 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if ((yyvsp[0].i)>255) cf_error("Priority must be in range 0-255"); }
#line 9745 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3421 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 9751 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3422 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 9757 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3423 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 9763 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3424 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 9769 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3425 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 9775 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3427 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 9781 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3428 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 9787 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3429 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 9793 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3430 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 9799 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3431 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 9805 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3432 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 9811 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3433 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 9817 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3434 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 9823 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3435 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 9829 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3436 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 9835 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3437 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 9841 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3438 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 9847 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3439 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 9853 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3450 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[0].net);
 }
#line 9863 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3459 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 9869 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3460 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 9875 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3469 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 9881 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3470 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 9887 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3474 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 9898 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3483 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 9922 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3506 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 9928 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3510 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 9934 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3524 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 9940 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3530 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 9946 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3533 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 9952 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3536 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 9958 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3541 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 9964 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3544 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 9970 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3549 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 9976 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3552 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 9982 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3556 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 9988 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3559 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 9996 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3562 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 10002 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3563 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 10008 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3564 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 10014 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3565 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 10020 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3566 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 10026 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3567 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 10032 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3568 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 10038 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3569 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 10044 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3576 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
}
#line 10052 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3580 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
}
#line 10065 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3593 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->peer = (yyvsp[-1].r); }
#line 10071 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3600 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 10084 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3613 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 10090 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3614 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 10096 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3614 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 10102 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3615 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 10108 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 915:
#line 3615 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 10114 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 916:
#line 3616 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_CFG->trigger = (yyvsp[0].net); }
#line 10120 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 3617 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 10126 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3630 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 10152 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3653 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 10158 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3654 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 10164 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3655 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 10170 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3656 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 10176 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3657 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 10182 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3658 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); }
#line 10188 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3659 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if ((yyvsp[0].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); }
#line 10194 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3660 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); }
#line 10200 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3661 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if ((yyvsp[0].i) > 255) cf_error("Current hop limit must be in range 0-255"); }
#line 10206 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3662 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 10216 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3667 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 10225 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3671 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 10231 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3672 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 10237 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3673 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 10243 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3674 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 10249 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 3675 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 10255 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 3676 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 10261 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 939:
#line 3676 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 10267 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 940:
#line 3677 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 10273 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 3677 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 10279 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 942:
#line 3678 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 10285 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 943:
#line 3679 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 10291 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 3683 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 10297 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3684 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 10303 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3685 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 10309 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3688 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 10350 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 3741 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[0].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 10364 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 954:
#line 3752 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 10370 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 3753 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 10376 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 3754 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 10382 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 957:
#line 3755 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 10391 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 958:
#line 3759 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 10400 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 959:
#line 3766 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 10412 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 965:
#line 3790 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 10424 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 966:
#line 3799 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 10433 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 3806 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 10439 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 970:
#line 3810 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 10455 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 975:
#line 3834 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 10470 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 976:
#line 3846 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 10479 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 979:
#line 3853 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 10485 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 980:
#line 3857 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 10501 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 985:
#line 3881 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 10507 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 986:
#line 3882 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 10513 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 987:
#line 3886 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (uint) -1; }
#line 10519 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 988:
#line 3887 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 10525 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 989:
#line 3895 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 10531 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 990:
#line 3896 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 10537 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 991:
#line 3900 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[0].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
}
#line 10553 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 994:
#line 3915 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 10559 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 995:
#line 3916 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 10565 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 996:
#line 3917 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 10571 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 3931 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 10598 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 3955 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 10631 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 3985 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 10637 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 3986 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 10643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 3987 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 10649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 3988 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 10655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 3989 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); if (ipa_is_ip4((yyvsp[0].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); }
#line 10661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 3990 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 3991 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 10676 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 3995 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 10682 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 3996 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 10688 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 3997 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 10694 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 3998 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 10700 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 3999 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 10706 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 4000 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 10712 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 4001 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 10718 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 4002 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 10724 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 4003 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 10730 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 4004 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 10736 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 4005 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 10742 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 4006 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 10748 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 4007 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 10754 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 4008 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 10760 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 4009 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 10766 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 4010 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 10772 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 4011 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 10778 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 4012 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 10784 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 4016 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 10790 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 4017 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 10796 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 4018 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 10802 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 4019 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 10808 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 4040 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 10814 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 4043 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 10820 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 4050 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
  init_list(&STATIC_CFG->routes);
}
#line 10829 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 4058 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[-1].cc)->net_type; }
#line 10835 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 4059 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 10841 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 4060 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    if ((yyvsp[-1].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[-1].r);
    else if ((yyvsp[-1].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[-1].r);
    else
      cf_error("Incompatible IGP table type");
   }
#line 10854 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 4068 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 10860 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 4072 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[-1].a);
      this_snh->iface = (yyvsp[0].iface);
    }
#line 10870 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 4077 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 10880 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 4082 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    this_snh->mls = (yyvsp[0].mls);
  }
#line 10888 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 4085 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    this_snh->onlink = (yyvsp[0].i);
  }
#line 10896 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 4088 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    this_snh->weight = (yyvsp[0].i) - 1;
    if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256");
  }
#line 10905 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 4092 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    this_snh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
  }
#line 10913 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 4102 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[0].net_ptr);
     this_srt_last_cmd = &(this_srt->cmds);
     this_srt->mp_next = NULL;
     this_snh = NULL;
  }
#line 10926 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 4114 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 10935 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 4118 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[-2].a);
      this_srt->mls = (yyvsp[0].mls);
   }
#line 10945 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 4123 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_NONE; }
#line 10951 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 4124 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 10957 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 4125 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 10963 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 4126 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 10969 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 4127 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 10975 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 4128 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 10981 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 4132 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 10987 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 4147 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 10993 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 4153 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 10999 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 4154 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 11005 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 4165 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 11016 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 4174 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 11022 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 4175 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 11028 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 4179 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 11038 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 4184 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 11044 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 4185 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 11050 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 4189 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 11056 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 4190 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 11062 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 4194 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 11068 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 4195 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 11074 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 4199 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 11080 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 4200 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 11086 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 4201 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 11092 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 4202 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 11098 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 4203 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 11104 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 4204 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 11110 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 4205 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 11116 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 4206 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 11122 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 4207 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 11128 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 4213 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 11134 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 4214 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 11144 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 4224 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 11150 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 4225 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].time); }
#line 11156 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 4226 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].time); }
#line 11162 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 4227 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].time) + 999999) TO_S; }
#line 11168 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 4236 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 11174 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 4239 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 11180 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 4246 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 11186 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 4249 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 11192 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 4252 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 11198 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 4255 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 11204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 4258 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 11210 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 4263 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 11216 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 4264 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 11222 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 4265 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 11228 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 4273 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = krt_init_config((yyvsp[-1].i));
}
#line 11236 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 4280 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 11242 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 4281 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 11248 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 4286 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11254 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 4287 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 11260 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 4288 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i) S_;
   }
#line 11269 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 4292 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 11281 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 4299 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 11287 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 4300 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 11299 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 4312 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 11305 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 4319 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i) S_;
   }
#line 11314 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 4326 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
}
#line 11324 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 4333 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { kif_set_preferred((yyvsp[0].a)); }
#line 11330 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 4355 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { proto_postconfig(); }
#line 11336 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 4356 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 11342 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 4357 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 11348 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 4357 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
#line 11354 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 4358 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 11360 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 4359 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 11366 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 4360 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 11372 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 4361 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 11378 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 4362 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 11384 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 4363 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 11390 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 4364 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 11396 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 4365 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 11402 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 4366 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 11408 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 4367 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 11414 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 4368 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 11420 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 11426 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 11432 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 11438 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 11444 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 11450 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 11456 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 11462 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 11468 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 11474 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 11480 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 11486 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 11492 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 11498 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 11504 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 11510 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 11516 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 11522 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 11528 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 11534 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 11540 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 11546 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 11552 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 11558 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 11564 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 11570 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 11576 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 11582 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 11588 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 11594 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 11600 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 11606 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 11612 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 11618 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 11624 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 11630 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 11636 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 11642 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 11648 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 4369 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 11654 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 4370 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 11660 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 4370 "obj/conf/cf-parse.y" /* yacc.c:1646  */
    { this_channel = NULL; }
#line 11666 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 11670 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4375 "obj/conf/cf-parse.y" /* yacc.c:1906  */

/* C Code from conf/confbase.Y */

/* C Code from conf/flowspec.Y */

/* C Code from nest/config.Y */

/* C Code from proto/bfd/config.Y */

/* C Code from proto/babel/config.Y */

/* C Code from proto/bgp/config.Y */

/* C Code from proto/ospf/config.Y */

/* C Code from proto/pipe/config.Y */

/* C Code from proto/radv/config.Y */

/* C Code from proto/rip/config.Y */

/* C Code from proto/static/config.Y */

/* C Code from sysdep/linux/netlink.Y */

/* C Code from sysdep/unix/config.Y */

/* C Code from sysdep/unix/krt.Y */

